﻿#target bridge
if (BridgeTalk.appName == 'bridge')

/*
Produced by Greg Reser and Sarah Saunders. Javascript by Greg Reser. 

Terms and Conditions of Use:
MIT License

Copyright © 2018 IPTC - International Press Telecommunications Council
25 Southampton Buildings, London WC2A 1AL, United Kingdom
www.iptc.org

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

var plgnVers = "1.0";
var codeVers = "2018-11-06";

{ // brace 1 open

//Create a menu option within Adobe Bridge
var findIPTC_CHMenu = MenuElement.find ('IPTCCulturalHeritage');
if (findIPTC_CHMenu == null){
	 var csuMenu = new MenuElement ('menu', "IPTC Cultural Heritage Metadata", 'before Help', 'IPTCCulturalHeritage');
	}
var iptcChExpImp = new MenuElement ('command', "Metadata Export-Import", 'at the beginning of IPTCCulturalHeritage');
iptcChExpImp.onSelect = function()

	{ // brace 2 open
     // Load the XMP Script library
     if( xmpLib == undefined ){
          if( Folder.fs == "Windows" ){
               var pathToXMPLib = Folder.startup.fsName + "/AdobeXMPScript.dll";
			}
          else{
               var pathToXMPLib = Folder.startup.fsName + "/AdobeXMPScript.framework";
			}
          var libfile = new File( pathToXMPLib );
          var xmpLib = new ExternalObject("lib:" + pathToXMPLib );
		}
	
	// Basic characters used throughout the code
	var projectName1 = "IPTC_CH"
	var projectName2 = "IPTC Cultural Heritage"
	var plgnName = ""+projectName2+" Metadata Export-Import";
	var appDataFwdSlash = Folder.userData;
	var plgnPrefs = "/"+projectName1+"_Import_Export";
	var plgnSet = "/settings.txt";
	var hardDriveCheck = hardDrive;
	var plgnOpt = "/Options";
	var exportChoice = "folder";
	// today's date
	var dateTime = new XMPDateTime(new Date()); // now
	var dateYMD = dateTime.toString().slice(0, -19)
	var un = undefined;
	//	var currentField = {}

// ► ► ▼ ▲ ◀ ◄ → ← ↪ ↩ ⠇⡆⡇⣿⠿ ◦ ◉ ○ ◌ □ 
  var arrowLeft = "←"
  var arrowRight = "→"
	//Tool tips
	var clickInstrucTT = "Click for instructions";
        
	var imageFolderPath = "Folder containing image files"
	var imageFolderBrowse = "Locate the path to your folder of images.";
	
	var textFilePath = ".txt file of metadata to be imported"
	var textFileBrowse = "Locate the path to your .txt file";
	
	var dateWhyTT = 
	"This is useful if you will be importing the metadata to Excel.\n\n" +
	"XMP Date values must use the YYYY/MM/DD format.  Adding a '_' character at the beginning of the Date will prevent Excel from automatically changing it to a format XMP cannot understand.\n\n" +
	"The '_' character will be removed when you import the data back into the image file(s)."
			   
	var lineFeedWhyTT = 
	"This is useful if you will be importing the metadata to Excel.\n\n" +
	"When selected, line breaks (line feed and carriage return) will be replaced by a semi-colon and a space ('; ').\n\n"+
	"When not selected, line breaks will be retained but converted to plain text place holders ('LF'), ('CR') so that they are not changed by Excel.  When the data is imported back to an image, the codes will be changed to the proper XMP encoding."	
	
	var replaceDataTT = 
	"Completely replaces any existing metadata\n" +
	"in the image file(s) with the metadata in the\n"+
    "tab-delimited import file.\n" +
	"   • Overwrites all fields except camera and\n"+
    "      software fields."
		  
	var appendDataTT = 
	"Applies the tab-delimited import metadata\n"+
    "where no metadata value or property currently\n" +
	"exists in the file.\n" +
	"   • Does not overwrite existing data.\n" +
	"   • Data will only be imported to blank fields."
	
	var createTemplateTT = 
	"Creates a text file which, when opened in Excel, contains the proper column field names for the "+projectName1+" import function.\nYou can then paste your own data in the appropriate columns for import.";
	
	var IgnoreExtCbTT = 
	"When selected, metadata will be imported to all matching media with matching file names regardless of the file extension.\n" +
	"This allows you to import matching metadata to all versions of the same media file, e.g., .tif, .jpg. .png.";
	
    var createHeadlineTT = 
	"When selected, the IPTC Headline will be filled with the data values from "+projectName1+" fields:\n" +
	"Artwork/Object Title; Image view";
    
	var createKeywordsTT = 
	"When selected, IPTC Keywords will be filled with the data values from "+projectName1+" Artwork/Object fields:\n" +
	"Subject; Style/Period; Culture; Work Type; Technique; Site";
	
	var createDescriptionTT = 
	"When selected, the IPTC Description/Caption will be filled with the data values from "+projectName1+" Artwork/Object fields:\n" +
	"Creator; Title, View; Date; Work Type; Materials; Measurements; Repository; Location; Rights";
	
	var addLabelTT = 
	"When selected, each image that has metadata successfully imported will have its label set to: '"+projectName1+" metadata imported' and the label color will be changed to white.\n" +
	"Warning: Existing labels will be lost.";
    
    var useDefaultBtnTT = 
    "Click to use the default header in your custom list";

     // If the current file system is Windows, create directory location variables
     if (Folder.fs == 'Windows'){
		var spot = "•";
		var hardDrive = "C:\\";
		var appDataPlgnSetBkSlash = Folder (File.decode (Folder.userData)).toString().split ("/").join ("\\"); // User preferences file	
		}
     // If the current file system is Mac, create directory location variables
     else{
          var spot = "•";
      //    var userData = "//";
          var hardDrive = "//";
          var appDataPlgnSetBkSlash = Folder (File.decode (Folder.userData)).toString();
          while (appDataPlgnSetBkSlash.split ("/.").length > 1) var appDataPlgnSetBkSlash = appDataPlgnSetBkSlash.split ("/.").join ("/");
          while (appDataPlgnSetBkSlash.split ("./").length > 1) var appDataPlgnSetBkSlash = appDataPlgnSetBkSlash.split ("./").join ("/");
          var pathFirstChar = "/";
          if (appDataPlgnSetBkSlash.substring (0,1) == "~") var pathFirstChar = "~";
          var appDataPlgnSetBkSlash = appDataPlgnSetBkSlash.split ("~").join ("");
          while (appDataPlgnSetBkSlash.split ("//").length > 1) var appDataPlgnSetBkSlash = appDataPlgnSetBkSlash.split ("//").join ("/");
		}
   
    // default location for export text file
    if (Folder.fs == "Windows"){
        var desktopSaveFile = "~\\Desktop\\IPTC_CH_metadata_"+dateYMD+".txt";
        }
    else{
        var desktopSaveFile = "~/Desktop/IPTC_CH_metadata_"+dateYMD+".txt";
        }
    // desktop
    if (Folder.fs == "Windows"){
		var desktop = "~\\Desktop\\";
		}
	else{
		var desktop = "~/Desktop/";
		}
    var mode = "export"
	 // preferredSize for UI objects
     var hidden = [0,0]
     var panelSize = [700,600]
 // preferredSize for UI objects
     if (Folder.fs == "Windows"){
      var editMSml = [160,20];
	var buttonSize1 = [20,20];
	var buttonSize2 = [40,40];
	var buttonSize3 = [80,20]
	var buttonSize4 = [160,30]
  var textSize1 = [600,20]
    var headerListSpacing = 1
    var headerUseBtnSpacing = 1
	}
else{
    var editMSml = [180,20];
	var buttonSize1 = [34,34];
	var buttonSize2 = [60,60];
	var buttonSize3 = [100,34]
	var buttonSize4 = [180,40]
  var textSize1 = [600,20]
    var headerListSpacing = 2
    var headerUseBtnSpacing = 0
	}

	var exportImageFolderOK = false;
	var exportTextFolderOK = false;
	var exportTextFileOK = false;
	
	var importImageFolderOK = false;
	var importTextFolderOK = false;
	var importTextFileOK = false;
          
     // if it doesn't already exist, create folder: C:\Users\[user name]\AppData\Roaming\IPTC_CH_Import_Export\Options
     if (Folder (appDataFwdSlash + plgnPrefs).exists == false){
          new Folder (appDataFwdSlash + plgnPrefs).create();
          //removed code here that writes 'appDataFwdSlash' to desktop if writing to appDataFwdSlash failed
		}
    // Namespaces	 
    var NS_IPTC_EXT = "http://iptc.org/std/Iptc4xmpExt/2008-02-29/";
        XMPMeta.registerNamespace (NS_IPTC_EXT, "Iptc4xmpExt"); 
    var NS_PLUS = "http://ns.useplus.org/ldf/xmp/1.0/";
        XMPMeta.registerNamespace (NS_PLUS, "plus");
        var plusPrefix = XMPMeta.getNamespacePrefix (NS_PLUS);
    var plusCRownerName = "CopyrightOwner[1]/"+plusPrefix+"CopyrightOwnerName"
    var NS_W3 = "http://www.w3.org/XML/1998/namespace";
        XMPMeta.registerNamespace (NS_W3, "xml");   
	
    // if it doesn't already exist, create folder 'userData/"+projectName1+"_Import_Export/Options'
     if (Folder (appDataFwdSlash + plgnPrefs + plgnOpt).exists == false) new Folder (appDataFwdSlash + plgnPrefs + plgnOpt).create();
     
 /*   var xmpStructsDict = [{namespace:NS_IPTC_EXT, path:'ArtworkOrObject', type:XMPConst.ARRAY_IS_UNORDERED},{namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOCreator', type:XMPConst.ARRAY_IS_UNORDERED},{namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOCreatorId', type:XMPConst.ARRAY_IS_UNORDERED},{namespace:NS_IPTC_EXT, path:'RegistryId', type:XMPConst.ARRAY_IS_UNORDERED},{namespace:NS_PLUS, path:'CopyrightOwner', type:XMPConst.ARRAY_IS_UNORDERED},{namespace:NS_PLUS, path:'Licensor', type:XMPConst.ARRAY_IS_UNORDERED},{namespace:NS_PLUS, path:'ImageSupplier', type:XMPConst.ARRAY_IS_UNORDERED}]
    */
var complexStruct = 
[
	{namespace:NS_IPTC_EXT, path:'ArtworkOrObject', arrType:XMPConst.ARRAY_IS_UNORDERED, 
		subArr:[
			{namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOCreator', arrType:XMPConst.ARRAY_IS_UNORDERED},
			{namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOCreatorId', arrType:XMPConst.ARRAY_IS_UNORDERED}]},
	{namespace:NS_IPTC_EXT, path:'RegistryId', arrType:XMPConst.ARRAY_IS_UNORDERED,
		subArr:[]},
	{namespace:NS_PLUS, path:'CopyrightOwner', arrType:XMPConst.ARRAY_IS_UNORDERED,
		subArr:[],
        structProp:[{namespace:NS_PLUS, path:'CopyrightOwner[1]/'+plusPrefix+'CopyrightOwnerName'},
        {namespace:NS_PLUS, path:'CopyrightOwner[1]/'+plusPrefix+'CopyrightOwnerID'}]},
	{namespace:NS_PLUS, path:'Licensor', arrType:XMPConst.ARRAY_IS_UNORDERED,
		subArr:[],
        structProp:[{namespace:NS_PLUS, path:'Licensor[1]/'+plusPrefix+'LicensorName'},
        {namespace:NS_PLUS, path:'Licensor[1]/'+plusPrefix+'LicensorID'},
        {namespace:NS_PLUS, path:'Licensor[1]/'+plusPrefix+'LicensorTelephone1'},
        {namespace:NS_PLUS, path:'Licensor[1]/'+plusPrefix+'LicensorTelephone2'},
        {namespace:NS_PLUS, path:'Licensor[1]/'+plusPrefix+'LicensorEmail'},
        {namespace:NS_PLUS, path:'Licensor[1]/'+plusPrefix+'LicensorURL'}]},
	{namespace:NS_PLUS, path:'ImageSupplier', arrType:XMPConst.ARRAY_IS_UNORDERED,
		subArr:[],
        structProp:[{namespace:NS_PLUS, path:'ImageSupplier[1]/'+plusPrefix+'ImageSupplierName'},
        {namespace:NS_PLUS, path:'ImageSupplier[1]/'+plusPrefix+'ImageSupplierID'}]}
]
                 
     // complex object for header, customHeader, namespace and path
     var fieldsDict = [{header:'File Name (required)', customHeader:'', type:'system', namespace:'', path:''}, {header:'File Path (optional)', customHeader:'', type:'system', namespace:'', path:''}, {header:'A/O:Title', customHeader:'', type:'langAlt', namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOTitle'}, {header:'A/O:Creator 1 Name', customHeader:'', type:'complexStruct', namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOCreator[1]'}, {header:'A/O:Creator 1 ID', customHeader:'', type:'complexStruct', namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOCreatorId[1]'}, {header:'A/O:Creator 2 Name', customHeader:'', type:'complexStruct', namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOCreator[2]'}, {header:'A/O:Creator 2 ID', customHeader:'', type:'complexStruct', namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOCreatorId[2]'}, {header:'A/O:Creator 3 Name', customHeader:'', type:'complexStruct', namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOCreator[3]'}, {header:'A/O:Creator 3 ID', customHeader:'', type:'complexStruct', namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOCreatorId[3]'}, {header:'A/O:Date Created', customHeader:'', type:'date', namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AODateCreated'}, {header:'A/O:Circa Date Created', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOCircaDateCreated'}, {header:'A/O:Style/Period', customHeader:'', type:'bag', namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOStylePeriod'}, {header:'A/O:Contribution Description', customHeader:'', type:'langAlt', namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOContributionDescription'}, {header:'A/O:Physical Description', customHeader:'', type:'langAlt', namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOPhysicalDescription'}, {header:'A/O:Source Name', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOSource'}, {header:'A/O:Source Inventory Number', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOSourceInvNo'}, {header:'A/O:Source Inventory URL', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOSourceInvURL'}, {header:'A/O:Content Description', customHeader:'', type:'langAlt', namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOContentDescription'}, {header:'A/O:Copyright Notice', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOCopyrightNotice'}, {header:'A/O:Current Copyright Owner Name', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOCurrentCopyrightOwnerName'}, {header:'A/O:Current Copyright Owner ID', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOCurrentCopyrightOwnerId'}, {header:'A/O:Current Licensor Name', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOCurrentLicensorName'}, {header:'A/O:Current Licensor ID', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'ArtworkOrObject[1]/Iptc4xmpExt:AOCurrentLicensorId'}, {header:'Image:Title', customHeader:'', type:'langAltDcTitle', namespace:XMPConst.NS_DC, path:'title'}, {header:'Image:Creator', customHeader:'', type:'seq', namespace:XMPConst.NS_DC, path:'creator'}, {header:'Image:Creators Job Title', customHeader:'', type:'text', namespace:XMPConst.NS_PHOTOSHOP, path:'AuthorsPosition'}, {header:'Image:Date Created', customHeader:'', type:'date', namespace:XMPConst.NS_PHOTOSHOP, path:'DateCreated'}, {header:'Image:Core Loc Sublocation', customHeader:'', type:'text', namespace:XMPConst.NS_IPTC_CORE, path:'Location'}, {header:'Image:Core Loc City', customHeader:'', type:'text', namespace:XMPConst.NS_PHOTOSHOP, path:'City'}, {header:'Image:Core Loc State/Province', customHeader:'', type:'text', namespace:XMPConst.NS_PHOTOSHOP, path:'State'}, {header:'Image:Core Loc Country Name', customHeader:'', type:'text', namespace:XMPConst.NS_PHOTOSHOP, path:'Country'}, {header:'Image:Core Loc Country Code', customHeader:'', type:'text', namespace:XMPConst.NS_IPTC_CORE, path:'CountryCode'}, {header:'Image:Camera Loc Sublocation', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'LocationCreated[1]/Iptc4xmpExt:Sublocation'}, {header:'Image:Camera Loc City', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'LocationCreated[1]/Iptc4xmpExt:City'}, {header:'Image:Camera Loc State/Province', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'LocationCreated[1]/Iptc4xmpExt:ProvinceState'}, {header:'Image:Camera Loc Country Name', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'LocationCreated[1]/Iptc4xmpExt:CountryName'}, {header:'Image:Camera Loc Country Code', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'LocationCreated[1]/Iptc4xmpExt:CountryCode'}, {header:'Image:Camera Loc World Region', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'LocationCreated[1]/Iptc4xmpExt:WorldRegion'}, {header:'Image:Shown Loc Sublocation', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'LocationShown[1]/Iptc4xmpExt:Sublocation'}, {header:'Image:Shown Loc City', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'LocationShown[1]/Iptc4xmpExt:City'}, {header:'Image:Shown Loc State/Province', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'LocationShown[1]/Iptc4xmpExt:ProvinceState'}, {header:'Image:Shown Loc Country Name', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'LocationShown[1]/Iptc4xmpExt:CountryName'}, {header:'Image:Shown Loc Country Code', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'LocationShown[1]/Iptc4xmpExt:CountryCode'}, {header:'Image:Shown Loc World Region', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'LocationShown[1]/Iptc4xmpExt:WorldRegion'}, {header:'Image:Headline', customHeader:'', type:'text', namespace:XMPConst.NS_PHOTOSHOP, path:'Headline'}, {header:'Image:Description', customHeader:'', type:'langAltDcDescription', namespace:XMPConst.NS_DC, path:'description'}, {header:'Image:Keywords', customHeader:'', type:'bagDcSubject', namespace:XMPConst.NS_DC, path:'subject'}, {header:'Image:Credit Line', customHeader:'', type:'text', namespace:XMPConst.NS_PHOTOSHOP, path:'Credit'}, {header:'Image:Copyright Owner:Name', customHeader:'', type:'text', namespace:NS_PLUS, path:'CopyrightOwner[1]/'+plusPrefix+'CopyrightOwnerName'}, {header:'Image:Copyright Owner:ID', customHeader:'', type:'text', namespace:NS_PLUS, path:'CopyrightOwner[1]/'+plusPrefix+'CopyrightOwnerID'}, {header:'Image:Copyright Notice', customHeader:'', type:'langAlt', namespace:XMPConst.NS_DC, path:'rights'}, {header:'Image:Rights Usage Terms', customHeader:'', type:'langAlt', namespace:XMPConst.NS_XMP_RIGHTS, path:'UsageTerms'}, {header:'Image Licensor:Name', customHeader:'', type:'text', namespace:NS_PLUS, path:'Licensor[1]/'+plusPrefix+'LicensorName'}, {header:'Image Licensor:ID', customHeader:'', type:'text', namespace:NS_PLUS, path:'Licensor[1]/'+plusPrefix+'LicensorID'}, {header:'Image Licensor:Telphone 1', customHeader:'', type:'text', namespace:NS_PLUS, path:'Licensor[1]/'+plusPrefix+'LicensorTelephone1'}, {header:'Image Licensor:Telephone 2', customHeader:'', type:'text', namespace:NS_PLUS, path:'Licensor[1]/'+plusPrefix+'LicensorTelephone2'}, {header:'Image Licensor:Email', customHeader:'', type:'text', namespace:NS_PLUS, path:'Licensor[1]/'+plusPrefix+'LicensorEmail'}, {header:'Image Licensor:Web Address', customHeader:'', type:'text', namespace:NS_PLUS, path:'Licensor[1]/'+plusPrefix+'LicensorURL'}, {header:'Image Property Release:Status', customHeader:'', type:'text', namespace:NS_PLUS, path:'PropertyReleaseStatus'}, {header:'Image Property Release:ID', customHeader:'', type:'bag', namespace:NS_PLUS, path:'PropertyReleaseID'}, {header:'Image:Instructions', customHeader:'', type:'text', namespace:XMPConst.NS_PHOTOSHOP, path:'Instructions'}, {header:'Image:Digital Source Type', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'DigitalSourceType'}, {header:'Image:Maximum Width', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'MaxAvailWidth'}, {header:'Image:Maximum Height', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'MaxAvailHeight'}, {header:'Image Supplier:Name', customHeader:'', type:'text', namespace:NS_PLUS, path:'ImageSupplier[1]/'+plusPrefix+'ImageSupplierName'}, {header:'Image Supplier:Supplier ID', customHeader:'', type:'text', namespace:NS_PLUS, path:'ImageSupplier[1]/'+plusPrefix+'ImageSupplierID'}, {header:'Image Supplier:Image ID', customHeader:'', type:'text', namespace:NS_PLUS, path:'ImageSupplierImageID'}, {header:'Image Registry Entry:Organization ID', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'RegistryId[1]/Iptc4xmpExt:RegOrgId'}, {header:'Image Registry Entry:Image ID', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'RegistryId[1]/Iptc4xmpExt:RegItemId'}, {header:'Image:Max Width', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'MaxAvailWidth'}, {header:'Image:Max Height', customHeader:'', type:'text', namespace:NS_IPTC_EXT, path:'MaxAvailHeight'}, {header:'Date File Created', customHeader:'', type:'file', namespace:'', path:''}, {header:'Date File Modified', customHeader:'', type:'file', namespace:'', path:''}, {header:'Format', customHeader:'', type:'file', namespace:XMPConst.NS_DC, path:'format'}, {header:'File Size', customHeader:'', type:'file', namespace:'', path:''}, {header:'Image Width (pixels)', customHeader:'', type:'file', namespace:XMPConst.NS_EXIF, path:'PixelXDimension'}, {header:'Image Height (pixels)', customHeader:'', type:'file', namespace:XMPConst.NS_EXIF, path:'PixelYDimension'}, {header:'Bit Depth', customHeader:'', type:'file', namespace:XMPConst.NS_TIFF, path:'BitsPerSample[1]'}, {header:'Compression', customHeader:'', type:'file', namespace:XMPConst.NS_TIFF, path:'Compression'}, {header:'Resolution', customHeader:'', type:'file', namespace:XMPConst.NS_TIFF, path:'XResolution'}, {header:'Make', customHeader:'', type:'file', namespace:XMPConst.NS_TIFF, path:'Make'}, {header:'Model', customHeader:'', type:'file', namespace:XMPConst.NS_TIFF, path:'Model'}, {header:'Software', customHeader:'', type:'file', namespace:XMPConst.NS_TIFF, path:'Software'}, {header:'Color Mode', customHeader:'', type:'file', namespace:XMPConst.NS_PHOTOSHOP, path:'ColorMode'}, {header:'Color Profile', customHeader:'', type:'file', namespace:XMPConst.NS_PHOTOSHOP, path:'ICCProfile'}, {header:'Color Space', customHeader:'', type:'file', namespace:XMPConst.NS_EXIF, path:'ColorSpace'}];
 
	 // array for custom headers - populated from user prefs or on Headers window "Save"
var customHeadersArray = [];

     // Default column headers array
    var columnHeaders = ['File Name (required)','File Path (optional)','A/O:Title','A/O:Creator 1 Name','A/O:Creator 1 ID','A/O:Creator 2 Name','A/O:Creator 2 ID','A/O:Creator 3 Name','A/O:Creator 3 ID','A/O:Date Created','A/O:Circa Date Created','A/O:Style/Period','A/O:Contribution Description','A/O:Physical Description','A/O:Source Name','A/O:Source Inventory Number','A/O:Source Inventory URL','A/O:Content Description','A/O:Copyright Notice','A/O:Current Copyright Owner Name','A/O:Current Copyright Owner ID','A/O:Current Licensor Name','A/O:Current Licensor ID','Image:Title','Image:Creator','Image:Creators Job Title','Image:Date Created','Image:Core Loc Sublocation','Image:Core Loc City','Image:Core Loc State/Province','Image:Core Loc Country Name','Image:Core Loc Country Code','Image:Camera Loc Sublocation','Image:Camera Loc City','Image:Camera Loc State/Province','Image:Camera Loc Country Name','Image:Camera Loc Country Code','Image:Camera Loc World Region','Image:Shown Loc Sublocation','Image:Shown Loc City','Image:Shown Loc State/Province','Image:Shown Loc Country Name','Image:Shown Loc Country Code','Image:Shown Loc World Region','Image:Headline','Image:Description','Image:Keywords','Image:Credit Line','Image:Copyright Owner:Name','Image:Copyright Owner:ID','Image:Copyright Notice','Image:Rights Usage Terms','Image Licensor:Name','Image Licensor:ID','Image Licensor:Telphone 1','Image Licensor:Telephone 2','Image Licensor:Email','Image Licensor:Web Address','Image Property Release:Status','Image Property Release:ID','Image:Instructions','Image:Digital Source Type','Image:Maximum Width','Image:Maximum Height','Image Supplier:Name','Image Supplier:Supplier ID','Image Supplier:Image ID','Image Registry Entry:Organization ID','Image Registry Entry:Image ID','Image:Max Width','Image:Max Height','Date File Created','Date File Modified','Format','File Size','Image Width (pixels)','Image Height (pixels)','Bit Depth','Compression','Resolution','Make','Model','Software','Color Mode','Color Profile','Color Space'];   
//////////////////////////////////////////////////////////////// BEGINNING OF MAIN UI WINDOW ////////////////////////////////////////////////////////////////
		// Create the main dialog box
		var mainWindow = new Window('palette', "IPTC_CH Export-Import - code version: "+plgnVers+" ("+codeVers+")");
		{ //  main UI window - brace 1 open
		// header
		header =  mainWindow.add( 'group' );
		header.orientation = 'row';
		header.alignment='left';
		title = header.add('statictext', undefined, "IPTC Cultural Heritage Metadata Export-Import Tool (compatible with custom info panel "+plgnVers+")");
		title.alignment = 'left';
        title.preferredSize = [720, 20]
	
settingsGroup = mainWindow.add('group', un, un)
settingsGroup.minimumSize = [0,0];
settingsGroup.maximumSize = [0,0];
	setHeaders = settingsGroup.add('button', undefined, "Using Default Field Names")
	setHeaders.preferredSize = [0,0];
	setHeaders.onClick = setHeadersFunc 
  
navGroup = mainWindow.add('group', un, un)
	navExportBtn = navGroup.add('radiobutton', undefined, arrowLeft+"EXPORT"+arrowRight)
	navExportBtn.preferredSize = [150,20];
    navExportBtn.value = true
  navExportBtn.onClick = function(){mode = "export"; toggleNav();}
   // navSpcr1 = navGroup.add('statictext', undefined, "")
   // navSpcr1.preferredSize = [100,40];
	navImportBtn = navGroup.add('radiobutton', undefined, "import")
	navImportBtn.preferredSize = [150,20];
	navImportBtn.onClick = function(){mode = "import"; toggleNav();}
	
		mainWindow.row = mainWindow.add( 'group' );
		mainWindow.row.orientation = 'row';
		mainWindow.row.spacing = 0;
	  
		// Export section
    exportPanel = mainWindow.row.add('panel', undefined, "Export Metadata");
    exportPanel.margins = 3;
    exportPanel.alignment = 'top';
    exportPanel.alignChildren = 'center';
 //   exportPanel.minimumSize = panelSize
 //   exportPanel.maximumSize = panelSize

		// Export Instructions button
		exportInstButton = exportPanel.add('button', undefined, "?");
		exportInstButton.alignment = 'right';
		exportInstButton.preferredSize = buttonSize1
		exportInstButton.helpTip = clickInstrucTT;
		exportInstButton.onClick = showExportInst;

		//  Select which files to export         
		var selections = app.document.selections;
		var folder  = app.document.visibleThumbnails;

		exportWhich = exportPanel.add('panel', undefined, "Images");
		exportWhich.alignChildren = 'left';
		exportWhich.spacing = 2;
        exportWhich.margins = 5;

		// Spacer
		spacer1 = exportWhich.add( 'group' );
		spacer1.minimumSize = [100, 10]
		  var  exportWhichthumbsRbtext = "Selected thumbnail(s) in Bridge"
          exportWhich.thumbsRb = exportWhich.add('radiobutton', undefined, exportWhichthumbsRbtext);
          exportWhich.thumbsRb.onClick = function(){ 
              exportChoice = "thumbs";
              toggleExportWhich();
              }  
          
		exportWhich.folderRb = exportWhich.add('radiobutton', undefined, "Entire folder");
		exportWhich.folderRb.value = true;
		exportWhich.folderRb.onClick = function(){
			exportChoice = "folder";
			toggleExportWhich();
			} 
        exportWhich.spacer = exportWhich.add('group');
		exportWhich.spacer.preferredSize = [10, 10];
		
        exportWhich.subfoldersGr = exportWhich.add('group');
        exportWhich.subfoldersGr.orientation = 'row';
          exportWhich.subfoldersPath = exportWhich.subfoldersGr.add('statictext', undefined, "folder location:");
           exportWhich.subfoldersPath.preferredSize = [160,20]
		exportWhich.subfoldersCb = exportWhich.subfoldersGr.add('checkbox', undefined, "include subfolders");		

		exportWhich.folderGr = exportWhich.add('group');
		exportWhich.folderGr.orientation = 'row';
        exportWhich.folderGr.spacing = 2;

		exportWhich.folderEt = exportWhich.folderGr.add('edittext', undefined, "");
		exportWhich.folderEt.preferredSize = textSize1
		exportWhich.folderEt.helpTip = imageFolderPath;
		exportWhich.folderBrowse = exportWhich.folderGr.add('button', undefined, "Browse");
		exportWhich.folderBrowse.helpTip = imageFolderBrowse
		
		exportWhich.folderEt.Alert = exportWhich.add('statictext', undefined, "? Folder not found.  Keep looking.");
		exportWhich.folderEt.Alert.alignment = 'left';
		exportWhich.folderEt.Alert.indent = 20;
        exportWhich.folderEt.Alert.preferredSize = textSize1
		exportWhich.folderEt.Alert.visible = false;
          
           // opens file browser to pick the location of the script file before installation can begin
          exportWhich.folderBrowse.onClick =  function(){
         /*   if (!pluginSettingsArray[13]){
                var path = desktopSaveFile;
                }
            else{
                var path = pluginSettingsArray[13].split(" " ).join("%20")
                }
			folder = new Folder(path); */
			var folderPath = Folder.selectDialog("Select a folder of image files for export");
            
            // selected folder path is copied into exportWhich.folderEt.text 
            if (folderPath){
                exportWhich.folderEt.text = folderPath.toString().split ("%20").join (" ");
                testExportImagesFolder();
                exportWhich.folderEt.helpTip = exportWhich.folderEt.text+"\n\n"+imageFolderPath
                }			
			}
        
        // Panel for options
         exportOptionsGrp = exportPanel.add('group', un, un);
		
		exportOptions = exportOptionsGrp.add('panel', undefined, 'Options');
		exportOptions.alignChildren = 'left'; 
		exportOptions.spacing = 2;

		exportOptions.dates = exportOptions.add( 'group' );
		exportOptions.dates.orientation = 'row';
		exportOptions.datesCb = exportOptions.dates.add('checkbox', undefined, "prepend Image dates with '_'");
        exportOptions.datesCb.value = true;
		exportOptions.datesCb.minimumSize = [200, undefined];
	//	exportOptions.datesCb.helpTip = dateWhyTT;

		exportOptionsLf = exportOptions.add( 'group' );
		exportOptionsLf.orientation = 'row';
		exportOptionsLfCb = exportOptionsLf.add('checkbox', undefined, "Remove line breaks");
        exportOptionsLfCb.value = true;
		exportOptionsLfCb.minimumSize = [200, undefined];
	//	exportOptionsLfCb.helpTip = lineFeedWhyTT;

        // Export Options Instructions button
		exportOptionsButton = exportOptionsGrp.add('button', undefined, "?");
		exportOptionsButton.alignment = 'right';
		exportOptionsButton.preferredSize = buttonSize1
		exportOptionsButton.helpTip = clickInstrucTT;
		exportOptionsButton.onClick = showExportOptInst

		exportBtn = exportPanel.add('button', undefined, "Export");   
		exportBtn.preferredSize = [120, 35];
		exportBtn.enabled = false;
		exportBtn.onClick = exportToFile;

		// check to see if the folder of images specified exists
		function testExportImagesFolder(){
			var selectedFolder = Folder(exportWhich.folderEt.text.split(" ").join("%20"));			
			if (exportWhich.folderEt.text && selectedFolder.exists == false){
				exportImageFolderOK = false;
				exportWhich.folderEt.Alert.visible = true;
				}
			else if (exportWhich.folderEt.text && selectedFolder.exists == true){
				exportImageFolderOK = true;
				exportWhich.folderEt.Alert.visible = false;
				}
			toggleExportBtn();
			}

		function toggleExportBtn(){
			if (exportImageFolderOK == true){
				exportBtn.enabled = true;
				}
			else{
				 exportBtn.enabled = false;
				}
			}
        
		 // test to see if the paths entered by user exist
		exportWhich.folderEt.addEventListener('changing',function(){testExportImagesFolder()});
		
		// If user selects export to "Entire folder", show folder path box, otherwise hide it
		function toggleExportWhich(){
			if (exportChoice == "thumbs"){
				exportWhich.subfoldersGr.visible = false;
				exportWhich.folderGr.visible = false;
                  exportBtn.enabled = true;
				}
			else{
				exportWhich.subfoldersGr.visible = true;
				exportWhich.folderGr.visible = true;
                  toggleExportBtn;
				}
              }
		
		// info windows 
            function showHeaderInst(){
			var headerInst = new Window('palette', "Header Instructions"); 
			headerInst.body = headerInst.add('group');
			headerInst.body.orientation = 'column';
			headerInst.body.spacing = 0;
			   
            var text1 =
            "You have choices.\n\n" +
            "   • 'Default Field Names' will export all of the "+projectName1+" field names.\n" +
            "         • For import, header names must match the default template.\n" +
            "         • For import, header order does not matter.\n" +
            "         • For import, you do not need to include all columns.\n" +
            "         • Want to see the default template?\n"

            var text2 =			 
            "   • 'Custom Field Names' will export and import using all only the field names you choose.\n" +
            "         • You can use selected "+projectName1+" field names by clicking the '>' button.\n" +
            "         • You can enter your own field names next to the appropriate "+projectName1+" field names.\n" +
            "              • You are giving a new name to the field names, but the XMP data is still the same.\n" +
            "              • You are mapping the "+projectName1+" fields to your own fields.\n" +
            "              • Your custom field names will be remembered for next time.\n" +
            "         • For import, only the custom field names in your tab-delimited file will be imported.\n"
          
   
			headerInst.text1 = headerInst.body.add('statictext', undefined, text1, {multiline:true});
			if (Folder.fs == "Windows"){
				headerInst.text1.preferredSize = [540,100];
				}
			else{
				headerInst.text1.preferredSize = [620,130];
				}			
			headerInst.templateBtn = headerInst.body.add ('button', undefined, "Create "+projectName1+"_import_default template.txt");
			headerInst.templateBtn.helpTip = createTemplateTT;
			headerInst.templateBtn.alignment = 'left';
			headerInst.templateBtn.indent = 50;
            headerInst.templateBtn.preferredSize = [300,25]
			headerInst.templateBtn.onClick  = createTemplate; 
            headerInst.spacer = headerInst.body.add('statictext', undefined, "");
            headerInst.spacer.preferredSize = [1,40]
			headerInst.text2 = headerInst.body.add('statictext', undefined, text2, {multiline:true});
			if (Folder.fs == "Windows"){
				headerInst.text2.preferredSize = [540,120];
				}
			else{
				headerInst.text2.preferredSize = [620,150];
				}
			headerInst.cancelBtn = headerInst.add('button', undefined, 'Close');
			headerInst.cancelBtn.onClick =  function(){ 
				headerInst.hide();
				}  		
			headerInst.show();
		}
        
          function showExportInst(){
               var ExportInst = new Window('palette', "Export Instructions");
                var body =
                    "This script creates a tab delimited text file containing all of the metadata fields used in the "+projectName2+" custom XMP panels.\n\n" +
                    "    Choose which files to export\n" +
                    "          From selected files only\n" +
                    "              1. Select file(s) in Adobe Bridge\n"+
                    "              2. Under ‘Images’, choose 'Selected thumbnails in Bridge'\n" +
                    "              3. Select desired export options (see below)'\n" +
                    "              4. click 'Export'\n" +
                    "              5. Choose name and location for your export file (.txt format)'\n" +
                    "              6. Saven\n" +
                    "          From all image files in a folder\n" +
                    "              1. Select 'Entire folder'\n" +
                    "              2. Use 'browse'  to select folder you wish to use\n" +
                    "              3. If you want to export images in all subfolders check the box 'include subfolders'\n" +
                    "              4. Select desired export options (see below)\n" +
                    "              5. Click 'Export'\n" +
                    "              6. Choose name and location for your export file (.txt format)\n" +
                    "              7. Save\n\n" +
                    "     After export is complete\n" +
                    "          1. Open your .txt file in a spreadsheet using tab delimiters.\n" +
                    "          2. Because the .txt file is created as UTF-8, it is best to use the Excel import text wizard to retain\n"+
                    "              proper character encoding, e.g. ©, 작, ü\n"+
                    "                a. Use import option and select a .txt file to import\n" +
                    "                b. Text Import Wizard\n" +
                    "                    i. File origin = 65001- Unicode (UTF-8)\n" +
                    "                    ii. Delimited = Tab\n" +
                    "                    iii. Finish\n" +
                    "          3. The first row will contain the field names."
   
               ExportInstText = ExportInst.add('statictext', undefined, body, {multiline:true});
			   if (Folder.fs == "Windows"){
				ExportInstText.preferredSize = [600,450];
				}
			else{
				ExportInstText.preferredSize = [700, 550];
				}
            
            ExportInst.optionsBtn = ExportInst.add('button', undefined, 'Export options');
           ExportInst.optionsBtn.onClick = function(){showExportOptInst()}
             ExportInst.optionsBtn.alignment = 'left'
             
               ExportInst.cancelBtn = ExportInst.add('button', undefined, 'Close');
			ExportInst.cancelBtn.onClick =  function(){ 
				ExportInst.hide();
				}
               ExportInst.show();
			}
            
            function showExportOptInst(){
               var exportOptInst = new Window('palette', "Export Options");
               var body =
                    "Export Options\n\n"+
                    "Option 1:  prepend Image dates with '_'\n"+
                    "   This is useful if you will be importing the metadata to Excel.\n"+                    
                    "   XMP Date values must use the YYYY/MM/DD format.  Adding a '_' character at the beginning of\n"+
                    "      the Date will prevent Excel from automatically changing it to a format XMP cannot understand.\n"+
                    "       (if your system is set up for another format, that will bereflected in the way Excel displays dates)\n"+
                    "     The '_' character will be removed when you import the data back into the image file(s).\n\n"+
                    "Option 2:  Remove line breaks\n"+
                    "    This is useful if you will be importing the metadata to Excel.\n"+
                    "    When selected, line breaks (line feed and carriage return) will be replaced by a semi-colon and a space ('; ').\n"+
                    "    When not selected, line breaks will be retained but converted to plain text place holders ('LF'), ('CR') so\n"+
                    "       that they are not changed by Excel.  When the data is imported back to an image, the codes will be\n"+
                    "       changed to the proper XMP encoding."
                    
               exportOptInstText = exportOptInst.add('statictext', undefined, body, {multiline:true});
			   if (Folder.fs == "Windows"){
				exportOptInstText.preferredSize = [650,250];
				}
			else{
				exportOptInstText.preferredSize = [700,350];
				}
               exportOptInst.cancelBtn = exportOptInst.add('button', undefined, 'Close');
			exportOptInst.cancelBtn.onClick =  function(){ 
				exportOptInst.hide();
				}
               exportOptInst.show();
			}
 
		// Panel for Import section
		importPanel = mainWindow.row.add('panel', undefined, "");
		importPanel.margins = 3;
		importPanel.alignChildren = 'center';
          importPanel.minimumSize = hidden
        importPanel.maximumSize = hidden
        
		header = importPanel.add( 'group' ); 
		header.orientation = 'row';
		header.spacing = 0;
		header.preferredSize = [360, undefined]

		importTitle = header.add('statictext', undefined, 'Import Metadata');
		importTitle.alignment = 'center';
		importTitle.justify = 'center';
        importTitle.preferredSize = [200,20];
 
		// Info button
		importInstButton = header.add('button', undefined, '?');
		importInstButton.preferredSize = buttonSize1
        importInstButton.alignment = 'right';
		importInstButton.helpTip = clickInstrucTT;
		importInstButton.onClick = function showImportInst(){
			var ImportInst = new Window('palette', "Import Instructions"); 
			ImportInst.body = ImportInst.add('group');
			ImportInst.body.orientation = 'column';
			ImportInst.body.spacing = 5;
			   
            var text1 =
            "This script imports data from a tab delimited text file into image files with matching filenames.\n\n" +
              "      If you have already exported metadata and edited it in Excel and want to import it back in:\n" +
			"         1. Select the folder containing the target images\n" +
			"              a. If you have nested folders, check 'include subfolders'\n" +
			"         2. Select the text file to be imported\n" +
			"              a. Click 'Import' and cross your fingers\n\n" +
			"     If you are starting with external metadata (from a database, etc.)\n" +
			"         First, you need a properly formatted template.\n"+
            "           This template lists all available IPTC fields and you can import data  into any IPTC field:";

			var text2 =			 
			"             Look for this new file on your desktop\n" +
			"                1. Open the text file in Excel\n" +
			"                2. Add data to the appropriate columns\n" +
			"                3. Save as a tab-delimited text file\n\n" +
			"      To import data into image files:\n" +
			"         1. Select the folder containing the target images\n" +
			"              a. If you have nested folders, check 'include subfolders'\n" +
			"         2. Select the text file to be imported\n" +
			"         3. Click 'Import' and cross your fingers";
   
			ImportInst.text1 = ImportInst.body.add('statictext', undefined, text1, {multiline:true});
			if (Folder.fs == "Windows"){
				ImportInst.text1.preferredSize = [540,160];
				}
			else{
				ImportInst.text1.preferredSize = [620,200];
				}			
			ImportInst.templateBtn = ImportInst.body.add ('button', undefined, "Create "+projectName1+"_import_default template.txt");
			ImportInst.templateBtn.helpTip = createTemplateTT;
			ImportInst.templateBtn.alignment = 'left';
			ImportInst.templateBtn.indent = 50;
			ImportInst.templateBtn.onClick  = createTemplate; 
			ImportInst.text2 = ImportInst.body.add('statictext', undefined, text2, {multiline:true});
			if (Folder.fs == "Windows"){
				ImportInst.text2.preferredSize = [540,150];
				}
			else{
				ImportInst.text2.preferredSize = [620,170];
				}
          ImportInst.optionsBtn = ImportInst.add('button', undefined, 'Import options');
           ImportInst.optionsBtn.onClick = function(){showImportOptInst();}
             ImportInst.optionsBtn.alignment = 'left'
			ImportInst.cancelBtn = ImportInst.add('button', undefined, 'Close');
			ImportInst.cancelBtn.onClick =  function(){ 
				ImportInst.hide();
				}  		
			ImportInst.show();
		}
               
		function showImportOptInst(){
               var importOptInst = new Window('palette', "Import Options");
               var body =
                    "Import Options\n\n"+
                    "Option 1: Ignore file extensions\n"+
                    "   When selected, metadata will be imported to all matching media with matching file names regardless\n"+
                    "   of the file extension.\n"+
                    "   This allows you to import matching metadata to all versions of the same media file, e.g., .tif, .jpg. .png.\n\n"+
                    "Option 2: Create Headline  (IPTC Core)\n"+
                    "   When selected, the Headline will be filled with the data values from:\n"+
                    "      A/O:Creator Name, A/O:Title\n\n"+
                    "Option 3: Create Description/Caption (IPTC)\n"+
                    "   When selected, the Description/Caption (dc:description) will be filled with the data values:\n"+
                    "      A/O:Creator 1 Name; A/O:Creator 2 Name; A/O:Creator 3 Name; A/O:Title; A/O:Circa Date Created;\n"+
                    "      A/O:Style/Period; A/O:Contribution Description; A/O:Source Name; A/O:Source Inventory Number;\n"+
                    "      A/O:Copyright Notice\n\n"+
                    "Option 4: Create Keywords (IPTC)\n"+
                    "   When selected, Keywords (dc:subject) will be filled with the data values from VRA Work fields:\n"+
                    "      A/O:Creator 1 Name; A/O:Creator 2 Name; A/O:Creator 3 Name; A/O:Style/Period\n\n"+             
                    "Option 5: Set Thumbnail Label\n"+	
                    "   When selected, each image that has metadata successfully imported will have its label set to:\n"+
                    "   'IPTC_CH metadata imported' and the label color will be changed to white.\n"+
                    "   Warning: Existing labels will be lost"

               importOptInstText = importOptInst.add('statictext', undefined, body, {multiline:true});
			   if (Folder.fs == "Windows"){
				importOptInstText.preferredSize = [650,350];
				}
			else{
				importOptInstText.preferredSize = [650,450];
				}
               importOptInst.cancelBtn = importOptInst.add('button', undefined, 'Close');
			importOptInst.cancelBtn.onClick =  function(){ 
				importOptInst.hide();
				}
               importOptInst.show();
			}
        
		// Select image files location
		imageLocBox = importPanel.add('panel', undefined, "Images folder");
		imageLocBox.spacing = 2;
        imageLocBox.margins = 5;      
         // Spacer
		spacer3 = imageLocBox.add( 'group' );
		spacer3.minimumSize = [100, 10]
		imageLocLblGrp = imageLocBox.add('group');
		imageLocLblGrp.orientation = 'row';
		imageLocLblGrp.alignment = 'left';
	//	imageLocLblGrp.spacing = 100
		imageLocLblGrp.indent = 3//55;
        imageLocSubfoldersLbl = imageLocLblGrp.add('statictext', undefined, "folder location:");
        imageLocSubfoldersLbl.preferredSize = [160,20]
		imageLocSubfoldersCb = imageLocLblGrp.add('checkbox', undefined, "include subfolders");		
		imageLocSubfoldersCb.alignment = 'left';
	//	imageLocSubfoldersCb.indent = 60;
		imageLocSubfoldersCb.onClick = function toggleImportSub(){
			if (imageLocSubfoldersCb.value == true){
				dataSourceOptions.enabled = true
				IgnoreExtCb.value = false;
				IgnoreExtCb.enabled = false;
				}
			if (imageLocSubfoldersCb.value == false){
				dataSourceOptions.enabled = false;
				dataSourceOptions.Name.value = true;
				dataSourceOptions.Path.value = false;
				IgnoreExtCb.value = true;
				IgnoreExtCb.enabled = true;
				}
			}

		imageLocGroup = imageLocBox.add('group');
		imageLocGroup.orientation = 'row';
        imageLocGroup.spacing = 2;
		imageLoc = imageLocGroup.add('edittext', undefined, "");
		imageLoc.preferredSize = textSize1
		imageLoc.helpTip = imageFolderPath;
		imageLocBrowse = imageLocGroup.add('button', undefined, "Browse");
		imageLocBrowse.helpTip = imageFolderBrowse;
		imageLocAlert = imageLocBox.add('statictext', undefined, "? Folder not found.  Keep looking.");
		imageLocAlert.alignment = 'left';
		imageLocAlert.justify = 'left';
		imageLocAlert.indent = 20;
        imageLocAlert.preferredSize = textSize1
	imageLocAlert.visible = false
	  
		// opens file browser to pick the location of the image files 
		imageLocBrowse.onClick =  function(){
		var folderPath = Folder.selectDialog("Select a folder of image files to import metadata");
            if (folderPath){
                imageLoc.text = folderPath.toString().split ("%20").join (" ");
                testImportImagesFolder();
                imageLoc.helpTip = imageLoc.text+"\n\n"+imageFolderPath
                }
			}
		 
		// Select the .txt  file to be imported
		dataSourceBox = importPanel.add('panel', undefined, "Metadata text file");
		dataSourceBox.spacing = 3;
		dataSourceBox.margins = 5;
		// Spacer
		spacer4 = dataSourceBox.add( 'group' );
		spacer4.minimumSize = [100, 10];
		dataSourceGrp = dataSourceBox.add('statictext', undefined, "file location:");
		dataSourceGrp.alignment = 'left';
		dataSourceGrp.indent = 3//68;
        dataSourceGrp.preferredSize = [160,20]
		dataSourceGroup = dataSourceBox.add('group');
		dataSourceGroup.orientation = 'row';      
		dataSourceGroup.spacing = 2;
		dataSource = dataSourceGroup.add('edittext', undefined, "");
		dataSource.preferredSize = textSize1
		dataSource.helpTip = textFilePath;
		dataSourceBrowse = dataSourceGroup.add('button', undefined, "Browse");
		dataSourceBrowse.helpTip = textFileBrowse;
		dataSourceFileAlert = dataSourceBox.add('statictext', undefined, "? File not found.  Keep looking.");
		dataSourceFileAlert.alignment = 'left';
		dataSourceFileAlert.justify = 'left';
        dataSourceFileAlert.preferredSize = [200,20]
		dataSourceFileAlert.indent = 20;
		dataSourceFileAlert.visible = false;
        
          // opens file browser to pick the location of the metadata text file to be imported to images
          dataSourceBrowse.onClick =  function(){
            var filePath = File.openDialog( 'Select the text file (.txt)',  "TXT  Files:*.txt" );
                if(filePath){
                dataSource.text = filePath.toString().split ("%20").join (" ");
                testTextFileExists();
                dataSource.helpTip = dataSource.text+"\n\n"+textFilePath
                }
		}
		  
		dataSourceOptions = importPanel.add('panel', undefined, "Match on");
		dataSourceOptions.Name = dataSourceOptions.add('radiobutton', undefined, "Filename");
        dataSourceOptions.Name.value = true;
		dataSourceOptions.Name.helpTip = "Example:\n 00252901.tif";
		dataSourceOptions.Path = dataSourceOptions.add('radiobutton', undefined, "Path and filename");
		dataSourceOptions.alignChildren = 'left';
		dataSourceOptions.Path.helpTip = "Example:\n C:/Architecture/Trajans_Column/Large/00252901.tif";
	     dataSourceOptions.minimumSize = [310, undefined]
		dataSourceOptions.spacing = 2;		

		writeOptions = importPanel.add('panel', undefined, "Existing Data");
		writeOptions.minimumSize = [310, undefined]
		writeOptions.spacing = 2;	
		writeOptions.overwriteRb = writeOptions.add('radiobutton', undefined, "Overwrite all fields");   
		writeOptions.overwriteRb.value = true
	//	writeOptions.overwriteRb.helpTip = replaceDataTT;
		writeOptions.appendRb = writeOptions.add('radiobutton', undefined, "Write only to empty fields");
        writeOptions.appendRb.value = true;
	//	writeOptions.appendRb.helpTip = appendDataTT;
		writeOptions.alignChildren = 'left';
		writeOptions.minimumSize = [310, undefined]
// Panel for options
     importOptionsGrp = importPanel.add('group', un, un);
		importOptions = importOptionsGrp.add('panel', undefined, "Options");	 
		importOptions.alignChildren = 'left';
		importOptions.minimumSize = [275, undefined]
		importOptions.spacing = 2;

		ignoreExt = importOptions.add('group', undefined, "");
		IgnoreExtCb = ignoreExt.add('checkbox', undefined, "Ignore file extensions");
		IgnoreExtCb.minimumSize = [200, undefined];	
	//	IgnoreExtCb.helpTip = IgnoreExtCbTT;

         fillHeadline = importOptions.add('group', undefined, "");
		fillHeadlineCb = fillHeadline.add('checkbox', undefined, "Create Headline (IPTC Core)");
		fillHeadlineCb.minimumSize = [200, undefined];	
	//	fillHeadlineCb.helpTip = createHeadlineTT;
        
		fillCpt = importOptions.add('group', undefined, "");
		fillCptCb = fillCpt.add('checkbox', undefined, "Create Description/Caption (IPTC Core)");
		fillCptCb.minimumSize = [200, undefined];	
	//	fillCptCb.helpTip = createDescriptionTT;

		fillSubj = importOptions.add('group', undefined, "");
		fillSubjCb = fillSubj.add('checkbox', undefined, "Create Keywords (IPTC Core)");
		fillSubjCb.minimumSize = [200, undefined];	
	//	fillSubjCb.helpTip = createKeywordsTT;

		addLabel = importOptions.add('group', undefined, "");
		addLabelCb = addLabel.add('checkbox', undefined, "Set Thumbnail Label");
		addLabelCb.minimumSize = [200, undefined];	
	//	addLabelCb.helpTip = addLabelTT; 
	  
	   // import Options Instructions button
		importOptionsButton = importOptionsGrp.add('button', undefined, "?");
		importOptionsButton.alignment = 'right';
		importOptionsButton.preferredSize = buttonSize1
		importOptionsButton.helpTip = clickInstrucTT;
		importOptionsButton.onClick = showImportOptInst	
				  
////////////////////////// SET HEADERS WINDOW ////////////////////////////////
// the floating palette UI
var headersWindow = new Window("palette", "Set Field Names", un, );
headersWindow.margins = 2;
headersWindow.spacing = 3;
headersWindow.orientation = 'column';

// Buttons
buttons = headersWindow.add('group',un, [un,un,un,un]);
buttons.alignChildren = ['top', 'center']
buttons.orientation = 'row';

buttonsChoice = buttons.add('group',un, un);
buttonsChoice.defaultHeadersRb = buttons.add('radiobutton', un, "Use Default Field Names");
buttonsChoice.defaultHeadersRb.value = true;
buttonsChoice.defaultHeadersRb.preferredSize = [200,20]
buttonsChoice.customHeadersRb = buttons.add('radiobutton', un, "Use Custom Field Names");
buttonsChoice.customHeadersRb.preferredSize = [200,20]
buttonsChoice.customHeadersRb.value = false
buttonsSave = buttons.add('button', un, "Save and Close");// save custom to custom array, close window
buttonsSave.preferredSize = [150,28]
buttonsSave.onClick = saveCustomHeaders;

buttonsChoice.defaultHeadersRb.onClick = function(){
    workDefaultHeaders.enabled = true
    workCustomHeaders.enabled = false
    imageDefaultHeaders.enabled = true
    imageCustomHeaders.enabled = false
    photoDefaultHeaders.enabled = true
    photoCustomHeaders.enabled = false
	setHeaders.text = "Using Default Field Names"
    };
buttonsChoice.customHeadersRb.onClick = function(){
    workDefaultHeaders.enabled = false
    workCustomHeaders.enabled = true
    imageDefaultHeaders.enabled = false
    imageCustomHeaders.enabled = true
    photoDefaultHeaders.enabled = false
    photoCustomHeaders.enabled = true
	setHeaders.text = "Using Custom Field Names"
    };

// Headers
headers = headersWindow.add('group',un, [un,un,un,un]);
headers.orientation = 'row';

//Work headers//
workHeaderLists = headers.add('group',un, un);
workHeaderLists.orientation = 'row';
workHeaderLists.alignment = 'top';
workHeaderLists.spacing = 0;

workDefaultHeaders = workHeaderLists.add('panel',un, un);
workDefaultHeaders.alignChildren = ['top', 'right'];
workDefaultHeaders.orientation = 'column';
workDefaultHeaders.spacing = headerListSpacing;
workDefaultHeaders.margins = [3,3,3,3]

workCopyDefault = workHeaderLists.add('group',un, un);
workCopyDefault.alignChildren = ['top', 'right'];
workCopyDefault.orientation = 'column';
workCopyDefault.spacing =  headerUseBtnSpacing;
workCopyDefault.margins = [3,3,3,3]

workCustomHeaders = workHeaderLists.add('panel',un, un);
workCustomHeaders.alignChildren = ['top', 'right'];
workCustomHeaders.orientation = 'column';
workCustomHeaders.spacing = headerListSpacing;
workCustomHeaders.margins = [3,3,3,3];
workCustomHeaders.enabled = false

//Image headers//
imageHeaderLists = headers.add('group',un, un);
imageHeaderLists.orientation = 'row';
imageHeaderLists.alignment = 'top';
imageHeaderLists.spacing = 0;

imageDefaultHeaders = imageHeaderLists.add('panel',un, un);
imageDefaultHeaders.alignChildren = ['top', 'right'];
imageDefaultHeaders.orientation = 'column';
imageDefaultHeaders.spacing = headerListSpacing;
imageDefaultHeaders.margins = [3,3,3,3]

imageCopyDefault = imageHeaderLists.add('group',un, un);
imageCopyDefault.alignChildren = ['top', 'right'];
imageCopyDefault.orientation = 'column';
imageCopyDefault.spacing = headerUseBtnSpacing;
imageCopyDefault.margins = [3,3,3,3]

imageCustomHeaders = imageHeaderLists.add('panel',un, un);
imageCustomHeaders.alignChildren = ['top', 'right'];
imageCustomHeaders.orientation = 'column';
imageCustomHeaders.spacing = headerListSpacing;
imageCustomHeaders.margins = [3,3,3,3];
imageCustomHeaders.enabled = false

//Photo headers//
photoHeaderLists = headers.add('group',un, un);
photoHeaderLists.orientation = 'row';
photoHeaderLists.alignment = 'top';
photoHeaderLists.spacing = 0;

photoDefaultHeaders = photoHeaderLists.add('panel',un, un);
photoDefaultHeaders.alignChildren = ['top', 'right'];
photoDefaultHeaders.orientation = 'column';
photoDefaultHeaders.spacing = headerListSpacing;
photoDefaultHeaders.margins = [3,3,3,3]

photoCopyDefault = photoHeaderLists.add('group',un, un);
photoCopyDefault.alignChildren = ['top', 'right'];
photoCopyDefault.orientation = 'column';
photoCopyDefault.spacing = headerUseBtnSpacing;
photoCopyDefault.margins = [3,3,3,3]

photoCustomHeaders = photoHeaderLists.add('panel',un, un);
photoCustomHeaders.alignChildren = ['top', 'right'];
photoCustomHeaders.orientation = 'column';
photoCustomHeaders.spacing = headerListSpacing;
photoCustomHeaders.margins = [3,3,3,3];
photoCustomHeaders.enabled = false

//Technical headers
techHeaderLists = headers.add('group',un, un);
techHeaderLists.orientation = 'column';
techHeaderLists.spacing = 0;
techHeaderLists.margins = [0,0,0,0];

// Functions
headersWindow.onClose = function(){mainWindow.enabled = true;}
function addWorkHeader(){
	while(workDefaultHeaders.children.length > 0){
		workDefaultHeaders.remove(0)
		}
	while(workCopyDefault.children.length > 0){
		workCopyDefault.remove(0)
		}
	while(workCustomHeaders.children.length > 0){
		workCustomHeaders.remove(0)
		}
    for(var i = 0; i < 32; i++){    
        newLabel = workDefaultHeaders.add('statictext', un, columnHeaders[i]);
        newLabel.preferredSize = editMSml;
        newLabel.id = "defaultHeader"+[i];    
        newEditText = workCustomHeaders.add('edittext', un, un);
        newEditText.preferredSize = editMSml;
        newEditText.id = "customHeader"+[i];		
        newEditText.text = fieldsDict[i].customHeader
        newCopyBtn = workCopyDefault.add( 'button', un, ">");
        newCopyBtn.preferredSize = singleButtonSize
        newCopyBtn.helpTip = useDefaultBtnTT
        newCopyBtn.id = "copyButton"+[i]
        newCopyBtn.onClick = function(){
			var index = this.id.split("copyButton").join("")           
			workCustomHeaders.children[index].text = workDefaultHeaders.children[index].text 
			}
	
	//	newEditText.addEventListener ('click',function(){var currentField = newEditText});
	//	newEditText.addEventListener ('click',function(){var currentField = this.id});
		}
	// set custom file name and file path same as defualt
    /*    workCustomHeaders.children[0].text = workDefaultHeaders.children[0].text 
        workCustomHeaders.children[0].visible = false;
        workCopyDefault.children[0].visible = false;
        workCustomHeaders.children[1].text = workDefaultHeaders.children[1].text 
        workCustomHeaders.children[1].visible = false;
        workCopyDefault.children[1].visible = false;	
		*/
}

function addImageHeader(){
	while(imageDefaultHeaders.children.length > 0){
		imageDefaultHeaders.remove(0)
		}
	while(imageCopyDefault.children.length > 0){
		imageCopyDefault.remove(0)
		}
	while(imageCustomHeaders.children.length > 0){
		imageCustomHeaders.remove(0)
		}
    for(var i = 32; i < 64; i++){    
        newLabel = imageDefaultHeaders.add('statictext', un, columnHeaders[i]);
        newLabel.preferredSize = editMSml;
        newLabel.id = "defaultHeader"+[i-32];    
        newEditText = imageCustomHeaders.add('edittext', un, un);
        newEditText.preferredSize = editMSml;
        newEditText.id = "customHeader"+[i-32];
        newEditText.text = fieldsDict[i].customHeader
        newCopyBtn = imageCopyDefault.add( 'button', un, ">");
        newCopyBtn.preferredSize = singleButtonSize
        newCopyBtn.helpTip = useDefaultBtnTT
        newCopyBtn.id = "copyButton"+[i-32]
		newCopyBtn.onClick = function(){
			var index = this.id.split("copyButton").join("")           
			imageCustomHeaders.children[index].text = imageDefaultHeaders.children[index].text 
			}
		}	
	}

function addPhotoHeader(){
	while(photoDefaultHeaders.children.length > 0){
		photoDefaultHeaders.remove(0)
		}
	while(photoCopyDefault.children.length > 0){
		photoCopyDefault.remove(0)
		}
	while(photoCustomHeaders.children.length > 0){
		photoCustomHeaders.remove(0)
		}
    for(var i = 64; i < 88; i++){    // 102
        newLabel = photoDefaultHeaders.add('statictext', un, columnHeaders[i]);
        newLabel.preferredSize = editMSml;
        newLabel.id = "defaultHeader"+[i-64];    
        newEditText = photoCustomHeaders.add('edittext', un, un);
        newEditText.preferredSize = editMSml;
        newEditText.id = "customHeader"+[i-64];
        newEditText.text = fieldsDict[i].customHeader
        newCopyBtn = photoCopyDefault.add( 'button', un, ">");
        newCopyBtn.preferredSize = singleButtonSize
        newCopyBtn.helpTip = useDefaultBtnTT
        newCopyBtn.id = "copyButton"+[i-64]
		newCopyBtn.onClick = function(){
			var index = this.id.split("copyButton").join("")           
			photoCustomHeaders.children[index].text = photoDefaultHeaders.children[index].text 
			}
		}
}

function addTechHeader(){
	while(techHeaderLists.children.length > 0){
		techHeaderLists.remove(0)
		}
    for(var i = 88; i < 102; i++){    // 102
        newLabel = techHeaderLists.add('statictext', un, columnHeaders[i]);
        newLabel.preferredSize = editMSml;
        newLabel.id = "techHeader"+[i-88];		
		}
	}

	//// end of set headers window
	function setHeadersFunc(){		
        mainWindow.enabled = false
        addWorkHeader();
		addImageHeader();
		addPhotoHeader();
		//addTechHeader();
        headersWindow.show();
        headersWindow.center();   
        /* disabled becasue we aren't using this option in this version
	//	if (setHeaders.text = "Using Custom Headers"){
		if (buttonsChoice.customHeadersRb.value == true){
				workDefaultHeaders.enabled = false
				imageDefaultHeaders.enabled = false
				photoDefaultHeaders.enabled = false
                workCustomHeaders.enabled = true
				imageCustomHeaders.enabled = true
				photoCustomHeaders.enabled = true
				}
	//	if (setHeaders.text = "Using Default Headers"){	
		if (buttonsChoice.defaultHeadersRb.value == true){
                    workDefaultHeaders.enabled = true
				imageDefaultHeaders.enabled = true
				photoDefaultHeaders.enabled = true
				workCustomHeaders.enabled = false
				imageCustomHeaders.enabled = false
				photoCustomHeaders.enabled = false
				}
            */
       headersWindow.layout.layout (true);
       headersWindow.enabled = true
		}
    
function saveCustomHeaders(){ // TODO: how do these get added to fieldsDict[i].customHeader?
    customHeadersArray = [];
    for(var L1 = 0; L1 < workCustomHeaders.children.length; L1++){
            customHeadersArray.push(workCustomHeaders.children[L1].text)
        }
    for(var L2 = 0; L2 < imageCustomHeaders.children.length; L2++){
            customHeadersArray.push(imageCustomHeaders.children[L2].text)
        }
    for(var L3 = 0; L3 < photoCustomHeaders.children.length; L3++){
            customHeadersArray.push(photoCustomHeaders.children[L3].text)
        }
	/*for(var L4 = 0; L4 < techHeaderLists.children.length; L4++){
            customHeadersArray.push(techHeaderLists.children[L4].text)
        }*/
	 for (var L1 = 0; L1 < customHeadersArray.length; L1++){
                    fieldsDict[L1].customHeader = customHeadersArray[L1]
                    }
	headersWindow.hide();
    mainWindow.enabled = true;
    }
	// check to see if the folder of images specified exists
		function testImportImagesFolder(){
			var selectedFolder = Folder(imageLoc.text.split(" ").join("%20"));			
			if (imageLoc.text && selectedFolder.exists == false){
				importImageFolderOK = false;
				imageLocAlert.visible = true;
				}
			else if (imageLoc.text && selectedFolder.exists == true){
				importImageFolderOK = true;
				imageLocAlert.visible = false;
				}
			toggleImportBtn();
			}		
				
		// check to see if the .txt file folder specified exists
		function testTextFileExists(){
			// get just the directory
			var textFile = File(dataSource.text.split(" ").join("%20"));
			if (dataSource.text && textFile.exists == false){
				importTextFileOK = false;
				dataSourceFileAlert.visible = true;
				}
			else if (dataSource.text && textFile.exists == true){
				importTextFileOK = true;
				dataSourceFileAlert.visible = false;
				}
			toggleImportBtn();
			}

		function toggleImportBtn(){
			if (importImageFolderOK == true && importTextFileOK == true ){
				importBtn.enabled = true;
				}
			else{
				 importBtn.enabled = false;
				}
			}
		
		  // test to see if the paths entered by user exist
		 imageLoc.addEventListener('changing',function(){testImportImagesFolder()});
		 dataSource.addEventListener('changing',function(){testTextFileExists()});
		 
          // Import button
          importBtn = importPanel.add('button', undefined, "Import");
          importBtn.preferredSize = [120, 35];
          importBtn.onClick = importFromFile;
            
		// Create a text file on the desktop with only the headers.  This can be used as a template in Excel to create properly formatted text for the import function
		function createTemplate(){
			var vraTemplate = new File (desktop+""+projectName1+"_import_default template.txt")                
			vraTemplate.encoding = "UTF8";
			vraTemplate.open ("w", "TEXT", "ttxt");	

			// Loop through array of headers (properties) and write them to the .txt file
			for (var L1 = 0; L1 < columnHeaders.length; L1++) vraTemplate.write (columnHeaders[L1] + "\t");

			// Close the file  ""+projectName1+"_import_template.txt"
			vraTemplate.close();

			Window.alert ("A new file named:\n\n"+projectName1+"_import_default template.txt\n\nhas been created on your desktop.", "Success!")
			}
			
		// Cancel button
		cancelBtn = mainWindow.add('button', undefined, "Cancel");
		cancelBtn.minimumSize = [150, 25];
		cancelBtn.onClick = function(){
            var appDataPlgnSet = File (appDataFwdSlash + plgnPrefs + plgnOpt + plgnSet);
            //  ~/AppData/Roaming/IPTC_CH_Import_Export/Options/settings.txt
            appDataPlgnSet.open ("w", "TEXT", "ttxt");
            appDataPlgnSet.write (exportWhich.folderRb.value  + "|");
            appDataPlgnSet.write (exportWhich.subfoldersCb.value  + "|");  
            appDataPlgnSet.write (exportWhich.thumbsRb.value + "|");
            appDataPlgnSet.write (exportOptions.datesCb.value + "|");
            appDataPlgnSet.write (dataSource.text + "|");
            appDataPlgnSet.write (writeOptions.appendRb.value+ "|");
            appDataPlgnSet.write(writeOptions.overwriteRb.value + "|");
            appDataPlgnSet.write (IgnoreExtCb.value+ "|");
            appDataPlgnSet.write (fillSubjCb.value+ "|");
            appDataPlgnSet.write (fillCptCb.value+ "|");     
            appDataPlgnSet.write (addLabelCb.value+ "|");
            appDataPlgnSet.write (exportOptionsLfCb.value+"|");
            appDataPlgnSet.write (exportChoice+"|");
            appDataPlgnSet.write (exportWhich.folderEt.text + "|");
            appDataPlgnSet.write (imageLoc.text+ "|");
            appDataPlgnSet.write (imageLocSubfoldersCb.value+ "|");
            appDataPlgnSet.write (dataSourceOptions.Path.value+ "|");
            appDataPlgnSet.write (dataSourceOptions.Name.value+ "|");
            appDataPlgnSet.write (dataSourceOptions.enabled+ "|");
            appDataPlgnSet.write (IgnoreExtCb.enabled+ "|");
            appDataPlgnSet.write (fillHeadlineCb.value+ "|");
			appDataPlgnSet.write (customHeadersArray.join(",") + "|");
			appDataPlgnSet.write (buttonsChoice.defaultHeadersRb.value + "|");
			appDataPlgnSet.write (buttonsChoice.customHeadersRb.value + "|");
      appDataPlgnSet.write (mode);
            appDataPlgnSet.close();
            // close hte main UI window   
            mainWindow.hide(); 
            mainWindow.close();     
			}
 
     // if file 'appDataFwdSlash/"+projectName1+"_Import_Export/Options/settings.txt' exists, read settings and apply to dialog
	 // ~/AppData/Roaming/"+projectName1+"_Import_Export/Options/settings.txt
	 // C:\Users\Computer User\AppData\Roaming\"+projectName1+"_Import_Export\Options
     var appDataPlgnSetBkSlash = File (appDataFwdSlash + plgnPrefs + plgnOpt + plgnSet);
     if (appDataPlgnSetBkSlash.exists == true){
          appDataPlgnSetBkSlash.open ('r');
          var pluginSettingsArray = appDataPlgnSetBkSlash.read().split ('|');
          appDataPlgnSetBkSlash.close();
		try{           
			if (pluginSettingsArray[1] == "true") exportWhich.subfoldersCb.value = true;           	
			if (pluginSettingsArray[3] == "false") exportOptions.datesCb.value = false;
			if (pluginSettingsArray[4]) dataSource.text = pluginSettingsArray[4];
			if (pluginSettingsArray[5] == "true") writeOptions.appendRb.value = true;
			if (pluginSettingsArray[6] == "true") writeOptions.overwriteRb.value = true;
			if (pluginSettingsArray[7] == "true") IgnoreExtCb.value = true; 
			if (pluginSettingsArray[8] == "true") fillSubjCb.value = true;
			if (pluginSettingsArray[9] == "true") fillCptCb.value = true; 
			if (pluginSettingsArray[10] == "true") addLabelCb.value = true;
			if (pluginSettingsArray[11] == "false") exportOptionsLfCb.value = false;
			exportChoice = pluginSettingsArray[12];        
			 if (pluginSettingsArray[12] == "folder") exportWhich.folderRb.value = true;
			 if (pluginSettingsArray[12] == "thumbs") exportWhich.thumbsRb.value = true;
			if (pluginSettingsArray[13]) exportWhich.folderEt.text = pluginSettingsArray[13];
			if (pluginSettingsArray[14]) imageLoc.text = pluginSettingsArray[14];
			if (pluginSettingsArray[15] == "true") imageLocSubfoldersCb.value = true;   
			if (pluginSettingsArray[16] == "true") dataSourceOptions.Path.value = true;
			if (pluginSettingsArray[17] == "true") dataSourceOptions.Name.value = true;
			if (pluginSettingsArray[18] == "false") dataSourceOptions.enabled = false;
			if (pluginSettingsArray[19] == "false") IgnoreExtCb.enabled = false;  
			if (pluginSettingsArray[20] == "true") fillHeadlineCb.value = true;
			if (pluginSettingsArray[21]) customHeadersArray = pluginSettingsArray[21].split(","); // TODO: add these to fieldsDict[i].customHeader
                for (var L1 = 0; L1 < customHeadersArray.length; L1++){
                    fieldsDict[L1].customHeader = customHeadersArray[L1]
                    };
        mode = pluginSettingsArray[24]
                /* disabled becasue we aren't using this option in this version
			if (pluginSettingsArray[22] == "true") buttonsChoice.defaultHeadersRb.value = true;
			if (pluginSettingsArray[22] == "true") setHeaders.text = "Using Default Field Names";
			if (pluginSettingsArray[23] == "true") buttonsChoice.customHeadersRb.value = true;
			if (pluginSettingsArray[23] == "true") setHeaders.text = "Using Custom Field Names";
            */
			}
          catch(pluginSettingsError){
               if (appDataPlgnSetBkSlash.exists == true) appDataPlgnSetBkSlash.remove();
          }
     }
// get current Bridge folder and file paths to automatically fill form
        if(app.document.visibleThumbnails == true){
            var slicePathIndex = app.document.visibleThumbnails[0].spec.toString().lastIndexOf ("/")
            var path = app.document.visibleThumbnails[0].spec.toString().substr(0,slicePathIndex+1).split("%20").join(" ")
            exportWhich.folderEt.text = path
            imageLoc.text = path
            }
		// get current Bridge folder and file paths to automatically fill form
		if(app.document.visibleThumbnails){
			 var slicePathIndex = app.document.visibleThumbnails[0].spec.toString().lastIndexOf ("/")
			 var path = app.document.visibleThumbnails[0].spec.toString().substr(0,slicePathIndex+1).split("%20").join(" ")
			 exportWhich.folderEt.text = path
			 imageLoc.text = path		     
			}
     
		if (hardDriveCheck == null) var hardDriveCheck = hardDrive;
		toggleExportWhich();	     
		
        testExportImagesFolder();
     //   testTextFolderExists();
     //   testTextFileExtension();
        testImportImagesFolder();
        testTextFileExists();
	exportWhich.folderEt.helpTip = exportWhich.folderEt.text+"\n\n"+imageFolderPath
   imageLoc.helpTip = imageLoc.text+"\n\n"+imageFolderPath
  dataSource.helpTip = dataSource.text+"\n\n"+textFilePath
  // set panel view
  toggleNav()
		// open the window
		mainWindow.show(); 
     } // main UI window - brace 1 close
//////////////////////////////////////////////////////////////// END OF MAIN UI WINDOW ////////////////////////////////////////////////////////////////
// BEGIN FUNCTIONS
 function toggleNav(){
    if(mode == "import"){
      navExportBtn.value = false
      navImportBtn.value = true 
      navExportBtn.text = "export"
      exportPanel.minimumSize = hidden
      exportPanel.maximumSize = hidden
      navImportBtn.text = arrowRight+"IMPORT"+arrowLeft
      importPanel.minimumSize = panelSize
      importPanel.maximumSize = panelSize
      mainWindow.layout.layout (true)
        }
    else{
      navExportBtn.value = true
      navImportBtn.value = false 
      navExportBtn.text = arrowLeft+"EXPORT"+arrowRight
      exportPanel.minimumSize = panelSize
      exportPanel.maximumSize = panelSize
      navImportBtn.text = "import"
      importPanel.minimumSize = hidden
      importPanel.maximumSize = hidden
      mainWindow.layout.layout (true)
        }
    }
 
// BEGIN EVENT LISTENERS
 /*
exportBtn.addEventListener('change',function(){alert("WORKS!")}); // toggleNav();
*/
//////////////////////////////////////////////////////////////// BEGINNING OF EXPORT FUNCTIONS ////////////////////////////////////////////////////////////////
	// check for valid file type i.e. jpg, jpeg, tif, etc.
    function testFileExtension(file) {
       return file instanceof File &&
          file.name.match(/\.(bmp|dng|gif|jpe?g|pdf|png|psd|tiff?|xmp)$/i) != null;
        }  
	// check that filename does not begin with "."
	function testFilePrefix(file) {
       return file instanceof File &&
          file.name.substring(0, 1) != "." == true;
        }

	// Progress bar for locating files
	var locateFilesProgress = new Window ('palette', "Exporting Metadata");
	locateFilesProgress.body = locateFilesProgress.add('group', undefined);
	locateFilesProgress.preferredSize = [300,100];
	locateFilesProgress.alignChildren = 'center';
	locateFilesProgress.message = locateFilesProgress.add('statictext', undefined, "Locating Files...");
   
   // Beginning of data Export Function
     // Extract and write metadata to a .txt. file
     function exportToFile(){ 
         	  { // export brace 1 open
		   if(exportWhich.thumbsRb.value == true && app.document.selections.length == 0){
			 app.beep();
			 Window.alert("You must select at least one thumbnail");
			}
		   else{
			// Open the Save dialog to choose a file name and directory for the export file
              caption = projectName2+" panel metadata export"
			var dataExport = File.saveDialog( caption,  "TXT  Files:*.txt" );             
			dataExport.encoding = "UTF8";
			dataExport.open ('w', 'XLS', 'XCEL');   	
			
			// Create empty objects to store pass/fail data during export
			var filePass = 0;
			var fileFail = 0;
			var fileFailArr = [];
			var couldNotOpen = [];
			var propFail = 0;
            var customHeadersExported = [];
       if (dataExport){  
        var allFiles = [];
        var selectedFolder = Folder(exportWhich.folderEt.text.split(" ").join("%20"));
        var appDataPlgnSet = File (appDataFwdSlash + plgnPrefs + plgnOpt + plgnSet);
        appDataPlgnSet.open ("w", "TEXT", "ttxt");
        appDataPlgnSet.write (exportWhich.folderRb.value  + "|");
        appDataPlgnSet.write (exportWhich.subfoldersCb.value  + "|");  
        appDataPlgnSet.write (exportWhich.thumbsRb.value + "|");
        appDataPlgnSet.write (exportOptions.datesCb.value + "|");
        appDataPlgnSet.write (dataSource.text + "|");
        appDataPlgnSet.write (writeOptions.appendRb.value+ "|");
        appDataPlgnSet.write(writeOptions.overwriteRb.value + "|");
        appDataPlgnSet.write (IgnoreExtCb.value+ "|");
        appDataPlgnSet.write (fillSubjCb.value+ "|");
        appDataPlgnSet.write (fillCptCb.value+ "|");     
        appDataPlgnSet.write (addLabelCb.value+ "|");
        appDataPlgnSet.write (exportOptionsLfCb.value+"|");
        appDataPlgnSet.write (exportChoice+"|");
        appDataPlgnSet.write (exportWhich.folderEt.text + "|");
        appDataPlgnSet.write (imageLoc.text+ "|");
        appDataPlgnSet.write (imageLocSubfoldersCb.value+ "|");
        appDataPlgnSet.write (dataSourceOptions.Path.value+ "|");
        appDataPlgnSet.write (dataSourceOptions.Name.value+ "|");
        appDataPlgnSet.write (dataSourceOptions.enabled+ "|");
        appDataPlgnSet.write (IgnoreExtCb.enabled+ "|");
        appDataPlgnSet.write (fillHeadlineCb.value+ "|");
        appDataPlgnSet.write (customHeadersArray+ "|");
        appDataPlgnSet.write (buttonsChoice.defaultHeadersRb.value+ "|");
        appDataPlgnSet.write (buttonsChoice.customHeadersRb.value + "|");
        appDataPlgnSet.write (mode);
        appDataPlgnSet.close();
        // close the main user interface window before running the export
        mainWindow.hide();			     

	// open selectedFolder add the path of every file found to the 'allFiles' array. this will be the list of files to be exported
	function getFolder(selectedFolder) {
		var allFilesList = selectedFolder.getFiles();
		for (var L1 = 0; L1 < allFilesList.length; L1++) {
			var myFile = allFilesList[L1];
				if (myFile instanceof File && testFileExtension(myFile) == true && testFilePrefix(myFile) == true) {
				allFiles.push(myFile); 
				}
			}
		}

	// open selectedFolder and all subfolders an add the path of every file found to the 'allFiles' array. this will be the list of files to be exported
	function getSubFolders(selectedFolder) {
		 var allFilesList = selectedFolder.getFiles();
		 for (var L1 = 0; L1 < allFilesList.length; L1++) {		 	 
			  var myFile = allFilesList[L1];
			  if (myFile instanceof Folder){
				   getSubFolders(myFile);
			  }
			  else if (myFile instanceof File && testFileExtension(myFile) == true && testFilePrefix(myFile) == true) {
				   allFiles.push(myFile); 
				  }
			 }  
		}

	// if "Include subfolders" is not checked, only read the files in the selected folder
	if (exportWhich.subfoldersCb.value == false){
		locateFilesProgress.show();
		getFolder(selectedFolder);
		locateFilesProgress.hide();
		}

	// if "Include subfolders" is checked, read all the files in the selected folder and its subfolders
	if (exportWhich.subfoldersCb.value == true){
		locateFilesProgress.show();
		getSubFolders(selectedFolder);
		locateFilesProgress.hide();
		}

	  if (exportWhich.folderRb.value == true) var Thumb = allFiles;
	  if (exportWhich.thumbsRb.value == true) var Thumb = app.document.selections;
			// progress bar window to show files are exporting
			var exportProgress = new Window ("palette {text: ' " + plgnName + "  " + spot + "  (Exporting "+projectName2+" Data)', bounds: [0,0,500,30], X: Progressbar {bounds: [0,0,500,30]}};");
      // write UTF-8 BOM
      dataExport.write ("\uFEFF")
			if(fieldsDict[0].customHeader.length > 0){
						dataExport.write (fieldsDict[0].customHeader + "\t")
						}
					else{
						dataExport.write (fieldsDict[0].header + "\t")
						}
            // force custom headers choice to be default, since we aren't shoinw the custom screen in this version.        
		buttonsChoice.customHeadersRb.value = false	
			// begin exporting data to the text file
			// loop through array of headers (properties) and write them to the .txt file
			for (var L1 = 1; L1 < fieldsDict.length; L1++){  // chaged L1 = 1 becasue filename was being exported twice
                if (buttonsChoice.customHeadersRb.value == true){
                    if(fieldsDict[L1].customHeader.length > 0){
                        dataExport.write (fieldsDict[L1].customHeader + "\t");
					customHeadersExported.push(fieldsDict[L1].customHeader)
                        }
                    }
                else{
                    dataExport.write (fieldsDict[L1].header + "\t");
                    }
                }

			// loop through files, read XMP property data and write it to "^"+projectName1+"_Data.txt"
			for (var L2 = 0; L2 < Thumb.length; L2++){
            // Display exorting progress bar if there are more than 50 images
			  if (Thumb.length > 50){
				   exportProgress.X.value = (L2 / Thumb.length) * 100;
				   exportProgress.center();
				   exportProgress.show();
				}
			if (Thumb[L2]){
             // get just the file name from allFiles so we can compare it to the file name in the text file
			 var splicePathIndex = Thumb[L2].toString().lastIndexOf ("/")
			 /* // TODO: disabled becasue Mac requires ".lastIndexOf ("/")" the same as Windows - use new doubled version below?
				 if (Folder.fs == 'Windows'){
					var splicePathIndex = Thumb[L2].toString().lastIndexOf ("/")
					}
				else{  
					var splicePathIndex = Thumb[L2].toString().lastIndexOf ("\\")
                       var splicePathIndex = Thumb[L2].toString().lastIndexOf ("/")
					}
				*/
				// just the file directory
				var spliceDirectory = Thumb[L2].toString().substr(0,splicePathIndex+1).split("%20").join(" ");
				// just the file name
				if (exportWhich.folderRb.value == true) var spliceName = Thumb[L2].toString().slice(splicePathIndex+1).split("%20").join(" ");
                  if (exportWhich.thumbsRb.value == true) var spliceName = Thumb[L2].name.split ("%20").join (' ');

				// overall try/catch for each image. If read passes, 1 is added to filePass variable. If read fails, catch error adds 1 to fileFail variable  and file name to fileFailArr
				try
				{		
				  // Get the file
				  if (exportWhich.folderRb.value == true) var singleFile = Thumb[L2];
				  if (exportWhich.thumbsRb.value == true) var  singleFile = Thumb[L2].spec;
                  // Create an XMPFile
                  // try to open file. if it fails, save file path in error log
                    try{
                    // if file is an .xmp sidecar - read the xmp directly to an XMPMeta Object
                    if( singleFile.name.match(/\.xmp/i) != null){
                        var xmpFile = Folder (File(singleFile.fsName)); 
                        xmpFile.open('r')
					xmpFile.encoding = "UTF8";	
                        var xmpData = new XMPMeta(xmpFile.read()); 									
                        xmpFile.close()
                        }
                    else{
                        // if file is not an .xmp sidecar pull XMP from file
                        var xmpFile = new XMPFile(singleFile.fsName, XMPConst.UNKNOWN, XMPConst.OPEN_FOR_READ);
										  	xmpFile.encoding = "UTF8 BOM";
                        // convert to xmp
                        var xmpData = xmpFile.getXMP();
                        }
                    }
                    catch(couldNotOpenError){}
                    /*
					// Create an XMPFile
					try{
						var xmpFile = new XMPFile(singleFile.fsName, XMPConst.UNKNOWN, XMPConst.OPEN_FOR_READ);
						xmpFile.encoding = "UTF8 BOM";
						// Get the XMP data
						var xmpData = xmpFile.getXMP();					
						}
				  catch(couldNotOpenError){couldNotOpen.push(imageFile.fsName)}
				*/
				// write return to start file properties
				dataExport.write ('\r');
				// Export image file name
				dataExport.write (spliceName);

				// Export file directory
				 if (buttonsChoice.customHeadersRb.value == true){
					 if(fieldsDict[1].customHeader.length > 0){  
						 dataExport.write ('\t' + spliceDirectory);
						 }
					 }
				 else{
					dataExport.write ('\t' + spliceDirectory);
					 }				

// Run export functions 
for (var L1 = 0; L1 < fieldsDict.length; L1++){
	if(fieldsDict[L1].type == 'text' || fieldsDict[L1].type == 'complexStruct' || fieldsDict[L1].type == 'boolean'){
		try{
			// customHeaders logic
            if (buttonsChoice.customHeadersRb.value == true){
                    if(fieldsDict[L1].customHeader.length > 0){                            
                        prop = xmpData.getProperty(fieldsDict[L1].namespace, fieldsDict[L1].path);
                        if (prop){
                            if (exportOptionsLfCb.value == true){
                                dataExport.write ("\t" + prop.toString().split("\n").join("; ").split("\r").join("; ").split("\t").join("; "));
                                }
                            else{
                                dataExport.write ("\t" + prop.toString().split("\n").join("(LF)").split("\r").join("(CR)").split("\t").join("(HT)"));
                                }
                            }
                        else{
                            dataExport.write ("\t");
                            }
                        }                
        		} // end if (buttonsChoice.customHeadersRb.value == true)
            else{                         
                    prop = xmpData.getProperty(fieldsDict[L1].namespace, fieldsDict[L1].path);
                    if (prop){
                        if (exportOptionsLfCb.value == true){
                            dataExport.write ("\t" + prop.toString().split("\n").join("; ").split("\r").join("; ").split("\t").join("; "));
                            }
                        else{
                            dataExport.write ("\t" + prop.toString().split("\n").join("(LF)").split("\r").join("(CR)").split("\t").join("(HT)"));
                            }
                        }
                    else{
                        dataExport.write ("\t");
                        }
                    } // end else
            } // end try
			catch(propFail){propFail++}
			}

	if(fieldsDict[L1].type == 'date'){
		try{
            if (buttonsChoice.customHeadersRb.value == true){
                if(fieldsDict[L1].customHeader.length > 0){  
                prop = xmpData.getProperty (fieldsDict[L1].namespace, fieldsDict[L1].path);
                if (prop){
                    if (exportOptions.datesCb .value == true) var prop = "_" + prop;                                      
                    dataExport.write ('\t' + prop);
                    }
                else{
                    dataExport.write ('\t');
                    }
                }
            }
        else{
            prop = xmpData.getProperty (fieldsDict[L1].namespace, fieldsDict[L1].path);
			if (prop){
				if (exportOptions.datesCb .value == true) var prop = "_" + prop;                                      
				dataExport.write ('\t' + prop);
				}
			else{
				dataExport.write ('\t');
				}
			}
            }
          catch(propFail){propFail++}    
		}

	if(fieldsDict[L1].type == 'seq' || fieldsDict[L1].type == 'bag' || fieldsDict[L1].type == 'bagDcSubject' || fieldsDict[L1].type == 'langAlt' || fieldsDict[L1].type == 'langAltDcTitle' || fieldsDict[L1].type == 'langAltDcDescription'){
		try{
            if (buttonsChoice.customHeadersRb.value == true){
                if(fieldsDict[L1].customHeader.length > 0){  
                    var count = xmpData.countArrayItems(fieldsDict[L1].namespace, fieldsDict[L1].path);
                    var arString = "";               
                if(count > 0){                   
                   for(var L1a = 1;L1a <= count;L1a++){
                         try{
                        arString += xmpData.getArrayItem(fieldsDict[L1].namespace, fieldsDict[L1].path, L1a);
                        if(L1a < count) arString += '; ';
                        }
                        catch(propFail){
                            var arString = "";
                            }
                        }
                    }      
                    if (exportOptionsLfCb.value == true){
                        dataExport.write ("\t" + arString.split("\n").join("; ").split("\r").join("; ").split("\t").join("; "));
                        }
                    else{
                        dataExport.write ("\t" + arString.split("\n").join("(LF)").split("\r").join("(CR)").split("\t").join("(HT)"));
                        }
                    }
                }
            else{
                var count = xmpData.countArrayItems(fieldsDict[L1].namespace, fieldsDict[L1].path);
                    var arString = "";
                     if(count > 0){   
                        for(var L1a = 1;L1a <= count;L1a++){
                            try{
                                arString += xmpData.getArrayItem(fieldsDict[L1].namespace, fieldsDict[L1].path, L1a);
                                if(L1a < count) arString += '; ';
                                }
                            catch(propFail){
                                var arString = "";
                                }
                            }
                        }
                        if (exportOptionsLfCb.value == true){
                            dataExport.write ("\t" + arString.split("\n").join("; ").split("\r").join("; ").split("\t").join("; "));
                            }
                        else{
                            dataExport.write ("\t" + arString.split("\n").join("(LF)").split("\r").join("(CR)").split("\t").join("(HT)"));
                            }
                        }
                    }		
			catch(propFail){propFail++}          
			}	
	} // end
				// Technical properties
                function exportText (namespace,path){
					try{
						prop = xmpData.getProperty (namespace,path);
						if (prop){
							dataExport.write ('\t' + prop);
							}
						else{
							dataExport.write ('\t');
							}
						}
					catch(propFail){propFail++}
					}	
				// Image File Created Date
				{
					try  {
						prop = singleFile.created;   							
						var fullDate = new Date (prop);
						var month = fullDate.getMonth() + 1;
						if (month.toString().length < 2)
						{
						month = "0"+month;
						} 
						var day = fullDate.getDate();
						if (day.toString().length < 2)
						{
						day = "0"+day;
						}
						var year = fullDate.getFullYear();
						var time = fullDate.toTimeString().split(" GMT").join("");
						time= time.substr(0,10) + ":" + time.substr(10)
						var display = year+"-"+month+"-"+day+"T"+time                 
						dataExport.write ("\t" + display); 
						}
					catch(propFail){propFail++}
				}                 

				// File Modified Date
				{
				try  {
					prop = singleFile.modified;                       
					var fullDate = new Date (prop);
					 var month = fullDate.getMonth() + 1;
					 if (month.toString().length < 2)
					{
						month = "0"+month;
					} 
					 var day = fullDate.getDate();
					   if (day.toString().length < 2)
					{
						day = "0"+day;
					}
					var year = fullDate.getFullYear();
					var time = fullDate.toTimeString().split(" GMT").join("");
					time= time.substr(0,10) + ":" + time.substr(10)
					var display = year+"-"+month+"-"+day+"T"+time                 
					dataExport.write ("\t" + display);   
					  }
			   catch(propFail){propFail++}
				}
						
			exportText (XMPConst.NS_DC, "format");   // TODO: find way to read directly from file

			// Export File Size (bytes)
			{
				try {
				   prop =  singleFile.length;                                
					var sizes = ["Bytes", "KB", "MB", "GB", "TB"];
					var i = parseInt(Math.floor(Math.log(prop) / Math.log(1024)));
					if (i == 0){
						prop = prop + " " + sizes[i];
						}
					else{
						prop = (prop / Math.pow(1024, i)).toFixed(1) + " " + sizes[i];
						}
					   dataExport.write ("\t" + prop);
				   }
				catch(propFail){propFail++}
				}
						  
			exportText (XMPConst.NS_EXIF, "PixelXDimension"); // TODO: find way to read directly from file
			exportText (XMPConst.NS_EXIF, "PixelYDimension"); // TODO: find way to read directly from file
			exportText (XMPConst.NS_TIFF, "BitsPerSample[1]"); // TODO: find way to read directly from file
			exportText (XMPConst.NS_TIFF, "Compression"); // TODO: find way to read directly from file

			// Export TIFF XResolution
			{  
				try  {
					Res = xmpData.getProperty( XMPConst.NS_TIFF, "XResolution") // TODO: find way to read directly from file
					// separate the value before the "/" from the value after it to do division
					var forwardSlashIndex = Res.toString().lastIndexOf ("/")
					// value before the "/"
					var pixels = Res.toString().substr(0,forwardSlashIndex);
					// value after the "/"
					var perInch = Res.toString().slice(forwardSlashIndex+1);
					// divide pixels by perInch and round to nearest integer
					prop = Math.round (pixels/perInch)

					if (prop){
						dataExport.write ("\t" + prop+" ppi");
						}
					else{
						dataExport.write ("\t");
						}
					}
				catch(propFail){propFail++}
				}   

			exportText (XMPConst.NS_TIFF, "Make");
			exportText (XMPConst.NS_TIFF, "Model");
			exportText (XMPConst.NS_TIFF, "Software");

			// Export PHOTOSHOP ColorMode
			{
				try {
					prop = xmpData.getProperty (XMPConst.NS_PHOTOSHOP, "ColorMode") // TODO: find way to read directly from file
					var mode = ["Bitmap", "Gray scale", "Indexed colour", "RGB colour", "CMYK colour", "Multi-channel", "Duotone", "LAB colour"];               
					if (prop){
						dataExport.write ("\t" + mode[prop]);
						}
					else{
						dataExport.write ("\t");
						}     
					}
				catch(propFail){propFail++}
				} 
							  
				// Export PHOTOSHOP ICCProfile (Color Profile)
				exportText (XMPConst.NS_PHOTOSHOP, "ICCProfile"); // TODO: find way to read directly from file

				// Export EXIF ColorSpace
				{
					try  {
						prop = xmpData.getProperty (XMPConst.NS_EXIF, "ColorSpace");
						var spec = ["1", "FFFF.H", "65535", "Other"]; 
						var label = ["sRGB", "Uncalibrated", "Uncalibrated", "reserved"];
						if (prop){
							for (var L1 = 0; L1 < spec.length; L1++){
								if (prop == spec[L1]){                                      
									dataExport.write ("\t" + label[L1]);
									}
								}
							}        
						else{
							dataExport.write ("\t");
							}
						}
					catch(propFail){propFail++}
					}

					// fail check  
				  if (propFail == 0)
						{
							filePass++;
						}
					} // End of overall try/catch for each image
				
				// outer fail check
				catch(fileFailArrError){
					fileFailArr.push(Thumb[L2].name.split ("%20").join (" "));
					} 
				} // end of  loop: if (Thumb[L2]){...
			}  // end of loop: for (var L2 = 0; L2 < Thumb.length; L2++){...

			// TODO: is this ever used?  where is "var W" used after it is created here?
            var W = "";
            if (hardDriveCheck != hardDrive){
                if (Folder.fs == "Windows"){
                    var X = hardDriveCheck.split ("/").join ("\\");
                    var Y = X.substring (2);
                    if (X.split ("\\")[0] == "~") var Z = "~\\";
                    else var Z = X.substring (1,2).toUpperCase() + ":";
                    }
                else {
                    var X = hardDriveCheck;
                    var Y = X.substring (1);
                    if (X.split ("/")[0] == "~") var Z = "~";
                    else var Z = "/";
                    }
                var W = "\n" + spot + "  Current Folder:\n" + spot + "  " + Z + Y;
                }
          
            } // end of 'Create and open the export file so it can recieve data'
        } // close brace 1 end of  if(exportWhich.thumbsRb.value == true && app.document.selections.length == 0)
	
		//  Hide exorting progress bar
		exportProgress.hide(); 
		// Show report that extraction is complete with directory path of .txt file
		var textFilePath = dataExport.toString().split ("%20").join (" ").split("/").join ("\\");
		var complete = new Window("dialog", "Export Complete");
        complete.spacing = 3;
		complete.alignChildren = 'center';		
		complete.header = complete.add('statictext', undefined, "Success!");
        complete.header .alignment = 'fill'
        complete.header .justify = 'center'
		complete.msg1 = complete.add('statictext', undefined, "Data has been Exported from "+filePass+" images and saved to:");
		complete.msg1.preferredSize = [400, 20]
		complete.msg1.justify = 'center';
		complete.msg2= complete.add('statictext', undefined, textFilePath, {multiline:true});
		complete.msg2.preferredSize = [400,100];
		complete.msg2.justify = 'center';
         
         complete.msg3 = complete.add('statictext', undefined, "The Custom field names option was selected,\nso only these field names were exported:", {multiline:true});
         complete.msg3.preferredSize = [0, 0]; //.preferredSize = [400, 40];
         complete.msg3.justify = 'center';     
         complete.msg4 = complete.add('edittext', undefined, customHeadersExported.join("\n"), {multiline:true});
         complete.msg4.preferredSize = [0, 0]; //.preferredSize = [250, 100];
         complete.msg4.justify = 'center';     	
        if(setHeaders.text == "Using Custom Field Names"){
            complete.msg3.minimumSize = [400, 40];
            complete.msg3.maximumSize = [400, 40];
            complete.msg4.minimumSize = [250, 200];
            complete.msg4.maximumSize = [250, 200];
            }
		// begin problems
		complete.problem = complete.add('group');
		complete.problem.orientation = 'column';	
		complete.problem.maximumSize = [0, 0];

		complete.problem.header = complete.problem.add('statictext', undefined, "But...");

		complete.problem.msg = complete.problem.add('statictext', undefined, "There was a problem exporting data from "+fileFailArr.length+" images.");
		complete.problem.btn=  complete.problem.add('button', undefined, "Which files?");
		complete.problem.btn.onClick = showProblems;
		complete.problem.msg2 = complete.problem.add('statictext', undefined, "The metadata structure may be invalid. Try opening and saving the file(s) in Photoshop and exporting again.", {multiline:true});
		complete.problem.msg2.minimumSize = [350, 40];
        complete.problem.msg2.maximumSize = [350, 40];

		function showProblems (){
			var problems = new Window('dialog', "Problems");
			complete.problem.files = problems.add('statictext', undefined, fileFailArr.join("\n"), {multiline:true});
			complete.problem.files.minimumSize = [300, 40];
             complete.problem.files.maximumSize = [300, 40];

			complete.okBtn = problems.add('button', undefined, "Continue");
			complete.okBtn.onClick =  function(){ 
				problems.hide();
				}
			problems.show();
			}
		// Continue button
		complete.okBtn = complete.add('button', undefined, "Continue");
		complete.okBtn.onClick =  function(){ 
			complete.hide();
			}
			} // close export brace 1
		complete.show();		
		// Close the file  "^"+projectName1+"_Data.txt"
		dataExport.close();
		}  // close "function exportToFile(){"
    

//////////////////////////////////////////////////////////////// END OF EXPORT FUNCTIONS ////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////// BEGINNING OF IMPORT FUNCTIONS ////////////////////////////////////////////////////////////////
function importFromFile(){
        var appDataPlgnSet = File (appDataFwdSlash + plgnPrefs + plgnOpt + plgnSet);
        appDataPlgnSet.open ("w", "TEXT", "ttxt");
        appDataPlgnSet.write (exportWhich.folderRb.value  + "|");
        appDataPlgnSet.write (exportWhich.subfoldersCb.value  + "|");  
        appDataPlgnSet.write (exportWhich.thumbsRb.value + "|");
        appDataPlgnSet.write (exportOptions.datesCb.value + "|");
        appDataPlgnSet.write (dataSource.text + "|");
        appDataPlgnSet.write (writeOptions.appendRb.value+ "|");
        appDataPlgnSet.write(writeOptions.overwriteRb.value + "|");
        appDataPlgnSet.write (IgnoreExtCb.value+ "|");
        appDataPlgnSet.write (fillSubjCb.value+ "|");
        appDataPlgnSet.write (fillCptCb.value+ "|");     
        appDataPlgnSet.write (addLabelCb.value+ "|");
        appDataPlgnSet.write (exportOptionsLfCb.value+"|");
        appDataPlgnSet.write (exportChoice+"|");
        appDataPlgnSet.write (exportWhich.folderEt.text + "|");
        appDataPlgnSet.write (imageLoc.text+ "|");
        appDataPlgnSet.write (imageLocSubfoldersCb.value+ "|");
        appDataPlgnSet.write (dataSourceOptions.Path.value+ "|");
        appDataPlgnSet.write (dataSourceOptions.Name.value+ "|");
        appDataPlgnSet.write (dataSourceOptions.enabled+ "|");
        appDataPlgnSet.write (IgnoreExtCb.enabled+ "|");
        appDataPlgnSet.write (fillHeadlineCb.value+ "|");
        appDataPlgnSet.write (customHeadersArray+ "|");
        appDataPlgnSet.write (buttonsChoice.defaultHeadersRb.value + "|");
        appDataPlgnSet.write (buttonsChoice.customHeadersRb.value + "|");
        appDataPlgnSet.write (mode);
        appDataPlgnSet.close();
    
		if (!imageLoc.text){
			app.beep();                  
			Window.alert ("ERROR: \nPlease select a folder of images");
			return false;
			}
	 
		 if (!dataSource.text){
			app.beep();                  
			Window.alert ("ERROR: \nPlease select a text file");
			return false;
			}

		// data source text file
		var textFileLoad = File (dataSource.text.split (" ").join ("%20"));
		// open the data text file
		var textFileLoad = File (textFileLoad);
		textFileLoad.open ('r');
		var textFile = textFileLoad.read().split ('\n');
		textFileLoad.close(); 
		var textFileHeaders = textFile[0].split ("\t");
		var selectedFolder = Folder(imageLoc.text.split (" ").join ("%20"));
		var allFiles = [];
		
/*TEST - show window with list of all file names in the import text file
var textFileNameArr = [];
            for (var L1 = 0; L1 < textFile.length; L1++) {
				 var textFileRead = textFile[L1].split ("\t")
				// if  there is a filename value, push each file name to an array to check for dupes
				if(textFileRead[0]){
				 textFileNameArr.push(textFileRead[0]);  
					}
				}
		textFileNameArr.push("END"); 
		// test info window	
		var testWindow = new Window('palette', "File names in import text file");
		var testMessage = testWindow.add('edittext', undefined, "",{multiline:true});
		testMessage.preferredSize = [300,500];
		testMessage.text = textFileNameArr.join('\n')
		testWindow.show()
*/	
		
		//  TODO: create report on which fields were and were not in the text file
		// open selectedFolder add the path of every file found to the 'allFiles' array. this will be the list of files to be exported
		function getFolder(selectedFolder) {
			var allFilesList = selectedFolder.getFiles();	 
			for (var L1 = 0; L1 < allFilesList.length; L1++) {
				var myFile = allFilesList[L1];
				if (myFile instanceof File && testFileExtension(myFile) == true && testFilePrefix(myFile) == true) {
					allFiles.push(myFile); 
					}
				}
			}

		// open selectedFolder and all subfolders and add the path of every file found to the 'allFiles' array. this will be the list of files to be exported
		function getSubFolders(selectedFolder) {
			 var allFilesList = selectedFolder.getFiles();		 
			 for (var L1 = 0; L1 < allFilesList.length; L1++) {
				  var myFile = allFilesList[L1];
				  if (myFile instanceof Folder){
					   getSubFolders(myFile);
				  }
				  if (myFile instanceof File && testFileExtension(myFile) == true && testFilePrefix(myFile) == true) {
					   allFiles.push(myFile); 
				  }
			 }	
		}
				
		// if "Include subfolders" is not checked, only read the files in the selected folder
		if (imageLocSubfoldersCb.value == false){
			locateFilesProgress.show();
			getFolder(selectedFolder);
			locateFilesProgress.hide();
			}

		// if "Include subfolders" is checked, read all the files in the selected folder and its subfolders 
		if (imageLocSubfoldersCb.value == true){
			locateFilesProgress.show();
			getSubFolders(selectedFolder);
			locateFilesProgress.hide();
			}
        
        //  if "Match on filename" is selected check that column B has a value, else show alert
        if (dataSourceOptions.Path.value == true){
            // check for existence of directory in text file column B
            var textFilePathBlank = 0;
            for (var L1 = 0; L1 < textFile.length; L1++) {
                var textFileRead = textFile[L1].split ('\t')
                if(!textFileRead[1]){
                    textFilePathBlank++;
                    }
                }          
            if (textFilePathBlank > 0){
                app.beep()
                Window.alert("Some items in your text file do not have a file path.\n\n"+
                "Your options are:\n"+
                " •  Check column 'B'  in your spreadsheet and\n"+
                "     add the missing path.\n"+
                " •  Use 'Match on Filename'.");
                return false;
                }
            }
        // if "include subfolders" is not selected, check .txt file for duplicate file names and, if any are found, display a list of them. 
        if(imageLocSubfoldersCb.value == false){
            var textFileNameArr = [];
            for (var L1 = 0; L1 < textFile.length; L1++) {
				 var textFileRead = textFile[L1].split ("\t")
				// if  there is a filename value, push each file name to an array to check for dupes
				if(textFileRead[0]){
				 textFileNameArr.push(textFileRead[0]);  
					}
				}
      //      var length = textFileNameArr.length,
            txtFileNameDupes=[],
            counts={};
            for (var L1=0; L1 < textFileNameArr.length; L1++) {
                var item = textFileNameArr[L1];
                var count = counts[item];
				
			//	if(counts[item].length>0){
                counts[item] = counts[item] >= 1 ? counts[item] + 1 : 1;
			//	}
                }
            for (var item in counts) {
                if(counts[item] > 1)
                  txtFileNameDupes.push(item);
                }          
            if(txtFileNameDupes.length > 0){    
                app.beep();
                var duplicatesFound = new Window('dialog', "Duplicates"); 
                duplicatesFound.alignChildren = 'left';
                var duplicatesFoundHeaderValue = "Duplicate filenames have been found, preventing the import from running."
                textDuplicatesHeader = duplicatesFound.add('statictext', [0, 0, 500, 20], duplicatesFoundHeaderValue);
		// test info window	
	//	var testMessage = duplicatesFound.add('edittext', [0,0,300,500], "",{multiline:true});
		
		
                // list of duplicates in text file
                textDuplicates = duplicatesFound.add('panel', undefined, "Duplicates in selected text file");
                textDuplicates.alignChildren = 'left';
                textDuplicates.spacing = 3;
                textFilePath = textDuplicates.add('statictext', [0,0,800,20], dataSource.text);
                textDuplicatesBtn = textDuplicates.add('button', undefined, "Save list of duplicates to desktop");
                textDuplicatesBtn.onClick = function(){
                    // Create a text file on the desktop with only the headers.  This can be used as a template in Excel to create properly formatted text for the import function
                    var dupesInText = "dupes_in_text_"+dateYMD+".txt"
                    // Create and open the file so it can recieve data
                    var duplicateImages = new File (desktop+dupesInText)                
                    duplicateImages.encoding = "UTF8";
                    duplicateImages.open ("w", "TEXT", "ttxt");   
                    // write .txt file path
                    duplicateImages.write ("DUPLICATES FOUND IN: "+dataSource.text+"\n\n");
                    // write paths and filenames to the .txt file
                    duplicateImages.write (txtFileNameDupes.join("\n"));
                    // Close the file
                    duplicateImages.hide();
                    duplicateImages.close();
                    Window.alert ("A new file named:\n\n"+dupesInText+"\n\nhas been created on your desktop.", "Success!")						
                    };
                var duplicatesOptionsValue = 
                "Your options are:\n"+
                "  •  Remove or change the duplicate filenames\n"+
                "  •  If your text file contains paths in column' A', select 'Match on path and filename'\n"+
                "  •  De-select the subfolders option\n"+
                "  •  Select a subfolder that has no duplicates\n"+
                "  •  Move duplicates so they are not in subfolders of the selected parent folder\n"+
                "  •  Rename duplicates";
                duplicatesOptions = duplicatesFound.add('statictext', [0, 0, 800, 120], duplicatesOptionsValue, {multiline:true});
                
            // Close button
            duplicatesFound.cancelBtn = duplicatesFound.add('button', undefined, "Close");
            duplicatesFound.cancelBtn.alignment = 'center';
            duplicatesFound.cancelBtn.onClick =  function(){ 
                duplicatesFound.hide();
                }
                duplicatesFound.show();
                return false; 
                }
            }
  
		// if "include subfolders" "Match on filename" are selected, check .txt file for duplicate file names and, if any are found, display a list of them. 
		if(imageLocSubfoldersCb.value == true && dataSourceOptions.Name.value == true){
			//  check filenames in text file column B for duplicate filenames
			var textFileNameArr = [];
            var textFilePathArr = [];
            var textFilePathBlank = 0;
			 for (var L1 = 0; L1 < textFile.length; L1++) {
				 var textFileRead = textFile[L1].split ("\t")
				// if  there is a filename value, push each file name to an array to check for dupes
				if(textFileRead[0]){
					 textFileNameArr.push(textFileRead[0]);  
					 }
				}  
		// run find duplicates against text file filenames array
		var length = textFileNameArr.length,
		txtFileNameDupes=[],
		counts={};
		for (var L1=0; L1 < length; L1++) {
			var item = textFileNameArr[L1];
			var count = counts[item];
			counts[item] = counts[item] >= 1 ? counts[item] + 1 : 1;
			}

		for (var item in counts) {
			if(counts[item] > 1)
			  txtFileNameDupes.push(item);
			}
			
		// check filenames in selected directory include subfolders for duplicate filenames
		// get just the file name from allFiles so we can compare it to the file name in the text file
		var fileNameArr = [];
		for (var L2 = 0; L2 < allFiles.length; L2++) {
		  if (Folder.fs == 'Windows'){
			var splicePathIndex = allFiles[L2].toString().lastIndexOf ("/")
			}
		else{
			var splicePathIndex = allFiles[L2].toString().lastIndexOf ("\\")
            var splicePathIndex = allFiles[L2].toString().lastIndexOf ("/")
			}
		var filenameOnly = allFiles[L2].toString().slice(splicePathIndex+1).split("%20").join(" ");
		fileNameArr.push(filenameOnly)
		}

		// run find duplicates against filenames array			 
		var len=fileNameArr.length,
		out=[],
		counts={};
		for (var L1=0;L1<len;L1++) {
			var item = fileNameArr[L1];
			var count = counts[item];
			counts[item] = counts[item] >= 1 ? counts[item] + 1 : 1;
			}

		for (var item in counts) {
			if(counts[item] > 1)
			  out.push(item);
			}

        if(out.length > 0 || txtFileNameDupes.length > 0){    
			var duplicatesWithPath = [];
			 for (var L1 = 0; L1 < out.length; L1++){ 
				for (var L2 = 0; L2 < allFiles.length; L2++){   
				  if(allFiles[L2].toString().match(RegExp (out[L1])) != null){
				     duplicatesWithPath.push(allFiles[L2]);	  
					}
				   }	  
				}   
            app.beep();
            var duplicatesFound = new Window('dialog', "Duplicates"); 
            duplicatesFound.alignChildren = 'left';
            var duplicatesFoundHeaderValue = "Duplicate filenames have been found, preventing the import from running."
            textDuplicatesHeader = duplicatesFound.add('statictext', [0, 0, 500, 20], duplicatesFoundHeaderValue);
// test info window	
		//var testMessage = duplicatesFound.add('edittext', [0,0,300,500], "",{multiline:true});
            // list of duplicates in text file
            if(txtFileNameDupes.length > 0){ 	
                textDuplicates = duplicatesFound.add('panel', undefined, "Duplicates in selected text file");
                textDuplicates.alignChildren = 'left';
                textDuplicates.spacing = 3;
                textFilePath = textDuplicates.add('statictext', [0,0,800,20], dataSource.text);
             //   textDuplicatesList = textDuplicates.add ('ListBox', [0, 0, 800, 150], txtFileNameDupes);
           //     textDuplicatesList = textDuplicates.add ('edittext', [0, 0, 800, 150], txtFileNameDupes.join("\n"), {multiline:true});
                textDuplicatesBtn = textDuplicates.add('button', undefined, "Save list of duplicates to desktop");
            textDuplicatesBtn.onClick = function(){
            // Create a text file on the desktop with only the headers.  This can be used as a template in Excel to create properly formatted text for the import function
            var dupesInText = "dupes_in_text_"+dateYMD+".txt"
            // Create and open the file so it can recieve data
            var duplicateImages = new File (desktop+dupesInText)                
            duplicateImages.encoding = "UTF8";
            duplicateImages.open ('w', 'XLS', 'XCEL');   
            // write .txt file path
            duplicateImages.write ("DUPLICATES FOUND IN: "+dataSource.text+"\n\n");
            // write paths ans filenames to the .txt file
            duplicateImages.write (txtFileNameDupes.join("\n"));
            // Close the file
            duplicateImages.hide();
            duplicateImages.close();
            Window.alert ("A new file named:\n\n"+dupesInText+"\n\nhas been created on your desktop.", "Success!")						
            };
        
     /*           var textDuplicatesOptionsValue = 
                "Your options are:\n"+
                "  •  Remove the duplicate filenames from your text file\n"+
                "  •  If your text file contains paths in column' A', select 'Match on path and filename'\n"+
                "  •  De-select the subfolders option\n"+
                "  •  Select a subfolder that has no duplicates\n"+
                "  •  Move duplicates so they are not in subfolders of the selected parent folder\n"+
                "  •  Rename duplicates";
                textDuplicatesOptions = textDuplicates.add('statictext', [0, 0, 800, 120], textDuplicatesOptionsValue, {multiline:true});
                */
                }
            // list of duplicates in folder include subfolders
            if(out.length > 0){	
                folderDuplicates = duplicatesFound.add('panel', undefined, "Duplicates in selected folder of image files");
                folderDuplicates.spacing = 3;
                folderDuplicates.alignChildren = 'left';
                folderPath = folderDuplicates.add('statictext', [0,0,800,20], imageLoc.text+" ... and subfolders");
            //    folderDuplicatesList = folderDuplicates.add ('ListBox', [0, 0, 800, 150], duplicatesWithPath);
                folderDuplicatesBtn = folderDuplicates.add('button', undefined, "Save list of duplicates to desktop");
                folderDuplicatesBtn.onClick = function(){
                // Create a text file on the desktop with only the headers.  This can be used as a template in Excel to create properly formatted text for the import function    
                var dupesInFolder = "dupes_in_folders_"+dateYMD+".txt"
                // Create and open the file so it can recieve data
                var duplicateImages = new File (desktop+dupesInFolder)                
                duplicateImages.encoding = "UTF8";
                duplicateImages.open ("w", "TEXT", "ttxt");
                
                // write paths ans filenames to the .txt file
                duplicateImages.write (duplicatesWithPath.join("\n"));
                // Close the file
                duplicateImages.hide();
                duplicateImages.close();
                Window.alert ("A new file named:\n\n"+dupesInFolder+"\n\nhas been created on your desktop.", "Success!")						
                };

             /*   var folderDuplicatesOptionsValue = 
                "Your options are:\n"+
                "  •  If your text file contains paths in column' A', select 'Match on path and filename'\n"+
                "  •  De-select the subfolders option\n"+
                "  •  Select a subfolder that has no duplicates\n"+
                "  •  Move duplicates so they are not in subfolders of the selected parent folder\n"+
                "  •  Rename duplicates";
                folderDuplicatesOptions = folderDuplicates.add('statictext', [0, 0, 800, 100], folderDuplicatesOptionsValue, {multiline:true});
                }*/
            var duplicatesOptionsValue = 
                "Your options are:\n"+
                "  •  Remove or change the duplicate filenames\n"+
                "  •  If your text file contains paths in column' A', select 'Match on path and filename'\n"+
                "  •  De-select the subfolders option\n"+
                "  •  Select a subfolder that has no duplicates\n"+
                "  •  Move duplicates so they are not in subfolders of the selected parent folder\n"+
                "  •  Rename duplicates";
                duplicatesOptions = duplicatesFound.add('statictext', [0, 0, 800, 120], duplicatesOptionsValue, {multiline:true});
                }
            // Close button
            duplicatesFound.cancelBtn = duplicatesFound.add('button', undefined, "Close");
            duplicatesFound.cancelBtn.alignment = 'center';
            duplicatesFound.cancelBtn.onClick =  function(){ 
                duplicatesFound.hide();
                }
             duplicatesFound.show();
             return false; 
             } // close if(out.length > 0 || txtFileNameDupes.length > 0)
         
        } // close if(imageLocSubfoldersCb.value == true)

	// Close the main UI window before running the import
	mainWindow.hide()



     // begin reading data from file
     { 	
	// Variables used for collecting pass/fail data for report
	var filePass = 0;
	var fileFail = 0;
	var fileFailArr = [];
	var couldNotOpen = [];
    var couldNotClose = [];
	var propFail = 0;
    var propFailName = [];
	var noMatch = [];
	var propPass = [];
    var customHeadersImported = []; 
	
for (var L0 = 0; L0 < fieldsDict.length; L0++){ 
	if(fieldsDict[L0].customHeader.length > 0){
		customHeadersImported.push(fieldsDict[L0].customHeader)
		}
	}
		// Progress bar window to show files are importing
		var importingProgress =  new Window ('palette', "Importing Metadata");
        importingProgress.alignChildren = 'center';
		importingProgress.preferredSize = [400,80];
		importingProgress.count = importingProgress.add('statictext', undefined, allFiles.length+" image files to proccess");
		importingProgress.progBar = importingProgress.add('progressbar', [0,20,390,40]);
	
    {
        for (var L3 = 0; L3 < allFiles.length; L3++){
			if ( allFiles.length > 50){
				importingProgress.progBar.value = Math.round ((L3 / allFiles.length) * 100);  
				  importingProgress.center();
				  importingProgress.show();
			 }

      //   if (allFiles[L3].hasMetadata)       
		 if (allFiles[L3]){         
		// Get the selected file
        var imageFile = allFiles[L3];

        try{
 // try to open file. if it fails, save file path in error log
try{
    // if file is an .xmp sidecar - read the xmp directly to an XMPMeta Object
    if(imageFile.name.match(/\.xmp/i) != null){
        var xmpFile = Folder (File(imageFile.fsName)); 
        xmpFile.open('r');  
        var xmpData = new XMPMeta(xmpFile.read());  
          xmpFile.close();  
        }
    else{
        // if file is not an .xmp sidecar pull XMP from file
        var xmpFile = new XMPFile(imageFile.fsName, XMPConst.UNKNOWN, XMPConst.OPEN_FOR_UPDATE);
        // convert to xmp
        var xmpData = xmpFile.getXMP();
        }
    }
catch(couldNotOpenError){}            

				// delete label before import begins  Data imported
				var prop = xmpData.getProperty (XMPConst.NS_XMP, "Label");		
				var patt1=new RegExp(""+projectName1+" metadata imported"); 	
			
				if (patt1.test(prop) == true){				
					xmpData.deleteProperty (XMPConst.NS_XMP, 'Label');	
					}
                
				// get just the file name from allFiles so we can compare it to the file name in the text file
				 if (Folder.fs == 'Windows'){
					var splicePathIndex = allFiles[L3].toString().lastIndexOf ("/")
					}
				else{
					var splicePathIndex = allFiles[L3].toString().lastIndexOf ("\\")
                       var splicePathIndex = allFiles[L3].toString().lastIndexOf ("/")
					}
				
				// get just the file directory
				var spliceDirectory = allFiles[L3].toString().slice(splicePathIndex+1).split("%20").join(" ");
				// get just the file name
				var spliceName = allFiles[L3].toString().slice(splicePathIndex+1).split("%20").join(" ");
	   
                    // read the tab delimited file
                for (var L4 = 1; L4 < textFile.length; L4++){                      
                    var textFileValue = textFile[L4].split ('\t');
                    if (IgnoreExtCb.value == true){		
                        var thumbName = spliceName.split ('.');						
                        thumbName.pop();
                        var thumbName = thumbName.join ('.');
                        var impFileName = textFileValue[0].split ('.');
                        impFileName.pop();
                        var impFileName = impFileName.join ('.');	
                        }         					 
                // if image file name matches the filename in the the first position of the text file array
                else{
                    var thumbName= spliceName;
                    var impFileName = textFileValue[0];
                    }       
             
    if(dataSourceOptions.Path.value == true){  
        var thumbName = allFiles[L3];
        var impFileName = textFileValue[1].split(" ").join("%20")+textFileValue[0].split(" ").join("%20");
        }         
// TODO: is .toLowerCase() neccessary for a match?
                 if (thumbName == impFileName){						 
// TODO: import is matched on column header value.  BUT, if a column is not in the spreadsheet, it will not be changed, including bad data that you want to be changed.  Should I give the user a warning or an option to clear all "+projectName1+" & IPTC fields for fresh import of only what is in their spreadsheet?	
	        	// get the array index of the specified header string
			if (typeof Array.prototype.indexOf != "function") {  
				Array.prototype.indexOf = function (el) {  
					for(var i = 0; i < this.length; i++) if(el === this[i]) return i;  
					return -1;  
					}  
                }

    // if XMP structures don't exist, create them so data can be added
        for (var L4a = 0; L4a < complexStruct.length; L4a++){         
            var countArr = xmpData.countArrayItems(complexStruct[L4a].namespace, complexStruct[L4a].path)
            if(countArr == 0){
                xmpData.setProperty (complexStruct[L4a].namespace, complexStruct[L4a].path, "", complexStruct[L4a].arrType);
                }  
                 // create nested XMP structure
        for(var L4b = 0; L4b < complexStruct[L4a].subArr.length; L4b++){
            var countSubsubArr = xmpData.countArrayItems(complexStruct[L4a].subArr[L4b].namespace,complexStruct[L4a].subArr[L4b].path) 
             if(countSubsubArr == 0){
                xmpData.setProperty (complexStruct[L4a].subArr[L4b].namespace, complexStruct[L4a].subArr[L4b].path, "", complexStruct[L4a].arrType);
                }
			}
            }
  // force custom headers choice to be default, since we aren't shoinw the custom screen in this version.        
    buttonsChoice.customHeadersRb.value = false	
        
 // import text and complexStruct	
                for (var L12 = 0; L12 < fieldsDict.length; L12++){   
                    var textHeader = "";
                    if(fieldsDict[L12].type == 'text' || fieldsDict[L12].type == 'complexStruct'){
                        try{		
                            // if customHeader length > 0, use it and path  
                            if (buttonsChoice.customHeadersRb.value == true){
                                if(fieldsDict[L12].customHeader.length > 0){
                                    textHeader = fieldsDict[L12].customHeader                                
                                    }                              
                                }            
                            // else use default header and path
                            else{
                                textHeader = fieldsDict[L12].header
                                }		
                            // run the import
                            if(textHeader.length > 0){	// add else with alert 'No matching headers fo
                                var prop = xmpData.getProperty(fieldsDict[L12].namespace, fieldsDict[L12].path);  							
                                var index = textFileHeaders.indexOf(textHeader)
                               if(index > 0){
						//	customHeadersImported.push(fieldsDict[L12].customHeader)	         
                                if (writeOptions.overwriteRb.value == true){                                  
                      //    xmpData.deleteProperty(fieldsDict[L12].namespace, fieldsDict[L12].path);         
                                //    if (textFileValue[index].length > 0){        
							 // 	xmpData.setProperty (fieldsDict[L12].namespace, fieldsDict[L12].path, "XXX");
							 var val = textFileValue[index].split("(LF)").join("\n").split("(CR)").join("\r").split("(HT)").join("\t").split("\"").join("")
							 if(!textFileValue[index]){val =" "}
                                 xmpData.setProperty (fieldsDict[L12].namespace, fieldsDict[L12].path, val);
                                   //     }
                                    }
                                else if (prop == undefined && textFileValue[index].length > 0){
                                   xmpData.setProperty (fieldsDict[L12].namespace, fieldsDict[L12].path, textFileValue[index].split("(LF)").join("\n").split("(CR)").join("\r").split("(HT)").join("\t").split("\"").join(""));
                                    } 						
								// for simple text propos only, delete prop if value == " "
                                if(fieldsDict[L12].type == 'text' && val == " "){
                                     xmpData.deleteProperty(fieldsDict[L12].namespace, fieldsDict[L12].path);
                                    }
								propPass.push(textHeader)
                            } // close if(textHeader.length > 0)
                        }        
                                } // close try
                                catch(propFail){propFail++, propFailName.push(path)}
                        }	// close if(fieldsDict[L12].type == 'complexStruct')
                    } // close import complexStruct
   
// clean up complex structures
// array items and sub-arrays must be deleted in reverse order, so loop in reverse - if value == " " delete item, then if no more items, delete prop
for (var L1 = 0; L1 < complexStruct.length; L1++){
	// check subArr reverse order
	for(var L2a=complexStruct[L1].subArr.length - 1; L2a >= 0;L2a--){
        countSubsubArr = xmpData.countArrayItems(complexStruct[L1].subArr[L2a].namespace,complexStruct[L1].subArr[L2a].path)
		for(var L2b=countSubsubArr - 1; L2b >= 0;L2b--){
             if(xmpData.getProperty(complexStruct[L1].subArr[L2a].namespace,complexStruct[L1].subArr[L2a].path+"["+(L2b+1)+"]") == " "){
                 xmpData.deleteProperty(complexStruct[L1].subArr[L2a].namespace,complexStruct[L1].subArr[L2a].path+"["+(L2b+1)+"]")
                 }
             // if sub prop has no items, delete it
             if(xmpData.countArrayItems(complexStruct[L1].subArr[L2a].namespace,complexStruct[L1].subArr[L2a].path)== 0){
                  xmpData.deleteProperty(complexStruct[L1].subArr[L2a].namespace,complexStruct[L1].subArr[L2a].path)
                }
            } // end for(var L2b=countSubsubArr
        } // end for(var L2a=complexStruct[L1].subArr.length
      /* give up on deleting empty structured properties.  this section works, but AO doesn't.  can't find a way to count the number of properties in a simple struct - bag [1]                          
           try{
               var countStructProp = complexStruct[L1].structProp.length
               var noValue = 0
               for (var L2c = 0; L2c < countStructProp; L2c++){   
              if(xmpData.getProperty(complexStruct[L1].structProp[L2c].namespace, complexStruct[L1].structProp[L2c].path) == undefined){
                  noValue ++
                  }
              if(noValue == countStructProp){
                  xmpData.deleteProperty(complexStruct[L1].namespace, complexStruct[L1].path) 
                  }
              }
              }
          catch (e){}
          // delete structProp parent
			if(xmpData.countArrayItems(complexStruct[L1].namespace, complexStruct[L1].path) == 0){
			  xmpData.deleteProperty(complexStruct[L1].namespace, complexStruct[L1].path) 
				}
            */
    } // end for (var L1 = 0; L1

/* give up on deleting empty structured properties
	  // if parent structure has one item and that has  no sub-properties, delete it
       try{
	for(var L3 = 0; L3 < complexStruct.length; L3++){
           if(xmpData.getProperty(complexStruct[L3].namespace, complexStruct[L3].path+"[1]") == ""){ //problem! catching all arrays need to see if array item [1] has no properties in it
        //  xmpData.deleteProperty(complexStruct[L3].namespace, complexStruct[L3].path) 
            }
        } // end for(var L3 = 0; L3
    }
	catch (e){}	
    */
         /*        // import text	
                for (var L5 = 0; L5 < fieldsDict.length; L5++){   
                    var textHeader = "";
                    if(fieldsDict[L5].type == 'text'){
                        try{		
                            // if customHeader length > 0, use it and path  
                            if (buttonsChoice.customHeadersRb.value == true){
                                if(fieldsDict[L5].customHeader.length > 0){
                                    textHeader = fieldsDict[L5].customHeader                                
                                    }                              
                                }            
                            // else use default header and path
                            else{
                                textHeader = fieldsDict[L5].header
                                }		
                            // run the import
                            if(textHeader.length > 0){	// add else with alert 'No matching headers fo
                                var prop = xmpData.getProperty(fieldsDict[L5].namespace, fieldsDict[L5].path);  							
                                var index = textFileHeaders.indexOf(textHeader)
                               if(index > 0){
						//	customHeadersImported.push(fieldsDict[L5].customHeader)	         
                                if (writeOptions.overwriteRb.value == true){                                  
                          xmpData.deleteProperty(fieldsDict[L5].namespace, fieldsDict[L5].path);         
                                    if (textFileValue[index].length > 0){                                      
                                   xmpData.setProperty (fieldsDict[L5].namespace, fieldsDict[L5].path, textFileValue[index].split("(LF)").join("\n").split("(CR)").join("\r").split("(HT)").join("\t").split("\"").join(""));
                                        }
                                    }
                                else if (prop == undefined && textFileValue[index].length > 0){
                                   xmpData.setProperty (fieldsDict[L5].namespace, fieldsDict[L5].path, textFileValue[index].split("(LF)").join("\n").split("(CR)").join("\r").split("(HT)").join("\t").split("\"").join(""));
                                    } 
								propPass.push(textHeader)
                            } // close if(textHeader.length > 0)
                        }        
                                } // close try
                                catch(propFail){propFail++, propFailName.push(path)}
                        }	// close if(fieldsDict[L5].type == 'text')
                    } // close import text
*/
                    // import date	
                    for (var L6 = 0; L6 < fieldsDict.length; L6++){    
                        var dateHeader = "";
                        if(fieldsDict[L6].type == 'date'){
                            try{ 
                                // if customHeader length > 0, use it and path  
                                if (buttonsChoice.customHeadersRb.value == true){
                                    if(fieldsDict[L6].customHeader.length > 0){
                                        dateHeader = fieldsDict[L6].customHeader
                                       
                                        }                                      
                                    }            
                                // else use default header and path
                                else{
                                    dateHeader = fieldsDict[L6].header
                                    }		
                                // run the import
                                if(dateHeader.length > 0){	// add else with alert 'No matching headers found		
                                    var index = textFileHeaders.indexOf(dateHeader)	             
                                       if(index > 0){
									//	 customHeadersImported.push(fieldsDict[L6].customHeader)    
                                        if (writeOptions.overwriteRb.value == true){
                                            xmpData.deleteProperty(fieldsDict[L6].namespace, fieldsDict[L6].path);
                                            if (textFileValue[index].length > 0){
                                                xmpData.setProperty (fieldsDict[L6].namespace, fieldsDict[L6].path, textFileValue[index].split ('_').join (""));
                                                }
                                            }
                                        else if (prop == undefined && textFileValue[index].length > 0){
                                            xmpData.setProperty (fieldsDict[L6].namespace, fieldsDict[L6].path, textFileValue[index].split ('_').join (""));
                                            }
										propPass.push(dateHeader)   
                                    } // close if(dateHeader.length > 0)
                                }                                             
                                } // close try
                                    catch(propFail){propFail++, propFailName.push(path)}
                            }	// close if(fieldsDict[L6].type == 'date')
                        } // close import date
                                        
					// import langAlt arrays	
					for (var L7 = 0; L7 < fieldsDict.length; L7++){    
						var langAltHeader = "";
						if(fieldsDict[L7].type == 'langAlt' || fieldsDict[L7].type == 'langAltDcTitle'){
							try{ 
								// if customHeader length > 0, use it and path  
								if (buttonsChoice.customHeadersRb.value == true){
									if(fieldsDict[L7].customHeader.length > 0){
										langAltHeader = fieldsDict[L7].customHeader
										}
									}            
								// else use default header and path
								else{
									langAltHeader = fieldsDict[L7].header
									}		
								// run the import
								if(langAltHeader.length > 0){	// add else with alert 'No matching headers found		
									var index = textFileHeaders.indexOf(langAltHeader)	
									var count = xmpData.countArrayItems(fieldsDict[L7].namespace, fieldsDict[L7].path);
												var prop = textFileValue[index].split('\"').join("");		
												if(index > 0){
												if (writeOptions.overwriteRb.value == true){
													 xmpData.deleteProperty(fieldsDict[L7].namespace, fieldsDict[L7].path);  
													 if (textFileValue[index].length > 0){
													 xmpData.appendArrayItem (fieldsDict[L7].namespace, fieldsDict[L7].path, prop, 0, XMPConst.ALIAS_TO_ALT_TEXT);
													xmpData.setQualifier    (fieldsDict[L7].namespace, fieldsDict[L7].path + '[1]', NS_W3, "lang", "x-default");
													}
												}
												else
													 if (count == 0 && textFileValue[index].length > 0){
														  xmpData.appendArrayItem (fieldsDict[L7].namespace, fieldsDict[L7].path, prop, 0, XMPConst.ALIAS_TO_ALT_TEXT);
														  xmpData.setQualifier (fieldsDict[L7].namespace, fieldsDict[L7].path + '[1]', NS_W3, "lang", "x-default");
													 }
									if (writeOptions.overwriteRb.value == true){
											}
										propPass.push(langAltHeader)
									} // close if(langAltHeader.length > 0)
								}						
								} // close try
									catch(propFail){propFail++, propFailName.push(path)}
							}	// close if(fieldsDict[L7].type == 'langAlt')
						} // close import langAlt arrays

                        // import bag arrays	
                        for (var L8 = 0; L8 < fieldsDict.length; L8++){    
                            var bagHeader = "";
                            if(fieldsDict[L8].type == 'bag'){
                                try{ 
                                    // if customHeader length > 0, use it and path  
                                    if (buttonsChoice.customHeadersRb.value == true){
                                        if(fieldsDict[L8].customHeader.length > 0){
                                            bagHeader = fieldsDict[L8].customHeader
                                            }
                                        }            
                                    // else use default header and path
                                    else{
                                        bagHeader = fieldsDict[L8].header
                                        }	
                                    // run the import
                                    if(bagHeader.length > 0){	// add else with alert 'No matching headers found		
                                        var index = textFileHeaders.indexOf(bagHeader)
                                         if(index > 0){
                                        if (writeOptions.overwriteRb.value == true){
                                                var count = xmpData.countArrayItems (fieldsDict[L8].namespace, fieldsDict[L8].path); 
                                                if (writeOptions.overwriteRb.value == true){
                                                    xmpData.deleteProperty(fieldsDict[L8].namespace, fieldsDict[L8].path);   
                                                    if (textFileValue[index].length > 0){
                                                        xmpData.setProperty (fieldsDict[L8].namespace, fieldsDict[L8].path, "", XMPConst.ARRAY_IS_UNORDERED);
                                                        var prop = textFileValue[index].split ('"').join ("").split('; ').join(';').split (';');
                                                        for (var L1 = 1; L1 < (prop.length + 1); L1++)
                                                        xmpData.setProperty (fieldsDict[L8].namespace, fieldsDict[L8].path + '[' + L1 + ']', prop[L1 - 1]);
                                                        }
                                                    }
                                                else
                                                if (count == 0 && textFileValue[index].length > 0){
                                                        xmpData.setProperty (fieldsDict[L8].namespace, fieldsDict[L8].path, "", XMPConst.ARRAY_IS_UNORDERED);
                                                        var prop = textFileValue[index].split ('"').join ("").split('; ').join(';').split (';');
                                                        for (var L1 = 1; L1 < (prop.length + 1); L1++)
                                                        xmpData.setProperty (fieldsDict[L8].namespace, fieldsDict[L8].path + '[' + L1 + ']', prop[L1 - 1]);
                                                        }
                                                    } 
                                            propPass.push(bagHeader)	
                                        } // close if(bagHeader.length > 0)
                                    }
                                
                                    } // close try
                                        catch(propFail){propFail++, propFailName.push(path)}
                                }	// close if(fieldsDict[L8].type == 'bag')
                            } // close import bag arrays

// import seq arrays	
for (var L9 = 0; L9 < fieldsDict.length; L9++){    
	var seqHeader = "";
	if(fieldsDict[L9].type == 'seq'){
		try{ 
			// if customHeader length > 0, use it and path  
			if (buttonsChoice.customHeadersRb.value == true){
				if(fieldsDict[L9].customHeader.length > 0){
					seqHeader = fieldsDict[L9].customHeader
					}
				}            
			// else use default header and path
			else{
				seqHeader = fieldsDict[L9].header
				}		
			// run the import
			if(seqHeader.length > 0){	// add else with alert 'No matching headers found		
				var index = textFileHeaders.indexOf(seqHeader)
				 if(index > 0){
				if (writeOptions.overwriteRb.value == true){
					if (writeOptions.overwriteRb.value == true){
									xmpData.deleteProperty(fieldsDict[L9].namespace, fieldsDict[L9].path);       
									if (textFileValue[index].length > 0){
										xmpData.setProperty (fieldsDict[L9].namespace, fieldsDict[L9].path, "", XMPConst.ARRAY_IS_ORDERED);
										var prop = textFileValue[index].split ('"').join ("").split('; ').join(';').split (';');
										for (var L1 = 1; L1 < (prop.length + 1); L1++)
										xmpData.setProperty (fieldsDict[L9].namespace, fieldsDict[L9].path + '[' + L1 + ']', prop[L1 - 1]);
										}
									}
								else
								if (count == 0 && textFileValue[index].length > 0){
									xmpData.setProperty (fieldsDict[L9].namespace, fieldsDict[L9].path, "", XMPConst.ARRAY_IS_ORDERED);
									var prop = textFileValue[index].split ('"').join ("").split('; ').join(';').split (';');
									for (var L1 = 1; L1 < (prop.length + 1); L1++)
									xmpData.setProperty (fieldsDict[L9].namespace, fieldsDict[L9].path + '[' + L1 + ']', prop[L1 - 1]);
									}
					}
				propPass.push(seqHeader)
				} // close if(seqHeader.length > 0)
			}		
			} // close try
				catch(propFail){propFail++, propFailName.push(path)}
		}	// close if(fieldsDict[L9].type == 'seq')
	} // close import seq arrays


// import Summary DC Headline
for (var L10 = 0; L10 < fieldsDict.length; L10++){    
	var dcHeadlineHeader = "";
	if(fieldsDict[L10].header == 'Image:Headline'){
        try{
		// if customHeader length > 0, use it and path  
		if (buttonsChoice.customHeadersRb.value == true){
			if(fieldsDict[L10].customHeader.length > 0){
                    dcHeadlineHeader = fieldsDict[L10].customHeader				
				}
			// if equiv of vra creator exists, use it for concat
			for (var L10a = 0; L10a < fieldsDict.length; L10a++){  
				if(fieldsDict[L10a].header =="A/O:Creator 1 Name"){
					var concat1 = textFileHeaders.indexOf(fieldsDict[L10a].customHeader)//textFileHeaders[L10a]
					}
				}
				// if equiv of vra creator exists, use it for concat
				for (var L10b = 0; L10b < fieldsDict.length; L10b++){  
				if(fieldsDict[L10b].header =="A/O:Title"){
					var concat2 = textFileHeaders.indexOf(fieldsDict[L10b].customHeader)//textFileHeaders[L10b]
					}
				}
			}            
		// else use default header and path
		else{
                dcHeadlineHeader = fieldsDict[L10].header
                for (var L10a = 0; L10a < fieldsDict.length; L10a++){  
				if(fieldsDict[L10a].header =="A/O:Creator 1 Name"){
					var concat1 = textFileHeaders.indexOf(fieldsDict[L10a].header)
                    }
                }
                for (var L10b = 0; L10b < fieldsDict.length; L10b++){  
				if(fieldsDict[L10b].header =="A/O:Title"){
					var concat2 = textFileHeaders.indexOf(fieldsDict[L10b].header)
					}
                }
			}
		// run the import
		 if(dcHeadlineHeader.length > 0 || (buttonsChoice.customHeadersRb.value == true && fillHeadlineCb.value == true)){
			 var index = textFileHeaders.indexOf(dcHeadlineHeader)
            var count = xmpData.getProperty(XMPConst.NS_PHOTOSHOP, "Headline").length;
		  var prop = textFileValue[index].split('(LF)').join('\n') .split ('(CR)').join ('\r').split('(HT)').join('\t').split('\"').join("");			  
		  var createDescArray1 = [textFileValue[concat1], textFileValue[concat2]] ;
		  var createDescArray = []
		  for(var L1 = 0; L1<createDescArray1.length; L1++){
									if(createDescArray1[L1]){
										createDescArray.push(createDescArray1[L1])
									}	
								}
								_headline = createDescArray.join(', ');
				 if(index > 0){												
				if (writeOptions.overwriteRb.value == true){
						 xmpData.deleteProperty(XMPConst.NS_PHOTOSHOP, "Headline");               
						 if (textFileValue[index].length > 0 || _headline.length > 0){
						if (fillHeadlineCb.value == true){											
							xmpData.setProperty (XMPConst.NS_PHOTOSHOP, "Headline", _headline);
							}
						else{												 
							xmpData.setProperty (XMPConst.NS_PHOTOSHOP, "Headline", _headline);
							}
					}
				}
					else
						 if (count == 0 && textFileValue[index].length > 0 || count == 0 && _headline.length > 0){
							  if (fillHeadlineCb.value == true){											
								xmpData.setProperty (XMPConst.NS_PHOTOSHOP, "Headline", _headline);
							}
						else{												 
							 xmpData.setProperty (XMPConst.NS_PHOTOSHOP, "Headline", _headline);
							}
						 }		
					propPass.push(dcHeadlineHeader)
                }  // close  if(dcHeadlineHeader.length > 0){
			}
		} // close try
		catch(propFail){propFail++, propFailName.push(path)}
		} // close if(fieldsDict[L10].header == 'Image:Headline')
	} // close for (var L10 = 0; L10 < fieldsDict.length; L10++)
// here!						
// import Summary Description/Caption	
for (var L11 = 0; L11 < fieldsDict.length; L11++){    
	var dcDescrHeader = "";
	if(fieldsDict[L11].type == 'langAltDcDescription'){
        try{
		// if customHeader length > 0, use it and path  
		if (buttonsChoice.customHeadersRb.value == true){
			if(fieldsDict[L11].customHeader.length > 0){
                    dcDescrHeader = fieldsDict[L11].customHeader
				}
			}            
		// else use default header and path
		else{
                 dcDescrHeader = fieldsDict[L11].header
                var concat1 = textFileHeaders.indexOf("A/O:Creator 1 Name")
                var concat2 = textFileHeaders.indexOf("A/O:Creator 2 Name")
                var concat3 = textFileHeaders.indexOf("A/O:Creator 3 Name")
                var concat4 = textFileHeaders.indexOf("A/O:Title")
                if(textFileValue[textFileHeaders.indexOf("A/O:Circa Date Created")]){
                    var concat5 = textFileHeaders.indexOf("A/O:Circa Date Created")
                    }
                else{
                    var concat5 = textFileHeaders.indexOf("A/O:Date Created")
                    }
                var concat6 = textFileHeaders.indexOf("A/O:Style/Period")
                var concat7 = textFileHeaders.indexOf("A/O:Contribution Description")
                var concat8 = textFileHeaders.indexOf("A/O:Source Name")
                var concat9 = textFileHeaders.indexOf("A/O:Source Inventory Number")
                var concat10 = textFileHeaders.indexOf("A/O:Copyright Notice")
			}
		// run the import	
        //remove "_" from beginning of date
		var cleanDate = textFileValue[concat5].split("_").join("")
		 if(dcDescrHeader.length > 0){
			 var index = textFileHeaders.indexOf(dcDescrHeader)
			 var count = xmpData.countArrayItems(XMPConst.NS_DC, "description");
          var prop = textFileValue[index].split('(LF)').join('\n') .split ('(CR)').join ('\r').split('(HT)').join('\t').split('\"').join("");
            var createDescArray  = [textFileValue[concat1], textFileValue[concat2], textFileValue[concat3], textFileValue[concat4], cleanDate, textFileValue[concat6], textFileValue[concat7], textFileValue[concat8], textFileValue[concat9], textFileValue[concat10]];	

            for(var L1 = 0; L1<createDescArray.length; L1++){
                if(createDescArray[L1] == ""){
                    createDescArray.splice(L1, 1); L1--;
                }	
            }   

                var  _desc = createDescArray.join('; ').split('(LF)').join('\n') .split ('(CR)').join ('\r').split('(HT)').join('\t').split('\"').join("");	
			 if(index > 0){	
            if (writeOptions.overwriteRb.value == true){
                     xmpData.deleteProperty(XMPConst.NS_DC, "description");               
                     if (textFileValue[index].length > 0 || _desc.length > 0){
                    if (fillCptCb.value == true){	
                        xmpData.appendArrayItem (XMPConst.NS_DC, "description", _desc, 0, XMPConst.ALIAS_TO_ALT_TEXT);
                        xmpData.setQualifier (XMPConst.NS_DC, "description" + '[1]', NS_W3, "lang", "x-default");	
                        }
                    else{												 
                        xmpData.appendArrayItem (XMPConst.NS_DC, "description", prop, 0, XMPConst.ALIAS_TO_ALT_TEXT);
                        xmpData.setQualifier    (XMPConst.NS_DC, "description" + '[1]', NS_W3, "lang", "x-default");
                        }
                }
            }
                else
                     if (count == 0 && textFileValue[index].length > 0 || count == 0 && _desc.length > 0){
                          if (fillCptCb.value == true){											
                            xmpData.appendArrayItem (XMPConst.NS_DC, "description", _desc, 0, XMPConst.ALIAS_TO_ALT_TEXT);
                            xmpData.setQualifier (XMPConst.NS_DC, "description" + '[1]', NS_W3, "lang", "x-default");	
                        }
                    else{												 
                         xmpData.appendArrayItem (XMPConst.NS_DC, "description", prop, 0, XMPConst.ALIAS_TO_ALT_TEXT);
                         xmpData.setQualifier    (XMPConst.NS_DC, "description" + '[1]', NS_W3, "lang", "x-default");
                        }
                     }
				 propPass.push(dcDescrHeader)
                }  // close  if(dcDescrHeader.length > 0){
			}		
        	} // close try
		catch(propFail){propFail++, propFailName.push(path)}
		} // close if(fieldsDict[L11].type == 'langAltDcDescription'){
	} // close import Summary Description/Caption						
						
						// import Summary Keywords	
for (var L12 = 0; L12 < fieldsDict.length; L12++){    
	var dcSubjectHeader = "";
	if(fieldsDict[L12].type == 'bagDcSubject'){
        try{
		// if customHeader length > 0, use it and path  
		if (buttonsChoice.customHeadersRb.value == true){
			if(fieldsDict[L12].customHeader.length > 0){
                    dcSubjectHeader = fieldsDict[L12].customHeader
				}
			}            
		// else use default header and path
		else{
                dcSubjectHeader = fieldsDict[L12].header
                var concat1 = textFileHeaders.indexOf("A/O:Creator 1 Name")
				var concat2 = textFileHeaders.indexOf("A/O:Creator 2 Name")
				var concat3 = textFileHeaders.indexOf("A/O:Creator 3 Name")
				var concat4 = textFileHeaders.indexOf("A/O:Style/Period")
			}
		// run the import
		if(dcSubjectHeader.length > 0){
			var index = textFileHeaders.indexOf(dcSubjectHeader)
			var prop = textFileValue[index].split ('"').join ('').split ('; ').join(';').split (';');
			var count = xmpData.countArrayItems (XMPConst.NS_DC, 'subject');         
			var createKeywordsArray  = [textFileValue[concat1], textFileValue[concat2], textFileValue[concat3], textFileValue[concat4]];              
			keywordsString = "X"
			keywords = []
			for(var L1 = 0; L1<createKeywordsArray.length; L1++){
						if(createKeywordsArray[L1]){
						 keywordsString = keywordsString+"; "+createKeywordsArray[L1].toString() ;
						}                          
					 } 	 
			keywords = keywordsString.split ('"').join ('').split('X; ').join('').split("; ")	 	
			 if(index > 0){	
					if (writeOptions.overwriteRb.value == true){
						xmpData.deleteProperty(XMPConst.NS_DC, 'subject'); 
						 if (textFileValue[index].length > 0 || keywords.length > 0){
							xmpData.setProperty (XMPConst.NS_DC, 'subject', "", XMPConst.ARRAY_IS_UNORDERED);
							if (fillSubjCb.value == true){
								for (var L1 = 0; L1 < keywords.length; L1++)
								xmpData.setProperty (XMPConst.NS_DC, 'subject' + '[' + (L1+1) + ']', keywords[L1]);		
							}
							else{	
								for (var L1 = 1; L1 < (prop.length + 1); L1++)
								xmpData.setProperty (XMPConst.NS_DC, 'subject' + '[' + L1 + ']', prop[L1 - 1]);
							}
						}
					}
					else if (count == 0 && textFileValue[index].length > 0 || count == 0 && keywords.length > 0){
					   xmpData.setProperty (XMPConst.NS_DC, 'subject', "", XMPConst.ARRAY_IS_UNORDERED);
					   if (fillSubjCb.value == true){
							for (var L1 = 0; L1 < keywords.length; L1++)
							  xmpData.setProperty (XMPConst.NS_DC, 'subject' + '[' + (L1+1) + ']', keywords[L1]);												
						}                                       
						else{	
							for (var L1 = 1; L1 < (prop.length + 1); L1++)
							xmpData.setProperty (XMPConst.NS_DC, 'subject' + '[' + L1 + ']', prop[L1 - 1]);
						}
					}		
				propPass.push(dcSubjectHeader)
			} // close if(dcSubjectHeader.length > 0){
		}
		} // close try
		catch(propFail){propFail++, propFailName.push(path)}
		} // close if(fieldsDict[L10].type == 'langAltDcDescription'){
	} // close import Summary Keywords
						
						
                                 // Set white label to indicate data was imported
                                var prop = xmpData.getProperty (XMPConst.NS_XMP, "Label");
                                try{
                                    if (addLabelCb.value == true){
                                        xmpData.setProperty (XMPConst.NS_XMP, "Label", projectName1+" metadata imported");	 		
                                        }
                                   }
                                      catch(propFail){propFail++, propFailName.push(path)}

                                // if any property failed to import, add the filename to the fileFailArr so it can be reported at the end
                                if(propPass.length == 0){
                                   fileFailArr.push(allFiles[L3]);
                                    }
                                else{
                                    filePass++;
                                    }
 
     
// Write save file and close	
try{
// todo - write .xmp differently
// if file is an .xmp sidecar - read the xmp directly to an XMPMeta Object
if(imageFile.name.match(/\.xmp/i) != null){
xmpFile.open('w'); 
xmpFile.close()
xmpFile.open('w')
xmpFile.write(xmpData.serialize(XMPConst.SERIALIZE_OMIT_PACKET_WRAPPER));
xmpFile.close()
    }
else{     
    if (xmpFile.canPutXMP(xmpData)) {
        xmpFile.putXMP(xmpData);
        }
    xmpFile.closeFile(XMPConst.CLOSE_UPDATE_SAFELY);	
    }
}
catch(couldNotCloseError){couldNotClose.push(allFiles[L3])}             
				
                    }		
                 } // close the loop: for (var L4 = 1; L4 < textFile.length; L4++)   
            } // also tried on line 1392
		catch(couldNotOpenError){couldNotOpen.push(imageFile.fsName)}    
               } // close the loop: if (allFiles[L3])	
             } // close the loop: for (var L3 = 0; L3 < allFiles.length; L3++) 

		    // hide the progress bar
            importingProgress.hide();    
			var failMesg = ""
			// set fail message vale
			if(customHeadersImported.length==0 && buttonsChoice.customHeadersRb.value == true){
				   failMesg = "The Custom field names option was selected,\nbut none were found.\n\nCheck your import file or select the Default field names option"
				   }
			else{
				failMesg = "No matching files were found.\n\nFiles are matched by file name.\n\nMake sure the folder you have selected contains the image file names in yout metadata text file."
				}
				   
			// Show results of Import
			  if (filePass == 0){
				   app.beep()
					   Window.alert(failMesg)
                }
			else{     
                    // Show report that import is complete
                    var complete = new Window("dialog", "Import Complete"); 
                //    complete.preferredSize = [400,400];
                    complete.spacing = 3;
                    complete.alignChildren = 'center';
                    complete.header = complete.add('statictext', undefined, "Success!");
                    complete.msg1= complete.add('statictext', undefined, "Data has been successfully imported for " + filePass + " files.");
                    complete.msg1.preferredSize = [400,40];
                     complete.msg1.justify = 'center';
                     
                     complete.msg3 = complete.add('statictext', undefined, "The Custom field names option was selected,\nso only these field names were imported:", {multiline:true});
                     complete.msg3.preferredSize = [0, 0]; //.preferredSize = [400, 40];
                     complete.msg3.justify = 'center';     
                     complete.msg4 = complete.add('edittext', undefined, customHeadersImported.join("\n"), {multiline:true});
                     complete.msg4.preferredSize = [0, 0]; //.preferredSize = [250, 100];
                     complete.msg4.justify = 'center';     	
                    if(setHeaders.text == "Using Custom Field Names"){
                        complete.msg3.minimumSize = [400, 40];
                        complete.msg3.maximumSize = [400, 40];
                        complete.msg4.minimumSize = [250, 200];
                        complete.msg4.maximumSize = [250, 200];
                        }

                    // List of files that could not be opened to write metadata
                    complete.problem1 = complete.add('group');
                    complete.problem1.orientation = 'column';	
                    complete.problem1.maximumSize = [0,0];
                    complete.problem1.header = complete.problem1.add('statictext', undefined, "But...");
                    complete.problem1.header.graphics.font = ScriptUI.newFont ('Arial', 'BOLD', 16);
                    complete.problem1.msg1 = complete.problem1.add('statictext', undefined, "These files could not be opened for import.\nThey might be corrupted or have an incompatable data structure.");
                    complete.problem1.list = complete.problem1.add ('edittext', [0, 0, 500, 150], couldNotOpen.join("\n"), {multiline:true});

				// If there are files that couln't be opened, make problem1 visible		
                    if (fileFailArr.length > 0){
					complete.problem1.maximumSize = [500,400];
					}
                    complete.okBtn = complete.add('button', undefined, 'Close');
                    complete.okBtn.onClick =  function(){ 
					complete.hide();
					}
                complete.show();		
			}
        }  
    } // close 'function importFromFile(){'
	} // close 'if(exportWhich.thumbsRb.value == true && app.document.selections.length == 0)'	
//////////////////////////////////////////////////////////////// END OF IMPORT FUNCTIONS ////////////////////////////////////////////////////////////////

	} // brace 2 close 'if( xmpLib == undefined ){'

}  // brace 1 close entire script - starting at : //Create a menu option within Adobe Bridge


