﻿#target bridge
/*
Produced by Greg Reser and Sarah Saunders. Javascript by Greg Reser. 

Terms and Conditions of Use:
MIT License

Copyright © 2018 IPTC - International Press Telecommunications Council
25 Southampton Buildings, London WC2A 1AL, United Kingdom
www.iptc.org

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

// SCRIPT
if (BridgeTalk.appName == "bridge"){
var bridgeVersion = BridgeTalk.appVersion
var paletteName = "IPTC Cultural Heritage Metadata";
var plgnVers= "1.0";
var codeVers = "2018-11-06";

//Create a menu option within Adobe Bridge
var findIPTC_CHMenu = MenuElement.find ('IPTCCulturalHeritage');
if (findIPTC_CHMenu == null){
	 var iptcChMenu = new MenuElement ('menu', "IPTC Cultural Heritage Metadata", 'before Help', 'IPTCCulturalHeritage');
	}
var iptcChPanel = new MenuElement ('command', "Metadata Panel", 'at the beginning of IPTCCulturalHeritage');
iptcChPanel.onSelect = function()

{  
 // Load the XMP Script library
if( !xmpLib){
	if( Folder.fs == "Windows" ){
		var pathToLib = Folder.startup.fsName + "/AdobeXMPScript.dll";
	}
	else{
		var pathToLib = Folder.startup.fsName + "/AdobeXMPScript.framework";
	}
	var libfile = new File( pathToLib );
	var xmpLib = new ExternalObject("lib:" + pathToLib );
}
// Register XMP namespaces
var NS_CC = "http://creativecommons.org/ns#";		
XMPMeta.registerNamespace(NS_CC, "cc");
var NS_IPTC_EXT = "http://iptc.org/std/Iptc4xmpExt/2008-02-29/"; 
XMPMeta.registerNamespace (NS_IPTC_EXT, "Iptc4xmpExt");
var NS_PLUS = "http://ns.useplus.org/ldf/xmp/1.0/";
XMPMeta.registerNamespace (NS_PLUS, "plus");
var plusPrefix = XMPMeta.getNamespacePrefix (NS_PLUS);
var plusCRownerName = "CopyrightOwner[1]/"+plusPrefix+"CopyrightOwnerName"
var NS_W3 = "http://www.w3.org/XML/1998/namespace";
XMPMeta.registerNamespace (NS_W3, "xml");
var NS_XMPR = "http://ns.adobe.com/xap/1.0/rights/";
XMPMeta.registerNamespace (NS_XMPR, "xmpRights");

////////////////////////// GLOBAL VARIABLES ////////////////////////////////  
// tooltips
var wTitle1labelTT = 'Name of the artwork or object in this image';
var wCreator1NameTT = 'Name of artist who created the artwork or object in the image';
var wCreator1idLabelTT = 'Gllobally unique identifier(s) for the artist  e.g. issued by an online registry . Enter in the same sequence as the creator names';
var wDateLabelTT = 'Date (and optionally the time) the artwork or object was created, in date format';
var wDateCircaLabelTT = 'Circa date or date range expressed in text format';
var wStylePeriodLabelTT = 'Style, historical period, or movement of artwork';
var wContribLabelTT = 'Contributions to the artwork such as restoration, find excavation etc. ';
var wPyhsDescLabelTT = 'Physical characteristics such as onbject type, materials, techniques, dimensions';
var wSourceGroupLabelTT = 'Organisation holding the artwork or object in its inventory';
var wSourceNameLabelTT = 'Name of Source';
var wSourceInvNumLabelTT = 'Inventory number of artwork or object held by the Source';
var wSourceInvUrlLabelTT = 'Reference url for the artwork or object held by the Source';
var wContentDescLabelTT = 'Description of content depicted in artwork or object';
var wCopyNoticeLabelTT = 'Copyright Notice for the artwork or object';
var wCurrCROGroupLabelTT = 'Current owner of the copyright of the artwork or object';
var wCurrLicGroupLabelTT = 'Current licensor of the artwork or object';
var iTitleLabelTT = 'Short name for the image. Sometimes the filename is held here. ';
var iCreator1labelTT = 'Name of the person who created the image';
var iCreatorJobLabelTT = 'Job Title of the person listed in the Creator field';
var iDateCreatedLabelTT = 'Date the image was taken';
var iLocDisplayGroupLabelTT = 'Details about the location associated with the image';
var iLocCoreGroupLabelTT = 'Camera and/or Location Shown';
var iLocDisplaySubLabelTT = 'Specific location, e.g., landmark, city area, village';
var iLocContryCdLabelTT = '2 or 3 letter ISO 3166 Country Code of the Country';
var iLocShownGroupLabelTT = 'Details about the location shown in the image';
var iLocShownSubLabelTT = 'Specific location, e.g., landmark, city area, village';
var iHeadlineLabelTT = 'Brief text summary of the contents of the image';
var iDescLabelTT = 'Caption describing the content of the image and its context';
var iKeywLabelTT = 'Keywords, expressing the image content for search purposes';
var iCopyrOwnerGroupLabelTT = 'Owner or owners of the copyright in the licensed image';
var iCreditLnLabelTT = 'Person or entity to credit when this image is published';
var iCRnoticeGroupLabelTT = 'Current owner of the Copyright for the image, e.g., ©2008 Jane Doe';
var iRightsUsageTLabelTT = 'Instructions on how this image can legally be used';
var iLicensorGroupLabelTT = 'Person or company to contact to obtain a license to use';
var iPropRelGroupLabelTT = 'Details of property release needed to use the image';
var iPropRelStatusLabelTT = 'Property release status';
var iInstructLabelTT = 'Embargoes, or other restrictions not covered by the Rights Usage field';
var iDigSrcTypeLabelTT = 'Type of the original source of the digital image';
var iMaxWidthLabelTT = 'Width in pixels of the original photo from which this derivative was made';
var iMaxHeightLabelTT = 'Height in pixels of the original photo from which this derivative was made';
var iSupplierGroupLabelTT = 'The most recent supplier of this image';
var iRegistryGroupLabelTT = 'Registry information for the digital image';
var iLocCd2TT = '2 letter ISO Country Code'
var iLocCd3TT = '3 letter ISO Country Code'
var iLocLookupTT = 'Lookup ISO Country, Country Code, World Region'

// dropdownlist variables
var headSepArray = [": ","; ",". "," | "," # "," * "]
var descSepArray = ["; "," | "," # "," * "]
var copyrightStatusArray = ["Unknown","Copyrighted","Public Domain","-","(Multiple Values)"];
var copyrightStatusDataArray = ["","True","False","-","(Multiple Values)"];
var iPropRelStatusDisplayArray = ["(Select Value)","None","Not Applicable","Unlimited Property Releases","Limited or Incomplete Property Releases",,"-","(Multiple Values)"];
var iPropRelStatusDataArray = ["","http://ns.useplus.org/ldf/vocab/PR-NON","http://ns.useplus.org/ldf/vocab/PR-NAP","http://ns.useplus.org/ldf/vocab/PR-UPR","http://ns.useplus.org/ldf/vocab/PR-LPR"];
var sourceTypeArray = ["(Select Value)","Original digital capture of a real life scene","Digitised from a negative on film","Digitised from a positive on film","Digitised from a print on non-transparent medium","Created by software",,"-","(Multiple Values)",];
var IPTCxIso2 = ['AF','AX','AL','DZ','AS','AD','AO','AI','AQ','AG','AR','AM','AW','AU','AT','AZ','BS','BH','BD','BB','BY','BE','BZ','BJ','BM','BT','BO','BA','BW','BV','BR','IO','VG','BN','BG','BF','BI','KH','CM','CA','CV','KY','CF','TD','CL','CN','CX','CC','CO','KM','CG','CK','CR','HR','CU','CY','CZ','CD','DK','DJ','DM','DO','TL','EC','EG','SV','GQ','ER','EE','ET','FK','FO','FJ','FI','FR','GF','PF','TF','GA','GM','GE','DE','GH','GI','GR','GL','GD','GP','GU','GT','GG','GN','GW','GY','HT','HM','HN','HK','HU','IS','IN','ID','IR','IQ','IE','IM','IL','IT','CI','JM','JP','JE','JO','KZ','KE','KI','XK','KW','KG','LA','LV','LB','LS','LR','LY','LI','LT','LU','MO','MK','MG','MW','MY','MV','ML','MT','MH','MQ','MR','MU','YT','MX','FM','MD','MC','MN','ME','MS','MA','MZ','MM','NA','NR','NP','NL','AN','NC','NZ','NI','NE','NG','NU','NF','KP','MP','NO','OM','PK','PW','PS','PA','PG','PY','PE','PH','PN','PL','PT','PR','QA','RE','RO','RU','RW','BL','SH','KN','LC','MF','PM','VC','WS','SM','ST','SA','SN','RS','CS','SC','SL','SG','SK','SI','SB','SO','ZA','GS','KR','ES','LK','SD','SR','SJ','SZ','SE','CH','SY','TW','TJ','TZ','TH','TG','TK','TO','TT','TN','TR','TM','TC','TV','VI','UG','UA','AE','GB','US','UM','UY','UZ','VU','VA','VE','VN','WF','EH','YE','ZM','ZW'];
var IPTCxIso3 = ['AFG','ALA','ALB','DZA','ASM','AND','AGO','AIA','ATA','ATG','ARG','ARM','ABW','AUS','AUT','AZE','BHS','BHR','BGD','BRB','BLR','BEL','BLZ','BEN','BMU','BTN','BOL','BIH','BWA','BVT','BRA','IOT','VGB','BRN','BGR','BFA','BDI','KHM','CMR','CAN','CPV','CYM','CAF','TCD','CHL','CHN','CXR','CCK','COL','COM','COG','COK','CRI','HRV','CUB','CYP','CZE','COD','DNK','DJI','DMA','DOM','TLS','ECU','EGY','SLV','GNQ','ERI','EST','ETH','FLK','FRO','FJI','FIN','FRA','GUF','PYF','ATF','GAB','GMB','GEO','DEU','GHA','GIB','GRC','GRL','GRD','GLP','GUM','GTM','GGY','GIN','GNB','GUY','HTI','HMD','HND','HKG','HUN','ISL','IND','IDN','IRN','IRQ','IRL','IMN','ISR','ITA','CIV','JAM','JPN','JEY','JOR','KAZ','KEN','KIR','XKX','KWT','KGZ','LAO','LVA','LBN','LSO','LBR','LBY','LIE','LTU','LUX','MAC','MKD','MDG','MWI','MYS','MDV','MLI','MLT','MHL','MTQ','MRT','MUS','MYT','MEX','FSM','MDA','MCO','MNG','MNE','MSR','MAR','MOZ','MMR','NAM','NRU','NPL','NLD','ANT','NCL','NZL','NIC','NER','NGA','NIU','NFK','PRK','MNP','NOR','OMN','PAK','PLW','PSE','PAN','PNG','PRY','PER','PHL','PCN','POL','PRT','PRI','QAT','REU','ROU','RUS','RWA','BLM','SHN','KNA','LCA','MAF','SPM','VCT','WSM','SMR','STP','SAU','SEN','SRB','SCG','SYC','SLE','SGP','SVK','SVN','SLB','SOM','ZAF','SGS','KOR','ESP','LKA','SDN','SUR','SJM','SWZ','SWE','CHE','SYR','TWN','TJK','TZA','THA','TGO','TKL','TON','TTO','TUN','TUR','TKM','TCA','TUV','VIR','UGA','UKR','ARE','GBR','USA','UMI','URY','UZB','VUT','VAT','VEN','VNM','WLF','ESH','YEM','ZMB','ZWE'];
var IPTCxLand = ['Afghanistan', 'Aland Islands', 'Albania', 'Algeria', 'American Samoa', 'Andorra', 'Angola', 'Anguilla', 'Antarctica', 'Antigua and Barbuda', 'Argentina', 'Armenia', 'Aruba', 'Australia', 'Austria', 'Azerbaijan', 'Bahamas', 'Bahrain', 'Bangladesh', 'Barbados', 'Belarus', 'Belgium', 'Belize', 'Benin', 'Bermuda', 'Bhutan', 'Bolivia', 'Bosnia and Herzegovina', 'Botswana', 'Bouvet Island', 'Brazil', 'British Indian Ocean Territory', 'British Virgin Islands', 'Brunei', 'Bulgaria', 'Burkina Faso', 'Burundi', 'Cambodia', 'Cameroon', 'Canada', 'Cape Verde', 'Cayman Islands', 'Central African Republic', 'Chad', 'Chile', 'China', 'Christmas Island', 'Cocos Islands', 'Colombia', 'Comoros', 'Congo', 'Cook Islands', 'Costa Rica', 'Croatia', 'Cuba', 'Cyprus', 'Czech Republic', 'Democratic Republic of Congo', 'Denmark', 'Djibouti', 'Dominica', 'Dominican Republic', 'East Timor', 'Ecuador', 'Egypt', 'El Salvador', 'Equatorial Guinea', 'Eritrea', 'Estonia', 'Ethiopia', 'Falkland Islands', 'Faroe Islands', 'Fiji', 'Finland', 'France', 'French Guiana', 'French Polynesia', 'French Southern Territories', 'Gabon', 'Gambia', 'Georgia', 'Germany', 'Ghana', 'Gibraltar', 'Greece', 'Greenland', 'Grenada', 'Guadeloupe', 'Guam', 'Guatemala', 'Guernsey', 'Guinea', 'Guinea-Bissau', 'Guyana', 'Haiti', 'Heard Island and McDonald Islands', 'Honduras', 'Hong Kong', 'Hungary', 'Iceland', 'India', 'Indonesia', 'Iran', 'Iraq', 'Ireland', 'Isle of Man', 'Israel', 'Italy', 'Ivory Coast', 'Jamaica', 'Japan', 'Jersey', 'Jordan', 'Kazakhstan', 'Kenya', 'Kiribati', 'Kosovo', 'Kuwait', 'Kyrgyzstan', 'Laos', 'Latvia', 'Lebanon', 'Lesotho', 'Liberia', 'Libya', 'Liechtenstein', 'Lithuania', 'Luxembourg', 'Macao', 'Macedonia', 'Madagascar', 'Malawi', 'Malaysia', 'Maldives', 'Mali', 'Malta', 'Marshall Islands', 'Martinique', 'Mauritania', 'Mauritius', 'Mayotte', 'Mexico', 'Micronesia', 'Moldova', 'Monaco', 'Mongolia', 'Montenegro', 'Montserrat', 'Morocco', 'Mozambique', 'Myanmar', 'Namibia', 'Nauru', 'Nepal', 'Netherlands', 'Netherlands Antilles', 'New Caledonia', 'New Zealand', 'Nicaragua', 'Niger', 'Nigeria', 'Niue', 'Norfolk Island', 'North Korea', 'Northern Mariana Islands', 'Norway', 'Oman', 'Pakistan', 'Palau', 'Palestinian Territory', 'Panama', 'Papua New Guinea', 'Paraguay', 'Peru', 'Philippines', 'Pitcairn', 'Poland', 'Portugal', 'Puerto Rico', 'Qatar', 'Reunion', 'Romania', 'Russia', 'Rwanda', 'Saint Barthelemy', 'Saint Helena', 'Saint Kitts and Nevis', 'Saint Lucia', 'Saint Martin', 'Saint Pierre and Miquelon', 'Saint Vincent and the Grenadines', 'Samoa', 'San Marino', 'Sao Tome and Principe', 'Saudi Arabia', 'Senegal', 'Serbia', 'Serbia and Montenegro', 'Seychelles', 'Sierra Leone', 'Singapore', 'Slovakia', 'Slovenia', 'Solomon Islands', 'Somalia', 'South Africa', 'South Georgia and the South Sandwich Islands', 'South Korea', 'Spain', 'Sri Lanka', 'Sudan', 'Suriname', 'Svalbard and Jan Mayen', 'Swaziland', 'Sweden', 'Switzerland', 'Syria', 'Taiwan', 'Tajikistan', 'Tanzania', 'Thailand', 'Togo', 'Tokelau', 'Tonga', 'Trinidad and Tobago', 'Tunisia', 'Turkey', 'Turkmenistan', 'Turks and Caicos Islands', 'Tuvalu', 'US Virgin Islands', 'Uganda', 'Ukraine', 'United Arab Emirates', 'United Kingdom', 'United States', 'United States Minor Outlying Islands', 'Uruguay', 'Uzbekistan', 'Vanuatu', 'Vatican', 'Venezuela', 'Vietnam', 'Wallis and Futuna', 'Western Sahara', 'Yemen', 'Zambia', 'Zimbabwe'];
var IPTCxCont = ['Asia', 'Europe', 'Europe', 'Africa', 'Oceania', 'Europe', 'Africa', 'North America', 'Antarctica', 'North America', 'South America', 'Asia', 'North America', 'Oceania', 'Europe', 'Asia', 'North America', 'Asia', 'Asia', 'North America', 'Europe', 'Europe', 'North America', 'Africa', 'North America', 'Asia', 'South America', 'Europe', 'Africa', 'Antarctica', 'South America', 'Asia', 'North America', 'Asia', 'Europe', 'Africa', 'Africa', 'Asia', 'Africa', 'North America', 'Africa', 'North America', 'Africa', 'Africa', 'South America', 'Asia', 'Asia', 'Asia', 'South America', 'Africa', 'Africa', 'Oceania', 'North America', 'Europe', 'North America', 'Europe', 'Europe', 'Africa', 'Europe', 'Africa', 'North America', 'North America', 'Oceania', 'South America', 'Africa', 'North America', 'Africa', 'Africa', 'Europe', 'Africa', 'South America', 'Europe', 'Oceania', 'Europe', 'Europe', 'South America', 'Oceania', 'Antarctica', 'Africa', 'Africa', 'Asia', 'Europe', 'Africa', 'Europe', 'Europe', 'North America', 'North America', 'North America', 'Oceania', 'North America', 'Europe', 'Africa', 'Africa', 'South America', 'North America', 'Antarctica', 'North America', 'Asia', 'Europe', 'Europe', 'Asia', 'Asia', 'Asia', 'Asia', 'Europe', 'Europe', 'Asia', 'Europe', 'Africa', 'North America', 'Asia', 'Europe', 'Asia', 'Asia', 'Africa', 'Oceania', 'Europe', 'Asia', 'Asia', 'Asia', 'Europe', 'Asia', 'Africa', 'Africa', 'Africa', 'Europe', 'Europe', 'Europe', 'Asia', 'Europe', 'Africa', 'Africa', 'Asia', 'Asia', 'Africa', 'Europe', 'Oceania', 'North America', 'Africa', 'Africa', 'Africa', 'North America', 'Oceania', 'Europe', 'Europe', 'Asia', 'Europe', 'North America', 'Africa', 'Africa', 'Asia', 'Africa', 'Oceania', 'Asia', 'Europe', 'North America', 'Oceania', 'Oceania', 'North America', 'Africa', 'Africa', 'Oceania', 'Oceania', 'Asia', 'Oceania', 'Europe', 'Asia', 'Asia', 'Oceania', 'Asia', 'North America', 'Oceania', 'South America', 'South America', 'Asia', 'Oceania', 'Europe', 'Europe', 'North America', 'Asia', 'Africa', 'Europe', 'Europe', 'Africa', 'North America', 'Africa', 'North America', 'North America', 'North America', 'North America', 'North America', 'Oceania', 'Europe', 'Africa', 'Asia', 'Africa', 'Europe', 'Europe', 'Africa', 'Africa', 'Asia', 'Europe', 'Europe', 'Oceania', 'Africa', 'Africa', 'Antarctica', 'Asia', 'Europe', 'Asia', 'Africa', 'South America', 'Europe', 'Africa', 'Europe', 'Europe', 'Asia', 'Asia', 'Asia', 'Africa', 'Asia', 'Africa', 'Oceania', 'Oceania', 'North America', 'Africa', 'Asia', 'Asia', 'North America', 'Oceania', 'North America', 'Africa', 'Europe', 'Asia', 'Europe', 'North America', 'Oceania', 'South America', 'Asia', 'Oceania', 'Europe', 'South America', 'Asia', 'Oceania', 'Africa', 'Asia', 'Africa', 'Africa'];

// panel UI varialbes
var activeInd = "◆"; // ★
var rightArrow = " ➜";
var check = "✓";
var spot = "•";
var headSeparator = ": ";
var descSeparator = "; ";
var currentField = "";
 var spaces8 = "        ";""
 var separator1 = "\n——————————";
 // multiple values variables
var noData = "";
var multi = "(Multiple Values)";
var vocabLinkedField = {};
var lodObject = {};
var lastViewedThumb = [];
var lastViewedPanel = "";
var lastViewedPanelButtonLabel = "";
var allowedFiles = 0;
var selectedIndex = 0;
var orientation = "stack";
var un = undefined;
// panel size
var hidden = [0,0];
var containerSize = [1210,700] //1210,710
var singleFieldRowSpacing = 2;
// dropdown box size
var drpdwnXXXXSml = [80,22];
var drpdwnXXXSml = [100,22];
var drpdwnXXSml = [120,22];
var drpdwnXSml = [150,22];
var drpDwnSml = [175,22];
var drpdwnM = [210,22];
// colors
var black = [0, 0, 0, 0];
var white = [1, 1, 1, 1];
var IPTCxColB = [0.955, 0.970, 0.985, 1];
var IPTCxColG = [0.960, 0.985, 0.960, 1];
var IPTCxColR = [0.980, 0.965, 0.965, 1];
var IPTCxColL = [0.000, 0.000, 0.600, 1];
var IPTCxColT = [0.500, 0.000, 0.000, 1];
if (Folder.fs == "Windows"){
   // panel size
	var winSize = [840,745] //1210,710
	// columns
	var colSize1 = [200,650]
	var colSize2 = [610,650]
    // footer
    var footerSize = [780,un]
     // spacers
     var spacer4 = [50,0]
     var spacer5 = [100,0]
    var spacer6 = [180,0]
    var spacer7 = [260,0]
    // buttons
	var buttonSize1 = [18,22]
    var buttonSize3 = [30,22]
    var buttonSize5 = [50,22]
	var buttonSize5a = [80,25]
	 var buttonSize6 = [100,22]
	 var buttonSize7 = [130,22]
	var buttonSize7a = [155,32]//[130,32]
	var buttonSize7b = [130,42]
    var buttonSize8 = [150,22]
    // navigation button indent
    var navBtnsIndentArr = ["    ","  ","         ","         "]
   // single
    var singleLabel = [60,18];
    var singleEdit = [520,18];
    // single and tall
    var singleTallLabel = [60,18];
    var singleTallEdit = [520,40];
    // single wide
    var singleWideLabel = [150,18];
    var singleWideEdit = [430,18];
    // single wide and tall
    var singleWideTallLabel = [150,60];
    var singleWideTallEdit = [430,60];
    var singleWideVeryTallLabel = [150,80];
    var singleWideVeryTallEdit = [430,100];
    // subfields
    var subSingleLabel = [35,18];
    var subSingleEditShorter = [386,18];
    var subSingleEditShort = [418,18];
    var subSingleEdit = [446,18]; 
    var subSingleLongLabel = [105,18]
    var subSingleLongEdit = [315,18]
    var iLocLabel = [85,18]
    var iLocEdit = [368,18]
	var iLocEditShort = [230,18]
    var detailsSingleFieldRowSpacing = 2;
    var detailsSingleFieldRowLabel = [105,18];
    var detailsSingleFieldRowEdit = [408,18];
    var iImageLabel = [120,18]
    var iRightsLabel = [140,18]
    var iRightsEdit = [460,18]
    var iRightsEditTall = [460,40]
    var iRightsLabelVeryTall = [140,80]
    var iRightsEditVeryTall = [460,80]
	var iRightsLabelExtraTall = [120,130]
    var iRightsEditExtraTall = [460,130]
    var iRightsSubLabel = [90,18]
    var iRightsSubEdit = [363,18]   
    var iRightsSubDrpEdit = [363,22] 
    var iAdminLabel = [110,18]
    var iAdminEdit = [470,18]
    var iAdminSubLabel = [90,18]
    var iAdminSubEdit = [363,18]
    var drpdwnLrg = [300,22];
	}
else{
    // panel size
	var winSize = [880,745] //1210,710
	// columns
	var colSize1 = [220,650]
	var colSize2 = [660,650]
    // footer
    var footerSize = [780,un] // 780
    // spacers
    var spacer4 = [50,0]
     var spacer5 = [100,0]
    var spacer6 = [175,0]
    var spacer7 = [310,0];
    // buttons
	var buttonSize1 = [18,22]
    var buttonSize3 = [50,22]
    var buttonSize5 = [70,22]
	var buttonSize5a = [80,25]
	 var buttonSize6 = [100,22]
	 var buttonSize7 = [130,22]
	var buttonSize7a = [180,32]
	var buttonSize7b = [130,42]
    var buttonSize8 = [150,22]
    // navigation button indent
    var navBtnsIndentArr = ["  "," ","      ","      "]
    // single
    var singleLabel = [60,18];
    var singleEdit = [520,18];
    // single and tall
    var singleTallLabel = [60,18];
    var singleTallEdit = [520,40];
    // single wide
    var singleWideLabel = [158,18];
    var singleWideEdit = [422,18];
    // single wide and tall
    var singleWideTallLabel = [158,60];
    var singleWideTallEdit = [422,60];
    var singleWideVeryTallLabel = [158,80];
    var singleWideVeryTallEdit = [422,100];
    // subfields
    var subSingleLabel = [40,18];
    var subSingleEditShorter = [375,18];
    var subSingleEditShort = [411,18];
    var subSingleEdit = [440,18];  
    var subSingleLongLabel = [112,18]
    var subSingleLongEdit = [303,18]
    var iLocLabel = [93,18]
    var iLocEdit = [355,18]
    var detailsSingleFieldRowSpacing = 2;
    var detailsSingleFieldRowLabel = [105,18];
    var detailsSingleFieldRowEdit = [408,18]; 
     var iImageLabel = [125,18]
    var iRightsLabel = [145,18]
    var iRightsEdit = [455,18]
    var iRightsEditTall = [460,40]
    var iRightsLabelVeryTall = [125,80]
    var iRightsEditVeryTall = [455,80]
    var iRightsLabelExtraTall = [125,130]
    var iRightsEditExtraTall = [455,130]
    var iRightsSubLabel = [95,18]
    var iRightsSubEdit = [357,18]   
    var iRightsSubDrpEdit = [357,22] 
    var iAdminLabel = [110,18]
    var iAdminEdit = [470,18]
    var iAdminSubLabel = [97,18]
    var iAdminSubEdit = [354,18]
    var drpdwnLrg = [350,22]
	}
// Bridge version dependant variables
 if(bridgeVersion < 5){
	 var re = /.ai|.dng|.gif|.jpg|.jpeg|.png|.psd|.tif|.tiff/i
	 var supportedFilesTxt = "Please select Bridge thumbnail(s)to begin\n\n"+
"Supported files:\n"+
"  .ai  (Adobe Illustrator)\n"+
"  .dng (Digital Negative)\n"+
"  .jpg (Joint Photographic Experts Group)\n"+
"  .pdf (Adobe PDF)\n"+
"  .png (Portable Network Graphics)\n"+
"  .psd (Adobe Photoshop)\n"+
"  .tif (Tagged Image File Format)"+
"   \n\nThis version of Bridge does not support RAW files with sidecard files."+
"   \nBridge CS6 and higher do though."+
"   \nSorry about that."
	 }
 else{
 // todo: removed Sony RAW .arw.  Can I put it back now?
	 var re = /.dng|.gif|.jpg|.jpeg|.png|.psd|.tif|.tiff|.3fr|.srf|.sr2|.crw|.cr2|.cap|.iiq|.eip|.dng|.erf|.fff|.mef|.mdc|.nef|.nrw|.orf|.pef|.ptx|.raw|.rwl|.dng|.srw/i
	  var supportedFilesTxt = "Please select Bridge thumbnail(s)to begin\n\n"+
"Supported files:\n"+
"  .ai  (Adobe Illustrator)\n"+
"  .dng (Digital Negative)\n"+
"  .jpg (Joint Photographic Experts Group)\n"+
"  .pdf (Adobe PDF)\n"+
"  .png (Portable Network Graphics)\n"+
"  .psd (Adobe Photoshop)\n"+
"  .tif (Tagged Image File Format)"+
"   \nRAW files:"+
"    \n   .3fr\n   .srf\n   .sr2\n   .crw\n   .cr2\n   .cap\n   .iiq\n   .eip\n   .dng\n   .erf\n   .fff\n   .mef\n   .mdc\n   .nef\n   .nrw\n   .orf\n   .pef\n   .ptx\n   .raw\n   .rwl\n   .dng\n   .srw"}
/* !!!/// vocab variables
var parsedJSON = new Object();
var uriArr = [];
var aatFacetId = "";
var periodStyleScopeNoteArr = [];
*/
// panel user settings variables
var appDataFwdSlash = Folder.userData;
var plgnPrefs = "/IPTC-CH_Panel";
var plgnOpt = "/Options";
var plgnSet = "/settings.txt";
var multiAoWinDontVal = false
var footerButtonsMultiAoWinVal = true
// report variables
var propPass = 0;
var propFail = 0;
var propFailArr = [];
// arrays to store read values for Multiple Values check
var multiTestArr = [];
var multiTestArr2 = [];
var multiTestArr3 = [];
// ISO country lookup variables
var isoCntryParams = [];
// file variables
var fileTypesArr = ["ai","dng","jpg","jpeg","pdf","png","psd","tif","tiff","3fr","arw","srf","sr2","crw","cr2","cap","iiq","eip","dng","erf","fff","mef","mdc","nef","nrw","orf","pef","ptx","raw","rwl","dng","srw"]
var rawFileTypesArr = ["arw","srf","sr2","crw","cr2","cap","iiq","eip","dng","erf","fff","mef","mdc","nef","nrw","orf","pef","ptx","raw","rwl","dng","srw"]
////////////////////////// END OF GLOBAL VARIABLES ////////////////////////////////
// if it doesn't already exist, create panel user settings file
if (Folder (appDataFwdSlash + plgnPrefs + plgnOpt).exists == false){
	  new Folder (appDataFwdSlash + plgnPrefs + plgnOpt).create();
	}
////////////////////////// USER INTERFACE ////////////////////////////////
// the floating palette UI
var winIptcChPnl = new Window("palette", paletteName+"  version "+plgnVers+" ("+codeVers+")", un, );
winIptcChPnl.minimumSize = winSize
winIptcChPnl.maximumSize = winSize
winIptcChPnl.margins = [0,10,0,10];
winIptcChPnl.spacing = 5;
winIptcChPnl.alignChildren = ['top', 'fill'];

    /////////////////////////////////////////////////////////
  //////////////// NAVIGATION ////////////////
/////////////////////////////////////////////////////////
cols = winIptcChPnl.add('group',un,un)
cols.orientation - 'row'
cols.margins = [0,0,0,0]
cols.spacing = 0

navCol = cols.add('group',un,un)
navCol.orientation = 'column'
navCol.margins = [0,10,0,0]
navCol.spacing = 5
navCol.minimumSize = colSize1
navCol.maximumSize = colSize1

save1 = navCol.add( 'button', un, "Save" )
save1.preferredSize = buttonSize7a
//save1.alignment = 'top'
save1.enabled = false;
save1.onClick =  function(){ writeXMP() }

navColSpacer1 = navCol.add( 'statictext', un, un )
navColSpacer1.preferredSize = [1,60]

aoBtn = navCol.add('button', undefined, "ARTWORK/OBJECT")
aoBtn.preferredSize = buttonSize7a

imgBtn = navCol.add('button', undefined, "IMAGE DESCRIPTION")
imgBtn.preferredSize = buttonSize7a

imgRightsBtn = navCol.add('button', undefined, "IMAGE RIGHTS")
imgRightsBtn.preferredSize = buttonSize7a

adminBtn = navCol.add('button', undefined, "IMAGE ADMIN")
adminBtn.preferredSize = buttonSize7a

aoBtn.alignment = 'left'
imgBtn.alignment = 'left'
imgRightsBtn.alignment = 'left'
adminBtn.alignment = 'left'
   /////////////////////////////////////////////////
  //////////////// FIELDS ////////////////
/////////////////////////////////////////////////
/// fields column
fieldsCol1 = cols.add('group',un,un)
fieldsCol1.orientation = 'stack'
fieldsCol1.alignChildren = ['top', 'fill']
fieldsCol1.margins = [0,0,0,0]
    //////////////////////////////////////////////////////////////////////////
  //////////////// SELECT A FILE PANEL //////////////
//////////////////////////////////////////////////////////////////////////
selectFilePanel = fieldsCol1.add('panel',un, un); //0,0,496,720
selectFilePanel.preferredSize = colSize2
selectFilePanel.margins = 10
selectFilePanel.alignChildren = 'left'
selectFilePanelText1 = selectFilePanel.add( 'statictext', un, supportedFilesTxt,{multiline:true});
selectFilePanelText1.preferredSize = [610,600] // colSize2
/////////////////////////////////////////////////////  
//////////////// ARTWORK / OBJECT PANEL //////////////
///////////////////////////////////////////////////// 
// Artwork / Object
aoPnl = fieldsCol1.add('panel',un,"ARTWORK/OBJECT")
aoPnl.orientation = 'column'
aoPnl.alignChildren = 'left'
aoPnl.preferredSize = colSize2
aoPnl.spacing = 5
aoPnl.visible = false
// Fields
wTitle1row = aoPnl.add( 'group', un, un );
wTitle1row.margins = 0;
wTitle1row.spacing = singleFieldRowSpacing;
wTitle1row.alignChildren = ['top', 'fill']
wTitle1label = wTitle1row.add( 'statictext', un, "Title" );
wTitle1label.preferredSize = singleTallLabel;
wTitle1label.justify = 'right';
wTitle1label.helpTip = wTitle1labelTT;
wTitle1 = wTitle1row.add( 'edittext', un, un );
wTitle1.preferredSize = singleEdit;
//
wCreator1row = aoPnl.add( 'group', un, un );
wCreator1row.margins = 0;
wCreator1row.spacing = singleFieldRowSpacing;
wCreator1label = wCreator1row.add( 'statictext', un, "Creator 1" );
wCreator1label.preferredSize = singleLabel;
wCreator1label.justify = 'right';
wCreator1label.helpTip = wCreator1NameTT;
wCreator1Name = wCreator1row.add( 'edittext', un, un );
wCreator1Name.preferredSize = [300,18];

wCreator1idLabel = wCreator1row.add( 'statictext', un, "ID" );
wCreator1idLabel.preferredSize = [20,18];
wCreator1idLabel.justify = 'right';
wCreator1idLabel.helpTip = wCreator1idLabelTT;
wCreator1id = wCreator1row.add( 'edittext', un, un );
wCreator1id.preferredSize = [196,18];
//
wCreator2row = aoPnl.add( 'group', un, un );
wCreator2row.margins = 0;
wCreator2row.spacing = singleFieldRowSpacing;
wCreator2label = wCreator2row.add( 'statictext', un, "Creator 2" );
wCreator2label.preferredSize = singleLabel;
wCreator2label.justify = 'right';
wCreator2label.helpTip = wCreator1NameTT;
wCreator2Name = wCreator2row.add( 'edittext', un, un );
wCreator2Name.preferredSize = [300,18];

wCreator2idLabel = wCreator2row.add( 'statictext', un, "ID" );
wCreator2idLabel.preferredSize = [20,18];
wCreator2idLabel.justify = 'right';
wCreator2idLabel.helpTip = wCreator1idLabelTT;
wCreator2id = wCreator2row.add( 'edittext', un, un );
wCreator2id.preferredSize = [196,18];
//
wCreator3row = aoPnl.add( 'group', un, un );
wCreator3row.margins = 0;
wCreator3row.spacing = singleFieldRowSpacing;
wCreator3label = wCreator3row.add( 'statictext', un, "Creator 3" );
wCreator3label.preferredSize = singleLabel;
wCreator3label.justify = 'right';
wCreator3label.helpTip = wCreator1NameTT;
wCreator3Name = wCreator3row.add( 'edittext', un, un );
wCreator3Name.preferredSize = [300,18];

wCreator3idLabel = wCreator3row.add( 'statictext', un, "ID" );
wCreator3idLabel.preferredSize = [20,18];
wCreator3idLabel.justify = 'right';
wCreator3idLabel.helpTip = wCreator1idLabelTT;
wCreator3id = wCreator3row.add( 'edittext', un, un );
wCreator3id.preferredSize = [196,18];
//
wDateRow = aoPnl.add( 'group', un, un );
wDateRow.margins = 0;
wDateRow.spacing = singleFieldRowSpacing;
wDateLabel = wDateRow.add( 'statictext', un, "Date Created" );
wDateLabel.preferredSize = singleWideLabel;
wDateLabel.justify = 'right';
wDateLabel.helpTip = wDateLabelTT;
wDate = wDateRow.add( 'edittext', un, un );
wDate.preferredSize = [120,18];
wDateHelp= wDateRow.add( 'statictext', un, "YYYY or YYYY-MM or YYYY-MM-DD" );
wDateHelp.preferredSize = [260,18];
wDateHelp.justify = 'left';
//
wDateCircaRow = aoPnl.add( 'group', un, un );
wDateCircaRow.margins = 0;
wDateCircaRow.spacing = singleFieldRowSpacing;
wDateCircaLabel = wDateCircaRow.add( 'statictext', un, "Circa Date Created" );
wDateCircaLabel.preferredSize = singleWideLabel
wDateCircaLabel.justify = 'right';
wDateCircaLabel.helpTip=wDateCircaLabelTT;
wDateCirca = wDateCircaRow.add( 'edittext', un, un );
wDateCirca.preferredSize =singleWideEdit;
//
wStylePeriodRow = aoPnl.add( 'group', un, un );
wStylePeriodRow.margins = 0;
wStylePeriodRow.spacing = singleFieldRowSpacing;
wStylePeriodLabel = wStylePeriodRow.add( 'statictext', un, "Style/Period" );
wStylePeriodLabel.preferredSize = singleWideLabel;
wStylePeriodLabel.justify = 'right';
wStylePeriodLabel.helpTip = wStylePeriodLabelTT;
wStylePeriod = wStylePeriodRow.add( 'edittext', un, un );
wStylePeriod.preferredSize = singleWideEdit;
//
wContribRow = aoPnl.add( 'group', un, un );
wContribRow.margins = 0;
wContribRow.spacing = singleFieldRowSpacing;
wContribLabel = wContribRow.add( 'statictext', un, "Contribution Description" );
wContribLabel.preferredSize = singleWideLabel;
wContribLabel.justify = 'right';
wContribLabel.alignment = 'top';
wContribLabel.helpTip = wContribLabelTT;
wContrib = wContribRow.add( 'edittext', un, un,{multiline:true} );
wContrib.preferredSize = singleWideTallEdit;
//
wPyhsDescRow = aoPnl.add( 'group', un, un );
wPyhsDescRow.margins = 0;
wPyhsDescRow.spacing = singleFieldRowSpacing;
wPyhsDescLabel = wPyhsDescRow.add( 'statictext', un, "Physical Description" );
wPyhsDescLabel.preferredSize = singleWideLabel;
wPyhsDescLabel.alignment = 'top';
wPyhsDescLabel.justify = 'right';
wPyhsDescLabel.helpTip = wPyhsDescLabelTT;
wPyhsDesc = wPyhsDescRow.add( 'edittext', un, un,{multiline:true} );
wPyhsDesc.preferredSize = singleWideTallEdit;
//
wSourceGroup = aoPnl.add( 'group', un, un );
wSourceGroup.spacing = singleFieldRowSpacing;
wSourceGroupLabel = wSourceGroup.add( 'statictext', un, "Source" );
wSourceGroupLabel.preferredSize = singleWideLabel;
wSourceGroupLabel.alignment = 'top';
wSourceGroupLabel.justify = 'right';
wSourceGroupLabel.helpTip = wSourceGroupLabelTT;
wSourcePanel = wSourceGroup.add( 'panel', un, "");
wSourcePanel.spacing = 1;
wSourcePanel.margins = [1,1,1,1];
wSourceNameRow = wSourcePanel.add( 'group', un, un );
wSourceNameRow.margins = 0;
wSourceNameRow.spacing = singleFieldRowSpacing;
wSourceNameLabel = wSourceNameRow.add( 'statictext', un, "Name" );
wSourceNameLabel.preferredSize = subSingleLabel;
wSourceNameLabel.justify = 'right';
wSourceNameLabel.helpTip = wSourceNameLabelTT;
wSourceName = wSourceNameRow.add( 'edittext', un, un );
wSourceName.preferredSize = subSingleEditShorter
wSourceInvNumRow = wSourcePanel.add( 'group', un, un );
wSourceInvNumRow.margins = 0;
wSourceInvNumRow.spacing = singleFieldRowSpacing;
wSourceInvNumLabel = wSourceInvNumRow.add( 'statictext', un, "Inventory Number" );
wSourceInvNumLabel.preferredSize = subSingleLongLabel
wSourceInvNumLabel.justify = 'right';
wSourceInvNumLabel.helpTip = wSourceInvNumLabelTT;
wSourceInvNum = wSourceInvNumRow.add( 'edittext', un, un );
wSourceInvNum.preferredSize = subSingleLongEdit
wSourceInvUrlRow = wSourcePanel.add( 'group', un, un );
wSourceInvUrlRow.margins = 0;
wSourceInvUrlRow.spacing = singleFieldRowSpacing;
wSourceInvUrlLabel = wSourceInvUrlRow.add( 'statictext', un, "Inventory URL" );
wSourceInvUrlLabel.preferredSize = subSingleLongLabel
wSourceInvUrlLabel.justify = 'right';
wSourceInvUrlLabel.helpTip = wSourceInvUrlLabelTT;
wSourceInvUrl = wSourceInvUrlRow.add( 'edittext', un, un );
wSourceInvUrl.preferredSize = subSingleLongEdit
//
wContentDescRow = aoPnl.add( 'group', un, un );
wContentDescRow.margins = 0;
wContentDescRow.spacing = singleFieldRowSpacing;
wContentDescLabel = wContentDescRow.add( 'statictext', un, "Content Description" );
wContentDescLabel.preferredSize = singleWideLabel;
wContentDescLabel.alignment = 'top';
wContentDescLabel.justify = 'right';
wContentDescLabel.helpTip = wContentDescLabelTT;
wContentDesc = wContentDescRow.add( 'edittext', un, un,{multiline:true});
wContentDesc.preferredSize = singleWideVeryTallEdit
//
wCopyNoticeRow = aoPnl.add( 'group', un, un );
wCopyNoticeRow.margins = 0;
wCopyNoticeRow.spacing = singleFieldRowSpacing;
wCopyNoticeLabel = wCopyNoticeRow.add( 'statictext', un, "Copyright Notice" );
wCopyNoticeLabel.preferredSize = singleWideLabel;
wCopyNoticeLabel.alignment = 'top';
wCopyNoticeLabel.justify = 'right';
wCopyNoticeLabel.helpTip = wCopyNoticeLabelTT;
wCopyNotice = wCopyNoticeRow.add( 'edittext', un, un,{multiline:true});
wCopyNotice.preferredSize = singleWideTallEdit
//
wCurrCROGroup = aoPnl.add( 'group', un, un );
wCurrCROGroup.spacing = singleFieldRowSpacing;
wCurrCROGroupLabel = wCurrCROGroup.add( 'statictext', un, "Current Copyright Owner" );
wCurrCROGroupLabel.preferredSize = singleWideLabel
wCurrCROGroupLabel.alignment = 'top';
wCurrCROGroupLabel.justify = 'right';
wCurrCROGroupLabel.helpTip = wCurrCROGroupLabelTT;
wCurrCROPanel = wCurrCROGroup.add( 'panel', un, "");
wCurrCROPanel.spacing = 1;
wCurrCROPanel.margins = [1,1,1,1];
wCurrCRONameRow = wCurrCROPanel.add( 'group', un, un );
wCurrCRONameRow.margins = 0;
wCurrCRONameRow.spacing = singleFieldRowSpacing;
wCurrCRONameLabel = wCurrCRONameRow.add( 'statictext', un, "Name" );
wCurrCRONameLabel.preferredSize = subSingleLabel;
wCurrCRONameLabel.justify = 'right';
wCurrCROName = wCurrCRONameRow.add( 'edittext', un, un );
wCurrCROName.preferredSize = subSingleEditShorter
wCurrCRONameIdRow = wCurrCROPanel.add( 'group', un, un );
wCurrCRONameIdRow.margins = 0;
wCurrCRONameIdRow.spacing = singleFieldRowSpacing;
wCurrCRONameIdLabel = wCurrCRONameIdRow.add( 'statictext', un, "ID" );
wCurrCRONameIdLabel.preferredSize = subSingleLabel;
wCurrCRONameIdLabel.justify = 'right';
//wCurrCRONameIdLabel.helpTip = wCurrCRONameIdLabelTT;
wCurrCRONameId = wCurrCRONameIdRow.add( 'edittext', un, un );
wCurrCRONameId.preferredSize = subSingleEditShorter
//
wCurrLicGroup = aoPnl.add( 'group', un, un );
wCurrLicGroup.spacing = singleFieldRowSpacing;
//wCurrLicGroup.margins = [1,1,1,1];
//wCurrLicGroup.alignChildren = ['top', 'fill']
wCurrLicGroupLabel = wCurrLicGroup.add( 'statictext', un, "Current Licensor" );
wCurrLicGroupLabel.preferredSize = singleWideLabel
wCurrLicGroupLabel.alignment = 'top';
wCurrLicGroupLabel.justify = 'right';
wCurrLicGroupLabel.helpTip = wCurrLicGroupLabelTT;
wCurrLicPanel = wCurrLicGroup.add( 'panel', un, "");
wCurrLicPanel.spacing = 1;
wCurrLicPanel.margins = [1,1,1,1];
wCurrLicNameRow = wCurrLicPanel.add( 'group', un, un );
wCurrLicNameRow.margins = 0;
wCurrLicNameRow.spacing = singleFieldRowSpacing;
wCurrLicNameLabel = wCurrLicNameRow.add( 'statictext', un, "Name" );
wCurrLicNameLabel.preferredSize = subSingleLabel;
wCurrLicNameLabel.justify = 'right';
wCurrLicName = wCurrLicNameRow.add( 'edittext', un, un );
wCurrLicName.preferredSize = subSingleEditShorter//[386,18];
wCurrLicNameIdRow = wCurrLicPanel.add( 'group', un, un );
wCurrLicNameIdRow.margins = 0;
wCurrLicNameIdRow.spacing = singleFieldRowSpacing;
wCurrLicNameIdLabel = wCurrLicNameIdRow.add( 'statictext', un, "ID" );
wCurrLicNameIdLabel.preferredSize = subSingleLabel;
wCurrLicNameIdLabel.justify = 'right';
wCurrLicNameId = wCurrLicNameIdRow.add( 'edittext', un, un );
wCurrLicNameId.preferredSize = subSingleEditShorter//[386,18];
    //////////////////////////////////////////////////////////
  //////////////// IMAGE PANEL //////////////   
///////////////////////////////////////////////////////////
imgPnl = fieldsCol1.add('panel',un,"IMAGE DESCRIPTION")
imgPnl.orientation = 'column'
imgPnl.alignChildren = 'left'
imgPnl.preferredSize = colSize2
imgPnl.spacing = 5
imgPnl.visible = false 
// Fields
//
iTitleRow = imgPnl.add( 'group', un, un );
iTitleRow.margins = 0;
iTitleRow.spacing = singleFieldRowSpacing;
iTitleLabel = iTitleRow.add( 'statictext', un, "Title" );
iTitleLabel.preferredSize = iImageLabel;
iTitleLabel.justify = 'right';
iTitleLabel.helpTip = iTitleLabelTT;
iTitle = iTitleRow.add( 'edittext', un, un );
iTitle.preferredSize = iRightsEdit;
//
iCreator1row = imgPnl.add( 'group', un, un );
iCreator1row.margins = 0;
iCreator1row.spacing = singleFieldRowSpacing;
iCreator1label = iCreator1row.add( 'statictext', un, "Creator" );
iCreator1label.preferredSize = iImageLabel;
iCreator1label.justify = 'right';
iCreator1label.helpTip = iCreator1labelTT;
iCreator1 = iCreator1row.add( 'edittext', un, un );
iCreator1.preferredSize = iRightsEdit;
//
iCreatorJobRow = imgPnl.add( 'group', un, un );
iCreatorJobRow.margins = 0;
iCreatorJobRow.spacing = singleFieldRowSpacing;
iCreatorJobLabel = iCreatorJobRow.add( 'statictext', un, "Creator's Job Title" );
iCreatorJobLabel.preferredSize = iImageLabel;
iCreatorJobLabel.justify = 'right';
iCreatorJobLabel.helpTip = iCreatorJobLabelTT
iCreatorJob = iCreatorJobRow.add( 'edittext', un, un );
iCreatorJob.preferredSize = iRightsEdit;
//
iDateCreatedRow = imgPnl.add( 'group', un, un );
iDateCreatedRow.margins = 0;
iDateCreatedRow.spacing = singleFieldRowSpacing;
iDateCreatedLabel = iDateCreatedRow.add( 'statictext', un, "Date Created" );
iDateCreatedLabel.preferredSize = iImageLabel;
iDateCreatedLabel.justify = 'right';
iDateCreatedLabel.helpTip = iDateCreatedLabelTT
iDateCreated = iDateCreatedRow.add( 'edittext', un, un );
iDateCreated.preferredSize = [250,18];
iDateHelp= iDateCreatedRow.add( 'statictext', un, "YYYY-MM-DD, e.g., 2015-01-30" );
iDateHelp.preferredSize = [200,18];
iDateHelp.justify = 'left';
//
iLocDisplayGroup= imgPnl.add( 'group', un, un );
    iLocDisplayGroup.spacing = singleFieldRowSpacing;
    iLocDisplayGroupLabel = iLocDisplayGroup.add( 'statictext', un, "Location" );
    iLocDisplayGroupLabel.preferredSize = iImageLabel;
    iLocDisplayGroupLabel.alignment = 'top';
    iLocDisplayGroupLabel.justify = 'right';
    iLocDisplayGroupLabel.helpTip = iLocDisplayGroupLabelTT
iLocDisplayPanel = iLocDisplayGroup.add( 'panel', un, "");
    iLocDisplayPanel.spacing = 1;
    iLocDisplayPanel.margins = [1,1,1,1];
    iLocDisplayPanel.alignChildren = 'left'
iLocDisplaySubRow = iLocDisplayPanel.add( 'group', un, un );
    iLocDisplaySubRow.margins = 0;
    iLocDisplaySubRow.spacing = singleFieldRowSpacing;
    iLocDisplaySubLabel = iLocDisplaySubRow.add( 'statictext', un, "Sublocation" );
    iLocDisplaySubLabel.preferredSize = iLocLabel;
    iLocDisplaySubLabel.justify = 'right';
    iLocDisplaySubLabel.helpTip = iLocDisplaySubLabelTT
    iLocDisplaySubEdit = iLocDisplaySubRow.add( 'edittext', un, un );
    iLocDisplaySubEdit.preferredSize = iLocEdit;
iLocDisplayCityRow = iLocDisplayPanel.add( 'group', un, un );
    iLocDisplayCityRow.margins = 0;
    iLocDisplayCityRow.spacing = singleFieldRowSpacing;
    iLocDisplayCityLabel = iLocDisplayCityRow.add( 'statictext', un, "City" );
    iLocDisplayCityLabel.preferredSize = iLocLabel;
    iLocDisplayCityLabel.justify = 'right';
    iLocDisplayCityEdit = iLocDisplayCityRow.add( 'edittext', un, un );
    iLocDisplayCityEdit.preferredSize = iLocEdit;
iLocDisplayCityStProvRow = iLocDisplayPanel.add( 'group', un, un );
    iLocDisplayCityStProvRow.margins = 0;
    iLocDisplayCityStProvRow.spacing = singleFieldRowSpacing;
    iLocDisplayCityStProvLabel = iLocDisplayCityStProvRow.add( 'statictext', un, "State/Province" );
    iLocDisplayCityStProvLabel.preferredSize = iLocLabel;
    iLocDisplayCityStProvLabel.justify = 'right';
    iLocDisplayCityStProvEdit = iLocDisplayCityStProvRow.add( 'edittext', un, un );
    iLocDisplayCityStProvEdit.preferredSize = iLocEdit;
iLocDisplayContryNmRow = iLocDisplayPanel.add( 'group', un, un );
    iLocDisplayContryNmRow.margins = 0;
    iLocDisplayContryNmRow.spacing = singleFieldRowSpacing;
    iLocDisplayContryNmLabel = iLocDisplayContryNmRow.add( 'statictext', un, "Country Name" );
    iLocDisplayContryNmLabel.preferredSize = iLocLabel;
    iLocDisplayContryNmLabel.justify = 'right';
    iLocDisplayContryNmEdit = iLocDisplayContryNmRow.add('edittext', un, un)
    iLocDisplayContryNmEdit.preferredSize = iLocEdit;
iLocDisplayContryCdRow = iLocDisplayPanel.add( 'group', un, un );
    iLocDisplayContryCdRow.margins = 0;
    iLocDisplayContryCdRow.spacing = singleFieldRowSpacing;
    iLocDisplayContryCdLabel = iLocDisplayContryCdRow.add( 'statictext', un, "Country Code" );
    iLocDisplayContryCdLabel.preferredSize = iLocLabel;
    iLocDisplayContryCdLabel.justify = 'right';
    iLocDisplayContryCdLabel.helpTip = iLocContryCdLabelTT
    iLocDisplayContryCdEdit = iLocDisplayContryCdRow.add('edittext', un, un)
    iLocDisplayContryCdEdit.preferredSize = singleLabel;
iLocScr1 = iLocDisplayContryCdRow.add( 'statictext', un, "" );
iLocScr1.preferredSize = buttonSize1
iLocCd2 = iLocDisplayContryCdRow.add( 'radiobutton', un, "2" );
    iLocCd2.preferredSize = buttonSize3
    iLocCd2.value = true
    iLocCd2.helpTip = iLocCd2TT
    iLocCd2.onClick = function(){toggleIsoCC (1, iLocDisplayContryNmEdit, iLocDisplayContryCdEdit, 2)}
iLocCd3 = iLocDisplayContryCdRow.add( 'radiobutton', un, "3" );
    iLocCd3.preferredSize = buttonSize3
    iLocCd3.helpTip = iLocCd3TT
    iLocCd3.onClick = function(){toggleIsoCC (1, iLocDisplayContryNmEdit, iLocDisplayContryCdEdit, 3)}
iLocLookup = iLocDisplayContryCdRow.add( 'button', un, "Lookup Country and Code" );
    iLocLookup.preferredSize = [200,22];
    iLocLookup.helpTip = iLocLookupTT
    iLocLookup.onClick = function(){isoCntryParams = [true,iLocDisplayContryNmEdit,iLocDisplayContryCdEdit,iLocDisplayWorlRegEdit]; setCntryWin.show()}

iLocDisplayWorlRegRow = iLocDisplayPanel.add( 'group', un, un );
    iLocDisplayWorlRegRow.margins = 0;
    iLocDisplayWorlRegRow.spacing = singleFieldRowSpacing;
    iLocDisplayWorlRegLabel = iLocDisplayWorlRegRow.add( 'statictext', un, "World Region" );
    iLocDisplayWorlRegLabel.preferredSize = iLocLabel;
    iLocDisplayWorlRegLabel.justify = 'right';
    iLocDisplayWorlRegEdit = iLocDisplayWorlRegRow.add('edittext', un, un)
    iLocDisplayWorlRegEdit.preferredSize = iLocEdit;

// Fill button
fillBtns = imgPnl.add( 'group', un, un);
fillBtns.margins = [1,10,1,0];
fillBtns.spacing = singleFieldRowSpacing;
fillBtns.orientation = 'row';
fillBtns.alignment = 'left';
fillBtnsSpacer = fillBtns.add('statictext', un, "");
fillBtnsSpacer.preferredSize = [80,18]
fillBtnsAll = fillBtns.add( 'button', un, "Fill");
fillBtnsAll.preferredSize = buttonSize5;
fillBtnsAll.onClick = function (){
    updateImageHeadline();
	updateImageDescription();
	updateImageKeywords();
    saveEnabled();
    }; 
fillBtnsInfo = fillBtns.add('statictext', un, " fields below using Artwork/Object data");
fillBtnsInfo.justify = 'left';
fillBtnsInfo.preferredSize = [250,18];

clearAll = fillBtns.add( 'button', un, "Clear");
clearAll.preferredSize = buttonSize5;
clearAll.onClick = function(){
    iHeadlineEdit.text  = "";
    iDescEdit.text  = "";
    iKeywEdit.text  = "";
    saveEnabled();
    };
fillBtnsSpc1 = fillBtns.add('statictext', un, "");
fillBtnsSpc1.preferredSize = [40,22];
fillOptsBtn = fillBtns.add( 'button', un, "Options");
fillOptsBtn.preferredSize = [75,22];
fillOptsBtn.onClick = function(){
    fillOptsWin.show()
    };
//
iHeadlineGroup = imgPnl.add('group',un,un);
iHeadlineGroup.margins = 0;
iHeadlineGroup.spacing = singleFieldRowSpacing;
iHeadlineLabel = iHeadlineGroup.add('statictext',un,"Headline");
iHeadlineLabel.preferredSize = iImageLabel;
iHeadlineLabel.alignment = 'top';
iHeadlineLabel.justify = 'right';
iHeadlineLabel.helpTip = iHeadlineLabelTT
iHeadlineEdit = iHeadlineGroup.add('edittext',un,un);
iHeadlineEdit.preferredSize = iRightsEditTall;
//
iDescGroup = imgPnl.add('group',un,un);
iDescGroup.margins = 0;
iDescGroup.spacing = singleFieldRowSpacing;
//iDescGroup.alignChildren = ['top', 'fill']
iDescLabel = iDescGroup.add('statictext',un,"Description");
iDescLabel.preferredSize = iImageLabel;
iDescLabel.alignment = 'top'
iDescLabel.justify = 'right';
iDescLabel.helpTip = iDescLabelTT
iDescEdit = iDescGroup.add('edittext',un,un,{multiline:true});
iDescEdit.preferredSize = iRightsEditExtraTall;
//
iKeywGroup = imgPnl.add('group',un,un);
iKeywGroup.margins = 0;
iKeywGroup.spacing = singleFieldRowSpacing;
iKeywGroup.alignChildren = ['top', 'fill']
iKeywLabel = iKeywGroup.add('statictext',un,"Keywords");
iKeywLabel.preferredSize = iImageLabel;
iKeywLabel.alignment = 'top';
iKeywLabel.justify = 'right';
iKeywLabel.helpTip = iKeywLabelTT
iKeywEdit = iKeywGroup.add('edittext',un,un,{multiline:true});
iKeywEdit.preferredSize = iRightsEditExtraTall;

fillOptsWin = new Window('palette', "Fill Options");
fillOptsWin.orientation = 'column';
fillOptsWin.alignment = 'right';
fillOptsWin.alignChildren = 'left';
fillOptsWin.spacing = 10;
fillOptsWin.margins = [5,10,5,5];

sepPnl = fillOptsWin.add( 'panel', un, "Separator between values" );
sepPnl.alignChildren = ['left', 'top']
fillHeadDelimGrp = sepPnl.add( 'group', un, un );
fillHeadDelimGrp.spacing = 5;
fillHeadDelimLabel = fillHeadDelimGrp.add( 'statictext', un, "Headline" );
fillHeadDelimLabel.preferredSize = [80,20]
fillHeadDelimLabel.justify = 'right'
fillHeadDelim = fillHeadDelimGrp.add('dropdownlist', un, un,{items:headSepArray})
fillHeadDelim.graphics.foregroundColor = fillHeadDelim.graphics.newPen (fillHeadDelim.graphics.PenType.SOLID_COLOR, black, 1)
fillHeadDelim.graphics.backgroundColor = fillHeadDelim.graphics.newBrush (fillHeadDelim.graphics.BrushType.SOLID_COLOR, white, 1)
fillHeadDelim.selection = 0
fillHeadDelimEx = fillHeadDelimGrp.add( 'statictext', un, "Palazzo della Ragione"+headSeparator+"Frontal view of the north elevation");
fillHeadDelimEx.preferredSize = [480,20];

fillDescDelimGrp = sepPnl.add( 'group', un, un );
fillDescDelimGrp.spacing = 5;
fillDescDelimLabel = fillDescDelimGrp.add( 'statictext', un, "Description" );
fillDescDelimLabel.preferredSize = [80,24]
fillDescDelimLabel.justify = 'right'
fillDescDelim = fillDescDelimGrp.add('dropdownlist', un, un,{items:descSepArray})
fillDescDelim.graphics.foregroundColor = fillDescDelim.graphics.newPen (fillDescDelim.graphics.PenType.SOLID_COLOR, black, 1)
fillDescDelim.graphics.backgroundColor = fillDescDelim.graphics.newBrush (fillDescDelim.graphics.BrushType.SOLID_COLOR, white, 1)
fillDescDelim.selection = 0
fillDescDelimEx = fillDescDelimGrp.add( 'statictext', un, "Andrea Palladio"+descSeparator+"Palazzo della Ragione"+descSeparator+"1548-1617"+descSeparator+"Vicenza, Veneto, Italy");
fillDescDelimEx.preferredSize = [480,20];

fillKeyDelimEx = sepPnl.add( 'statictext', un, "Keywords must always use the separator '; '");
fillKeyDelimEx.preferredSize = [480,20];
fillKeyDelimEx.indent = 20

fillOptsWinSave = fillOptsWin.add( 'button', un, "Save" );
fillOptsWinSave.preferredSize = buttonSize5a
fillOptsWinSave.alignment = ['center','bottom']
fillOptsWinSave.onClick =  function(){
    descSeparator = fillDescDelim.selection.text
     fillOptsWin.hide();
     fillOptsWin.close();
    }			

    //////////////////////////////////////////////////////////////////////////
  //////////////// IMAGE RIGHTS PANEL //////////////
///////////////////////////////////////////////////////////////////////////
// Image Rights  &  Admin container
imgRtsPnl = fieldsCol1.add('panel',un,"IMAGE RIGHTS")
imgRtsPnl.orientation = 'column'
imgRtsPnl.alignChildren = 'left'
imgRtsPnl.preferredSize = colSize2
imgRtsPnl.spacing = 5
imgRtsPnl.visible = false
// Fields
iCreditLnGroup = imgRtsPnl.add( 'group', un, un );
iCreditLnGroup.margins = 0;
iCreditLnGroup.spacing = singleFieldRowSpacing;
iCreditLnGroup.alignChildren = ['top', 'fill']

iCreditLnLblGroup = iCreditLnGroup.add( 'group', un, un );
iCreditLnLblGroup.orientation = 'column'

iCreditLnGroupLabel = iCreditLnLblGroup.add( 'statictext', un, "Credit Line" );
iCreditLnGroupLabel.alignment = 'top'
iCreditLnGroupLabel.preferredSize = iRightsLabel;
iCreditLnGroupLabel.justify = 'right';
iCreditLnGroupLabel.helpTip = iCreditLnLabelTT
iClSymbol = iCreditLnLblGroup.add( 'button', un, "©");
iClSymbol.alignment = 'right'
iClSymbol.maximumSize = buttonSize3;
iClSymbol.onClick = function(){
    iCreditLn.text  = "© "+iCreditLn.text;
    saveEnabled();
    };

iCreditLn = iCreditLnGroup.add( 'edittext', un, un,{multiline:true});
iCreditLn.preferredSize = iRightsEditVeryTall;
//
iCopyrOwnerGroup= imgRtsPnl.add( 'group', un, un );
iCopyrOwnerGroup.spacing = singleFieldRowSpacing;
iCopyrOwnerGroup.alignChildren = ['top', 'fill']
iCopyrOwnerGroupLabel = iCopyrOwnerGroup.add( 'statictext', un, "Copyright Owner" );
iCopyrOwnerGroupLabel.preferredSize = iRightsLabel;
iCopyrOwnerGroupLabel.alignment = 'top'
iCopyrOwnerGroupLabel.justify = 'right';
iCopyrOwnerGroupLabel.helpTip = iCopyrOwnerGroupLabelTT
iCopyrOwnerPanel = iCopyrOwnerGroup.add( 'panel', un, "");
iCopyrOwnerPanel.spacing = 1;
iCopyrOwnerPanel.margins = [1,1,1,1];
iCopyrOwnerRow = iCopyrOwnerPanel.add( 'group', un, un );
iCopyrOwnerRow.margins = 0;
iCopyrOwnerRow.spacing = singleFieldRowSpacing;
iCopyrOwnerNameLabel = iCopyrOwnerRow.add( 'statictext', un, "Name" );
iCopyrOwnerNameLabel.preferredSize = subSingleLabel;
iCopyrOwnerNameLabel.justify = 'right';
iCopyrOwnerName = iCopyrOwnerRow.add( 'edittext', un, un );
iCopyrOwnerName.preferredSize = subSingleEditShort;
iCopyrOwnerName.helpTip = wCreator1NameTT
iCopyrOwnerIDRow = iCopyrOwnerPanel.add( 'group', un, un );
iCopyrOwnerIDRow.margins = 0;
iCopyrOwnerIDRow.spacing = singleFieldRowSpacing;
iCopyrOwnerIdLabel = iCopyrOwnerIDRow.add( 'statictext', un, "ID" );
iCopyrOwnerIdLabel.preferredSize = subSingleLabel;
iCopyrOwnerIdLabel.justify = 'right';
iCopyrOwnerId = iCopyrOwnerIDRow.add( 'edittext', un, un );
iCopyrOwnerId.preferredSize = subSingleEditShort;
//
iCRnoticeGroup = imgRtsPnl.add( 'group', un, un );
iCRnoticeGroup.margins = 0;
iCRnoticeGroup.spacing = singleFieldRowSpacing;
iCRnoticeGroup.alignChildren = ['top', 'fill']

iCRnoticeLblGroup = iCRnoticeGroup.add( 'group', un, un );
iCRnoticeLblGroup.orientation = 'column'
iCRnoticeGroupLabel = iCRnoticeLblGroup.add( 'statictext', un, "Copyright Notice" );
iCRnoticeGroupLabel.preferredSize = iRightsLabel;
iCRnoticeGroupLabel.justify = 'right';
iCRnoticeGroupLabel.helpTip = iCRnoticeGroupLabelTT
iCsymbol = iCRnoticeLblGroup.add( 'button', un, "©");
iCsymbol.alignment = 'right'
iCsymbol.maximumSize = buttonSize3;
iCsymbol.onClick = function(){
    iCRnotice.text  = "© "+iCRnotice.text;
    saveEnabled();
    };
iCRnotice = iCRnoticeGroup.add( 'edittext', un, un,{multiline:true});
iCRnotice.preferredSize = iRightsEditExtraTall
//
iRightsUsageTRow = imgRtsPnl.add( 'group', un, un );
iRightsUsageTRow.margins = 0;
iRightsUsageTRow.spacing = singleFieldRowSpacing;
iRightsUsageTRow.alignChildren = ['top', 'fill'];
iRightsUsageTLabel = iRightsUsageTRow.add( 'statictext', un, "Rights Usage Terms" );
iRightsUsageTLabel.alignment = 'top'
iRightsUsageTLabel.preferredSize = iRightsLabel;
iRightsUsageTLabel.justify = 'right';
iRightsUsageTLabel.helpTip = iRightsUsageTLabelTT
iRightsUsageT = iRightsUsageTRow.add( 'edittext', un, un,{multiline:true});
iRightsUsageT.preferredSize = iRightsEditExtraTall
//
iLicensorGroup= imgRtsPnl.add( 'group', un, un );
iLicensorGroup.spacing = singleFieldRowSpacing;
iLicensorGroup.alignChildren = ['top', 'fill']
iLicensorGroupLabel = iLicensorGroup.add( 'statictext', un, "Licensor" );
iLicensorGroupLabel.preferredSize = iRightsLabel;
iLicensorGroupLabel.alignment = 'top'
iLicensorGroupLabel.justify = 'right';
iLicensorGroupLabel.helpTip = iLicensorGroupLabelTT
iLicensorPanel = iLicensorGroup.add( 'panel', un, "" );
iLicensorPanel.spacing = 1;
iLicensorPanel.margins = [1,1,1,1];
iLicensorNameRow = iLicensorPanel.add( 'group', un, un );
iLicensorNameRow.margins = 0;
iLicensorNameRow.spacing = singleFieldRowSpacing;
iLicensorNameLabel = iLicensorNameRow.add( 'statictext', un, "Name" );
iLicensorNameLabel.preferredSize = iRightsSubLabel;
iLicensorNameLabel.justify = 'right';
iLicensorName = iLicensorNameRow.add( 'edittext', un, un );
iLicensorName.preferredSize = iRightsSubEdit;
iLicensorIDRow = iLicensorPanel.add( 'group', un, un );
iLicensorIDRow.margins = 0;
iLicensorIDRow.spacing = singleFieldRowSpacing;
iLicensorIDLabel = iLicensorIDRow.add( 'statictext', un, "ID" );
iLicensorIDLabel.preferredSize = iRightsSubLabel;
iLicensorIDLabel.justify = 'right';
iLicensorID = iLicensorIDRow.add( 'edittext', un, un );
iLicensorID.preferredSize = iRightsSubEdit;
iLicensorTel1Row = iLicensorPanel.add( 'group', un, un );
iLicensorTel1Row.margins = 0;
iLicensorTel1Row.spacing = singleFieldRowSpacing;
iLicensorTel1Label = iLicensorTel1Row.add( 'statictext', un, "Telphone 1" );
iLicensorTel1Label.preferredSize = iRightsSubLabel;
iLicensorTel1Label.justify = 'right';
iLicensorTel1 = iLicensorTel1Row.add( 'edittext', un, un );
iLicensorTel1.preferredSize = iRightsSubEdit;
iLicensorTel2Row = iLicensorPanel.add( 'group', un, un );
iLicensorTel2Row.margins = 0;
iLicensorTel2Row.spacing = singleFieldRowSpacing;
iLicensorTel2Label = iLicensorTel2Row.add( 'statictext', un, "Telephone 2" );
iLicensorTel2Label.preferredSize = iRightsSubLabel;
iLicensorTel2Label.justify = 'right';
iLicensorTel2 = iLicensorTel2Row.add( 'edittext', un, un );
iLicensorTel2.preferredSize = iRightsSubEdit;
iLicensorEmailRow = iLicensorPanel.add( 'group', un, un );
iLicensorEmailRow.margins = 0;
iLicensorEmailRow.spacing = singleFieldRowSpacing;
iLicensorEmailLabel = iLicensorEmailRow.add( 'statictext', un, "Email" );
iLicensorEmailLabel.preferredSize = iRightsSubLabel;
iLicensorEmailLabel.justify = 'right';
iLicensorEmail = iLicensorEmailRow.add( 'edittext', un, un );
iLicensorEmail.preferredSize = iRightsSubEdit;
iLicensorWebRow = iLicensorPanel.add( 'group', un, un );
iLicensorWebRow.margins = 0;
iLicensorWebRow.spacing = singleFieldRowSpacing;
iLicensorWebLabel = iLicensorWebRow.add( 'statictext', un, "Web Address" );
iLicensorWebLabel.preferredSize = iRightsSubLabel;
iLicensorWebLabel.justify = 'right';
iLicensorWeb = iLicensorWebRow.add( 'edittext', un, un );
iLicensorWeb.preferredSize = iRightsSubEdit;
iPropRelGroup= imgRtsPnl.add( 'group', un, un );
iPropRelGroup.spacing = singleFieldRowSpacing;
iPropRelGroup.alignChildren = ['top', 'fill']

iPropRelGroupLabel = iPropRelGroup.add( 'statictext', un, "Property Release" );
iPropRelGroupLabel.preferredSize = iRightsLabel;
iPropRelGroupLabel.alignment = 'top'
iPropRelGroupLabel.justify = 'right';
iPropRelGroupLabel.helpTip = iPropRelGroupLabelTT
iPropRelPanel = iPropRelGroup.add( 'panel', un, "" );
iPropRelPanel.spacing = singleFieldRowSpacing;
iPropRelPanel.margins = [1,1,1,1];

iPropRelStatusRow = iPropRelPanel.add( 'group', un, un );
iPropRelStatusRow.margins = 0
iPropRelStatusRow.spacing = 1;
iPropRelStatusLabel = iPropRelStatusRow.add( 'statictext', un, "Status" );
iPropRelStatusLabel.preferredSize = iRightsSubLabel;
iPropRelStatusLabel.justify = 'right';
iPropRelStatusLabel.helpTip = iPropRelStatusLabelTT
iPropRelStatus = iPropRelStatusRow.add('dropdownlist', un, un,{items: iPropRelStatusDisplayArray,} )
iPropRelStatus.graphics.foregroundColor = iPropRelStatus.graphics.newPen (iPropRelStatus.graphics.PenType.SOLID_COLOR, black, 1)
iPropRelStatus.graphics.backgroundColor = iPropRelStatus.graphics.newBrush (iPropRelStatus.graphics.BrushType.SOLID_COLOR, white, 1)
iPropRelStatus.preferredSize = iRightsSubDrpEdit;
iPropRelIDRow = iPropRelPanel.add( 'group', un, un );
iPropRelIDRow.margins = 0;
iPropRelIDRow.spacing = singleFieldRowSpacing;
iPropRelIDLabel = iPropRelIDRow.add( 'statictext', un, "ID" );
iPropRelIDLabel.preferredSize = iRightsSubLabel;
iPropRelIDLabel.justify = 'right';
iPropRelID = iPropRelIDRow.add( 'edittext', un, un );
iPropRelID.preferredSize = iRightsSubEdit;
/////////////////////////////////////////////////////  
//////////////// IMAGE ADMIN PANEL //////////////
///////////////////////////////////////////////////// 

adminPnl = fieldsCol1.add('panel',un,"IMAGE ADMIN")
adminPnl.orientation = 'column'
adminPnl.alignChildren = 'left'
adminPnl.preferredSize = colSize2
adminPnl.spacing = 5
adminPnl.visible = false
// Fields
//
iInstructRow = adminPnl.add( 'group', un, un );
iInstructRow.margins = 0;
iInstructRow.spacing = singleFieldRowSpacing;
iInstructRow.alignChildren = ['top', 'fill'];
iInstructLabel = iInstructRow.add( 'statictext', un, "Instructions" );
iInstructLabel.preferredSize = iRightsLabel;
iInstructLabel.justify = 'right';
iInstructLabel.helpTip = iInstructLabelTT
iInstruct = iInstructRow.add( 'edittext', un, un,{multiline:true});
iInstruct.preferredSize = iRightsEditVeryTall;
//
iDigSrcType = adminPnl.add( 'group', un, un );
iDigSrcType.margins = 0;
iDigSrcType.spacing = detailsSingleFieldRowSpacing;
iDigSrcTypeLabel = iDigSrcType.add('statictext', un, "Digital Source Type");
iDigSrcTypeLabel.preferredSize = iRightsLabel;
iDigSrcTypeLabel.justify = 'right';
iDigSrcTypeLabel.helpTip = iDigSrcTypeLabelTT
iDigSrcType = iDigSrcType.add('dropdownlist', un, un,{items: sourceTypeArray,} )
iDigSrcType.graphics.foregroundColor = iDigSrcType.graphics.newPen (iDigSrcType.graphics.PenType.SOLID_COLOR, black, 1)
iDigSrcType.graphics.backgroundColor = iDigSrcType.graphics.newBrush (iDigSrcType.graphics.BrushType.SOLID_COLOR, white, 1)
iDigSrcType.preferredSize = drpdwnLrg;

//
iMaxRow = adminPnl.add( 'group', un, un );
iMaxRow.margins = 0;
iMaxRow.spacing = singleFieldRowSpacing;
iMaxWidthLabel = iMaxRow.add( 'statictext', un, "Maximum  Width" );
iMaxWidthLabel.preferredSize = iRightsLabel;
iMaxWidthLabel.justify = 'right';
iMaxWidthLabel.helpTip = iMaxWidthLabelTT
iMaxWidth = iMaxRow.add( 'edittext', un, un );
iMaxWidth.preferredSize = [100,18]
//
iMaxHeightLabel = iMaxRow.add( 'statictext', un, "Height" );
iMaxHeightLabel.preferredSize = [50,18]
iMaxHeightLabel.justify = 'right';
iMaxHeightLabel.helpTip = iMaxHeightLabelTT
iMaxHeight = iMaxRow.add( 'edittext', un, un );
iMaxHeight.preferredSize = [100,18];
//
iSupplierGroup= adminPnl.add( 'group', un, un );
iSupplierGroup.spacing = singleFieldRowSpacing;
iSupplierGroup.alignChildren = ['top', 'fill']

iSupplierGroupLabel = iSupplierGroup.add( 'statictext', un, "Supplier" );
iSupplierGroupLabel.preferredSize = iRightsLabel;
iSupplierGroupLabel.justify = 'right';
iSupplierGroupLabel.helpTip = iSupplierGroupLabelTT
iSupplierPanel = iSupplierGroup.add( 'panel', un, "" );
iSupplierPanel.spacing = 1;
iSupplierPanel.margins = [1,1,1,1];

iSupplierNameRow = iSupplierPanel.add( 'group', un, un );
iSupplierNameRow.margins = 0;
iSupplierNameRow.spacing = singleFieldRowSpacing;
iSupplierNameLabel = iSupplierNameRow.add( 'statictext', un, "Name" );
iSupplierNameLabel.preferredSize = iAdminSubLabel;
iSupplierNameLabel.justify = 'right';
iSupplierName = iSupplierNameRow.add( 'edittext', un, un );
iSupplierName.preferredSize = iAdminSubEdit;
iSupplierIDRow = iSupplierPanel.add( 'group', un, un );
iSupplierIDRow.margins = 0;
iSupplierIDRow.spacing = singleFieldRowSpacing;
iSupplierIDLabel = iSupplierIDRow.add( 'statictext', un, "Supplier ID" );
iSupplierIDLabel.preferredSize = iAdminSubLabel;
iSupplierIDLabel.justify = 'right';
iSupplierID = iSupplierIDRow.add( 'edittext', un, un );
iSupplierID.preferredSize = iAdminSubEdit;
//
iSupplierImageIDRow = iSupplierPanel.add( 'group', un, un );
iSupplierImageIDRow.margins = 0;
iSupplierImageIDRow.spacing = singleFieldRowSpacing;
iSupplierImageIDLabel = iSupplierImageIDRow.add( 'statictext', un, "Image ID" );
iSupplierImageIDLabel.preferredSize = iAdminSubLabel;
iSupplierImageIDLabel.justify = 'right';
iSupplierImageID = iSupplierImageIDRow.add( 'edittext', un, un );
iSupplierImageID.preferredSize = iAdminSubEdit;
//
iRegistryGroup= adminPnl.add( 'group', un, un );
iRegistryGroup.spacing = singleFieldRowSpacing;
iRegistryGroup.alignChildren = ['top', 'fill']

iRegistryGroupLabel = iRegistryGroup.add( 'statictext', un, "Registry Entry" );
iRegistryGroupLabel.preferredSize = iRightsLabel;
iRegistryGroupLabel.justify = 'right';
iRegistryGroupLabel.helpTip = iRegistryGroupLabelTT

iRegistryPanel = iRegistryGroup.add( 'panel', un, "" );
iRegistryPanel.spacing = 1;
iRegistryPanel.margins = [1,1,1,1];

iRegistryOrgIdRow = iRegistryPanel.add( 'group', un, un );
iRegistryOrgIdRow.margins = 0;
iRegistryOrgIdRow.spacing = singleFieldRowSpacing;
iRegistryOrgIdLabel = iRegistryOrgIdRow.add( 'statictext', un, "Organization ID" );
iRegistryOrgIdLabel.preferredSize = iAdminSubLabel;
iRegistryOrgIdLabel.justify = 'right';
iRegistryOrgId = iRegistryOrgIdRow.add( 'edittext', un, un );
iRegistryOrgId.preferredSize = iAdminSubEdit;
//
iRegistryImageIDRow = iRegistryPanel.add( 'group', un, un );
iRegistryImageIDRow.margins = 0;
iRegistryImageIDRow.spacing = singleFieldRowSpacing;
iRegistryImageIDLabel = iRegistryImageIDRow.add( 'statictext', un, "Image ID" );
iRegistryImageIDLabel.preferredSize = iAdminSubLabel;
iRegistryImageIDLabel.justify = 'right';
iRegistryImageID = iRegistryImageIDRow.add( 'edittext', un, un );
iRegistryImageID.preferredSize = iAdminSubEdit;

// Footer
footerButtons = winIptcChPnl.add('group', un, un);
footerButtons.margins = [5,0,5,0];
footerButtons.spacing = 4;
footerButtons.alignment = 'left'
footerButtons.alignChildren = ['left','center']
footerButtons.preferredSize = footerSize 

footerButtonsMultiAoWin = footerButtons.add('checkbox', un, 'show "more metadata" warning')
footerButtonsMultiAoWin.alignment = 'left'
footerButtonsMultiAoWin.value = true
footerButtonsMultiAoWin.onClick = function(){
    if(footerButtonsMultiAoWin.value == true){
        multiAoWinDont.value = false
        footerButtonsMultiAoWinVal = true
        }
    else{
        multiAoWinDont.value = true
        footerButtonsMultiAoWinVal = false
        }
    }

footerButtonsSpacer1 = footerButtons.add( 'statictext', un, "" );
footerButtonsSpacer1.preferredSize = spacer5

footerButtons.save = footerButtons.add( 'button', un, "Save" );
footerButtons.save.preferredSize = buttonSize7a
footerButtons.save.enabled = false;
footerButtons.save.onClick =  function(){ writeXMP() }			
    footerButtons.cancel = footerButtons.add( 'button', un, "Close" );
    footerButtons.cancel.onClick =  function(){     
        if (footerButtons.save.enabled == true){
             // when the Cancel or Close buttons are clicked: if changes have not been save, show alert
            closeSaveAlert = new Window('palette', "IPTC Metadata - Unsaved Changes");
            closeSaveAlert.preferredSize = [340,un]; 
            closeSaveAlert .alignChildren = 'center';
            var filesList = lastViewedThumb.join("\n")     
            closeSaveAlert.Body = closeSaveAlert.add( 'group', un, un );
            closeSaveAlert.Body.margins = [25,0,0,0];
            closeSaveAlert.Text = closeSaveAlert.Body.add( 'statictext', un, "Save changes to previous file(s)?\n\n"+filesList, {multiline:true});
            closeSaveAlert.Text.preferredSize = [240, lastViewedThumb.length*20+40];
            closeSaveAlert.Text.justify = 'left';
            closeSaveAlert.footerButtons = closeSaveAlert.add( 'group', un, un );
            closeSaveAlert.save = closeSaveAlert.footerButtons.add( 'button', un, "Yes" );
            closeSaveAlert.save.onClick = function(){  
                writeXMP();
                closeSaveAlert.hide();
                closeSaveAlert.close();
                winIptcChPnl.hide();
                winIptcChPnl.close();
                } 
            closeSaveAlert.no = closeSaveAlert.footerButtons.add( 'button', un, "No" );
            closeSaveAlert.no.onClick = function(){  
                closeSaveAlert.hide();
                closeSaveAlert.close();
                save1.enabled = false;
                footerButtons.save.enabled = false;
                winIptcChPnl.hide();
                winIptcChPnl.close();
                }
            closeSaveAlert.show();
            closeSaveAlert.active = true;
            }
        else{
            winIptcChPnl.hide();
            winIptcChPnl.close();
            }
        winIptcChPnl.hide();
		winIptcChPnl.close();
        }	
   //
footerButtonsSpacer2 = footerButtons.add( 'statictext', un, "" );
footerButtonsSpacer2.preferredSize = spacer6

footerButtons.iptc = footerButtons.add( 'button', un, "About" );
footerButtons.iptc.preferredSize = [70,22];
footerButtons.iptc.onClick = function(){aboutWin.show()}  
aboutWin =  new Window('palette', "About the panel");
aboutWin.preferredSize = [400,un]; 
aboutWin.alignChildren = ['top','center'];
aboutWin.spacing = 20
var aboutText = "Version: "+plgnVers+"\nCode version: "+codeVers+"\n\nThis metadata panel contains a subset of fields from the IPTC Photometadata Standard 2016 that are relevant for digital images of cultural heritage objects."
aboutBody = aboutWin.add( 'statictext', un, aboutText, {multiline:true});
aboutBody.preferredSize = [390,100]; 
aboutiptcPhGrp = aboutWin.add( 'group', un, un );
aboutiptcPhGrp.spacing = 2
aboutiptcPhGrp.alignment = 'left'
aboutiptcPhGrp.orientation = 'column'
aboutGotoIPTC = aboutiptcPhGrp.add( 'button', un, "Go to IPTC Photo Metadata Standard" );
aboutGotoIPTC.preferredSize = [260,28];
aboutGotoIPTC.alignment = 'left'
aboutGotoIPTC.onClick = function(){app.openUrl("www.iptc.org/photometadata")}
aboutVraGrp = aboutiptcPhGrp.add( 'group', un, un );
aboutVraGrp.spacing = 2
aboutGotoText1 = aboutVraGrp.add( 'statictext', un, "If you require a more detailed schema: ");
aboutGotoIPTC = aboutVraGrp.add( 'button', un, "Go to VRA Bridge Tools" );
aboutGotoIPTC.preferredSize = [180,28];
aboutGotoIPTC.onClick = function(){app.openUrl("http://metadatadeluxe.pbworks.com/w/page/108523528/VRA%20Bridge%20Metadata%20Tools")}
aboutSpacer1 = aboutWin.add('statictext', un, "");
aboutSpacer1.preferredSize = [10,20]; 
aboutComments = aboutWin.add('statictext', un, "Questions, comments?  Email: chpanel@iptc.org");
aboutComments.preferredSize = [390,20];
aboutComments.justify = 'left'
aboutCancel = aboutWin.add( 'button', un, "Close" );   
aboutCancel.onClick = function(){ 
    aboutWin.hide();
    aboutWin.close();
    }		

// navigation button clicks
aoBtn.onClick = toggleNavBtns
imgBtn.onClick = toggleNavBtns
imgRightsBtn.onClick = toggleNavBtns
adminBtn.onClick = toggleNavBtns

// if user prefs file exists, read settings and apply to dialog
 var appDataPlgnSetBkSlash = File (appDataFwdSlash + plgnPrefs + plgnOpt + plgnSet)
 if (appDataPlgnSetBkSlash.exists == true){
	  appDataPlgnSetBkSlash.open ('r');
	  var pluginSettingsArray = appDataPlgnSetBkSlash.read().split ("\t");
	  appDataPlgnSetBkSlash.close();
	try{         
		if (pluginSettingsArray[0] == "true") {multiAoWinDontVal = true; multiAoWinDont.value = true} else{multiAoWinDontVal = false; multiAoWinDont.value = false}	
        if (pluginSettingsArray[1] == "true") {footerButtonsMultiAoWinVal = true; footerButtonsMultiAoWin.value = true} else{footerButtonsMultiAoWinVal = false; footerButtonsMultiAoWin.value = false}
    if (pluginSettingsArray[2]) {
      for(var i = 0; i<headSepArray.length; i++){
				if(headSepArray[i] == pluginSettingsArray[2]){
          headSeparator = pluginSettingsArray[2]
					fillHeadDelim.selection = i
          fillHeadDelimEx.text = "Palazzo della Ragione"+headSeparator+"Frontal view of the north elevation"
					}
				}
            }
     if (pluginSettingsArray[3]) {
      for(var ii = 0; ii<descSepArray.length; ii++){
				if(descSepArray[ii] == pluginSettingsArray[3]){
          descSeparator = pluginSettingsArray[3]
					fillDescDelim.selection = ii
          fillDescDelimEx.text = "Andrea Palladio"+descSeparator+"Palazzo della Ragione"+descSeparator+"1548-1617"+descSeparator+"Vicenza, Veneto, Italy"
					}
				}
            }
    if (pluginSettingsArray[4] == "true") {iLocCd2.value = true} else{iLocCd3.value = true}
		}
	  catch(pluginSettingsError){
		   if (appDataPlgnSetBkSlash.exists == true) appDataPlgnSetBkSlash.remove();
          }
     }
// OK, all the UI stuff is defined, now display UI window
winIptcChPnl.show();
winIptcChPnl.center();
// lookup ISO country, code and World Region
var W = 0; //  edittext World Region / Continent
var setCntryWin = new Window ('palette', ' ', [0,0,545,185]);
setCntryWin.center();
setCntryPnl1 = setCntryWin.add ('panel', [15,15,530,140], '');
setCntryPnlGrp1 = setCntryPnl1.add ('group', [0,0,550,10]);
setCntryPnl1Head = setCntryPnl1.add ('statictext', [10,22,475,40], "SELECT COUNTRY 2 and 3 LETTER 'ISO' CODES");
setCntryPnl1Line = setCntryPnl1.add ('panel', [10,50,500,51], '');
setCntryPnl1Not1 = setCntryPnl1.add ('statictext', [10,60,300,80], "Country Names:");
setCntryPnl1Not2 = setCntryPnl1.add ('statictext', [305,60,380,80], "ISO Codes:");
setCntryPnl1Not3 = setCntryPnl1.add ('statictext', [385,60,500,80], "World Region:");
setCntryPnl1ISO1 = setCntryPnl1.add ('dropdownlist', [10,85,300,105], IPTCxLand);
setCntryPnl1ISO1.graphics.foregroundColor = setCntryPnl1ISO1.graphics.newPen (setCntryPnl1ISO1.graphics.PenType.SOLID_COLOR, black, 1)
setCntryPnl1ISO1.graphics.backgroundColor = setCntryPnl1ISO1.graphics.newBrush (setCntryPnl1ISO1.graphics.BrushType.SOLID_COLOR, white, 1)
setCntryPnl1ISO2 = setCntryPnl1.add ('edittext', [305,85,335,105], IPTCxIso2[0], {readonly: true});
setCntryPnl1ISO3 = setCntryPnl1.add ('edittext', [340,85,380,105], IPTCxIso3[0], {readonly: true});
setCntryPnl1Cont = setCntryPnl1.add ('edittext', [385,85,500,105], IPTCxCont[0]);

if (Folder.fs == 'Windows'){
 if (W == 0) setCntryWinNote = setCntryWin.add ('statictext', [210,155,385,170], "Use this Country and ISO Code:");
 else setCntryWinNote = setCntryWin.add ('statictext', [165,155,385,170], "Use this Country, ISO Code and Region:");
 setCntryWinStart = setCntryWin.add ('button', [390,150,460,175], "OK");
 setCntryWinCancel = setCntryWin.add ('button', [460,150,530,175], "Cancel");
 }
 else {
 if (W == 0) setCntryWinNote = setCntryWin.add ('statictext', [185,155,375,170], "Use this Country and ISO Code:");
 else setCntryWinNote = setCntryWin.add ('statictext', [135,155,375,170], "Use this Country, ISO Code and Region:");
 setCntryWinCancel = setCntryWin.add ('button', [380,152,460,174], "Cancel");
 setCntryWinStart = setCntryWin.add ('button', [460,152,530,174], "OK");
 }
setCntryPnl1ISO1.selection = 0;
if (W == 0){ // if  edittext World Region / Continent is empty
 setCntryPnl1Not3.enabled = false;
  setCntryPnl1Cont.enabled = false;
 }
setCntryWinStart.active = true;
setCntryPnl1ISO1.onChange = function(){
    for (var L1 = 0; L1 < IPTCxLand.length; L1++){
         if (setCntryPnl1ISO1.selection.toString() == IPTCxLand[L1]){
             setCntryPnl1ISO2.text = IPTCxIso2[L1];
             setCntryPnl1ISO3.text = IPTCxIso3[L1];
              setCntryPnl1Cont.text = IPTCxCont[L1];
             var L1 = IPTCxLand.length;
             }
         }
     }
setCntryWinStart.onClick = function(){addCntryCdReg()}

////////////////////////// END OF USER INTERFACE  ////////////////////////////////   
////////////////////////// BEGINNING OF FUNCTIONS //////////////////////////////// 
// write ISO country, code and World Region to main form and close lookup window
function addCntryCdReg(){
var X = isoCntryParams[0]
var A = isoCntryParams[1]
var B = isoCntryParams[2]
var C = isoCntryParams[3]

if (X == true){
  A.text = setCntryPnl1ISO1.selection.toString();
  if(iLocCd2.value == true){
  B.text = setCntryPnl1ISO2.text;
  }
  if(iLocCd3.value == true){
  B.text = setCntryPnl1ISO3.text;
  }
if(C){
  C.text = setCntryPnl1Cont.text;
  }
  }
setCntryWin.hide();
setCntryWin.close();
}
setCntryWinCancel.onClick = function(){
    setCntryWin.hide();
 setCntryWin.close();
 }
// END lookup ISO country, code and World Region

// when thumbnails are selected, refresh display
thumbSelected = function( event ) {
    if  ( event.object instanceof Document && event.type == "selectionsChanged" ) {
   //     vocabWin.close();
         if (footerButtons.save.enabled == true){          
             // when another thumbnail is selected: if changes have not been save, show alert
            var filesList = lastViewedThumb.join("\n")  
            changeSaveAlert = new Window('palette', "IPTC Metadata - Unsaved Changes");
            changeSaveAlert.preferredSize = [340,un]; 
            changeSaveAlert.alignChildren = 'center';      
             changeSaveAlert.Body = changeSaveAlert.add( 'group', un, un );
             changeSaveAlert.Body .margins = [25,0,0,0];                   
            changeSaveAlert.Header = changeSaveAlert.Body.add( 'statictext', un, "Save changes to previous file(s)?\n\n"+filesList, {multiline:true});
            changeSaveAlert.Header.preferredSize = [240, lastViewedThumb.length*20+40];
            changeSaveAlert.Header.justify = 'left';
            changeSaveAlert.footerButtons = changeSaveAlert.add( 'group', un, un );
            changeSaveAlert.save = changeSaveAlert.footerButtons.add( 'button', un, "Yes" );
            changeSaveAlert.save.onClick = function(){  
            writeXMP();
            changeSaveAlert.hide();
            changeSaveAlert.close();
            displayXMP();
            } 
            changeSaveAlert.no = changeSaveAlert.footerButtons.add( 'button', un, "No" );
            changeSaveAlert.no.onClick = function(){  
                changeSaveAlert.hide();
                changeSaveAlert.close();
                saveLastViewedThumb = true;
                displayXMP();
                save1.enabled = false;
                footerButtons.save.enabled = false;            
                }
            changeSaveAlert.show();
            changeSaveAlert.active = true;
            }
		else{
              checkFileType();
			displayXMP();
            save1.enabled = false;
                footerButtons.save.enabled = false;
			}
        } 
        // todo needed?
            return { 
            handled:false
            }
    }

//? add listener for every dropdown list?  use a loop?
function saveEnabled(){
    save1.enabled = true;
	 footerButtons.save.enabled = true;
     save1.text = "Save";
	 footerButtons.save.text = "Save";
	}  

// Cancel button function          
winIptcChPnl.onClose = function(event){
    // remove our thumbnail selectionsChanged event handler so it does not add repeat instances every time the script is run
    var indexOf = "thumbSelected";
     var i = app.eventHandlers.length;
        app.eventHandlers.splice((i-1), 1); 
        // write user prefs to local file	  
        var appDataPlgnSet = File (appDataFwdSlash + plgnPrefs + plgnOpt + plgnSet);
          appDataPlgnSet.open ("w", "TEXT", "ttxt");
          appDataPlgnSet.write (multiAoWinDontVal + "\t");
          appDataPlgnSet.write (footerButtonsMultiAoWin.value + "\t");
          appDataPlgnSet.write (headSeparator + "\t");
          appDataPlgnSet.write (descSeparator + "\t");
          appDataPlgnSet.write (iLocCd2.value + "\t");
          appDataPlgnSet.write (iLocCd3.value);
          appDataPlgnSet.close();
        }

function hideAll(){
	selectFilePanel.visible = false
    }

// navigation toggle
var navBtnsArr = [aoBtn,imgBtn,imgRightsBtn,adminBtn]
var navBtnsTextArr = ["ARTWORK/OBJECT","IMAGE DESCRIPTION","IMAGE RIGHTS","IMAGE ADMIN"]
var fieldColArr = [aoPnl,imgPnl,imgRtsPnl,adminPnl]
function toggleNavBtns(){
    try{
	for (var L1 = 0; L1 < navBtnsTextArr.length; L1++){
		if(this.text == navBtnsTextArr[L1] || lastViewedPanel == navBtnsTextArr[L1]){
            fieldColArr[L1].visible = true
            navBtnsArr[L1].text = navBtnsIndentArr[L1]+navBtnsTextArr[L1]+rightArrow
            navBtnsArr[L1].alignment = 'right'	
			}
		else{
            fieldColArr[L1].visible = false
            navBtnsArr[L1].text = navBtnsTextArr[L1]
            navBtnsArr[L1].alignment = 'left'
            }
        }
      }
    catch(e){}
	lastViewedPanel = this.text
	winIptcChPnl.layout.layout (true)
	}

function updateImageHeadline(){
    var count = 0;
    var details = [iHeadlineEdit.text,wCreator1Name.text,wTitle1.text,];
    var fields = [iHeadlineEdit.text,wCreator1Name.text,wTitle1.text,];
    for(var i = 0; i<fields.length; i++){
        if (fields[i] == multi){
            count++
        }					
    }
    if (count == 0){
        for (var L1 = 0; L1 < details.length; L1++){
		if(details[L1] == ""){
			details.splice(L1, 1); L1--;
			}
		}
   iHeadlineEdit.text = details.join(headSeparator);
        }
    }

function updateImageDescription(){
    var count = 0;
    var wDateFill = "";
    if(wDateCirca.text){
        wDateFill = wDateCirca.text;
        }
    else{
         wDateFill = wDate.text;
        }
    var details = [iDescEdit.text,wCreator1Name.text,wCreator2Name.text,wCreator3Name.text,wTitle1.text,wDateFill,wStylePeriod.text,wPyhsDesc.text,wContrib.text,wSourceName.text,wSourceInvNum.text,wCopyNotice.text,wContentDesc.text];
    var fields = [iDescEdit.text,wCreator1Name.text,wCreator2Name.text,wCreator3Name.text,wTitle1.text,wDateFill,wStylePeriod.text,wPyhsDesc.text,wContrib.text,wSourceName.text,wSourceInvNum.text,wCopyNotice.text,wContentDesc.text];
    for(var i = 0; i<fields.length; i++){
        if (fields[i] == multi){
            count++
        }					
    }
    if (count == 0){
        for (var L1 = 0; L1 < details.length; L1++){
		if(details[L1] == ""){
			details.splice(L1, 1); L1--;
			}
		}
   iDescEdit.text = details.join(descSeparator);
        }
    }

function updateImageKeywords(){
    var count = 0;
    var details = [iKeywEdit.text,wCreator1Name.text,wCreator2Name.text,wCreator3Name.text,wStylePeriod.text];
    var fields = [iKeywEdit.text,wCreator1Name.text,wCreator2Name.text,wCreator3Name.text,wStylePeriod.text];
    for(var i = 0; i<fields.length; i++){
        if (fields[i] == multi){
            count++
        }					
    }
    if (count == 0){
        for (var L1 = 0; L1 < details.length; L1++){
		if(details[L1] == ""){
			details.splice(L1, 1); L1--;
			}
		}
   iKeywEdit.text = details.join("; ");
        }
    }

////////////////////////// BEGIN EVENT HANDLERS ////////////////////////////////  
// when thumbnail selected, refresh data values
app.eventHandlers.push( {handler: thumbSelected} );
//vocabWin.addEventListener('mousedown',function(){vocabWin.enabled = true;vocabWin.active = true;vocabWin.layout.layout (true);});
// when a field is changed, the Save button becomes enabled
winIptcChPnl.addEventListener('changing',function(){saveEnabled()});
// validate artwork creaded date
wDate.addEventListener('blur',function(){
	if (wDate.text && wDate.text.length < 4){
	var dateRegex = /^\d{4}$/;
	if(!(dateRegex.test(wDate.text))){
		alert("Date must be YYYY.  e.g., 0001 or 2015\n\n Use 'Circa Date Created' for free text date statements")
		}
	}   
	if (wDate.text.length > 4 && wDate.text.length < 8){
		var dateRegex = /^\d{4}\-(0[1-9]|1[0-2])$/;
		if(!(dateRegex.test(wDate.text))){
			alert("Date must be YYYY-MM.  e.g., 1776-07 or 2015-05\n\n Use 'Circa Date Created' for free text date statements")
			}
		}
	if (wDate.text.length > 7){
		var dateRegex = /^\d{4}\-(0[1-9]|1[0-2])\-(0[1-9]|1\d|2\d|3[01])$/;
		if(!(dateRegex.test(wDate.text))){
			alert("Date must be YYYY-MM-DD.  e.g., 1776-07-04 or 2015-05-29\n\n Use 'Circa Date Created' for free text date statements")
			}
		}
	})
// validate image created date
iDateCreated.addEventListener('blur',function(){
	if (iDateCreated.text && iDateCreated.text.length < 4){
	var dateRegex = /^\d{4}$/;
	if(!(dateRegex.test(iDateCreated.text))){
		alert("Date must be YYYY")
		}
	}   
	if (iDateCreated.text.length > 4 && iDateCreated.text.length < 8){
		var dateRegex = /^\d{4}\-(0[1-9]|1[0-2])$/;
		if(!(dateRegex.test(iDateCreated.text))){
			alert("Date must be YYYY-MM.  e.g., 2015-05")
			}
		}
	if (iDateCreated.text.length > 7){
        // leave only 10 chars
        var noTime = iDateCreated.text.substring(0, 10);
		var dateRegex = /^\d{4}\-(0[1-9]|1[0-2])\-(0[1-9]|1\d|2\d|3[01])$/;
		if(!(dateRegex.test(noTime))){
			alert("Date must be YYYY-MM-DD.  e.g., 2015-05-29")
			}
		}
	})

 function toggleIsoCC (Q,U,V,W){
 var S2 = '';
 var S3 = '';
 var T2 = '';
 var T3 = '';
 if (U.text.length > 0){       
     for (var Q1 = 0; Q1 < IPTCxLand.length; Q1++){
         if (U.text.toLowerCase() == IPTCxLand[Q1].toLowerCase()){
             var S2 = IPTCxIso2[Q1];
             var S3 = IPTCxIso3[Q1];
             var Q1 = IPTCxLand.length;
             }
         }
     }
 if (V.text.length > 0){
     for (var Q2 = 0; Q2 < IPTCxLand.length; Q2++){
         if (V.text == IPTCxIso2[Q2] || V.text == IPTCxIso3[Q2]){
             var T2 = IPTCxIso2[Q2];
             var T3 = IPTCxIso3[Q2];
             var Q2 = IPTCxLand.length;
             }
         }
     }
 if (S2.length > 0 && S3.length > 0 && T2.length > 0 && T3.length > 0 && S2 != T2 && S3 != T3){
     if (W == 2) var X = S2;
     if (W == 3) var X = S3;
     if (Q == 1) app.beep();
     var Z = Window.confirm ("ERROR: \nCountry Code is not correct!" + spaces8 + "\nDo you want to change it? \n" + spot + '  ' + U.text + '  =  ' + X + separator1 + "\nClick 'YES' to Accept. \nClick 'NO' to Delete.", false, paletteName);
     if (Z == true) V.text = X;
     else V.text = '';
     }
 else {
     if (T2.length > 0 && T3.length > 0){
         if (W == 2) V.text = T2;
         if (W == 3) V.text = T3;
         }
         else {
             if (W == 2 && S2.length > 0) V.text = S2;
             if (W == 3 && S3.length > 0) V.text = S3;
             }
         }
     }
////////////////////////// END FUNCTIONS ////////////////////////////////  
////////////////////////// BEGIN EVENT HANDLERS ////////////////////////////////  
iDigSrcType.addEventListener('mousedown',function(){saveEnabled()});
iPropRelStatus.addEventListener('mousedown',function(){saveEnabled()});

fillHeadDelim.addEventListener('change', function(){
    headSeparator = fillHeadDelim.selection.text
    fillHeadDelimEx.text = "Palazzo della Ragione"+headSeparator+"Frontal view of the north elevation"
    })

fillDescDelim.addEventListener('change', function(){
    descSeparator = fillDescDelim.selection.text
    fillDescDelimEx.text = "Andrea Palladio"+descSeparator+"Palazzo della Ragione"+descSeparator+"1548-1617"+descSeparator+"Vicenza, Veneto, Italy"
    })
////////////////////////// END EVENT HANDLERS ////////////////////////////////  
//////////////// BEGIN READ XMP FUNCTION //////////////
// check to see if selected thumbnail(s) are supported file types
function checkFileType(){
    var filename = app.document.selections//.toLowerCase()
 //   var re = /.ai|.dng|.gif|.jpg|.jpeg|.png|.psd|.tif|.tiff|.CR2/i
    allowedFiles = 0;
    for (var L1 = 0; L1 < filename.length; L1++){
        if (re.test(filename[L1].name.toLowerCase()) == true){
            allowedFiles++;       
            }
        }
	}

// Get the XMP data and display it in the form
function displayXMP(){
	var thumb = app.document.selections;
    
	app.synchronousMode = true;
	// if lastViewedPanel has no value, usually when the panel is first opened, set the value to artwork/object
	if (lastViewedPanel == ""){
		 lastViewedPanel = "ARTWORK/OBJECT"
		 toggleNavBtns()
		}

 // if no thumnails(s) are seletected or not allowed file types are selected, show alert
 if (thumb == 0 || allowedFiles == 0){
  // hideAll();
	selectFilePanel.visible = true
	winIptcChPnl.layout.layout (true)
    }
// if one or more thumnails(s) are seletected and at least one file is of the allowed type, display the last viewed panel and read the data
else{
   selectFilePanel.visible = false
    //  display the last viewed panel
    toggleNavBtns
    winIptcChPnl.enabled = true
    winIptcChPnl.layout.layout (true)
    }
// read and write vraiables
var multiTest = ""	
var val = ""
lastViewedThumb = []
// read/write flat text fields
var flatTextInputNS = [NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,XMPConst.NS_PHOTOSHOP,XMPConst.NS_PHOTOSHOP,XMPConst.NS_PHOTOSHOP,XMPConst.NS_PHOTOSHOP,XMPConst.NS_PHOTOSHOP,XMPConst.NS_PHOTOSHOP,NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,NS_PLUS,NS_PLUS,NS_PLUS,NS_PLUS,NS_PLUS,NS_PLUS,NS_PLUS,NS_PLUS,NS_PLUS,NS_PLUS,NS_PLUS,NS_PLUS,NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT];

var flatTextInputPath = ["ArtworkOrObject[1]/Iptc4xmpExt:AOCreator[1]","ArtworkOrObject[1]/Iptc4xmpExt:AOCreatorId[1]","ArtworkOrObject[1]/Iptc4xmpExt:AOCreator[2]","ArtworkOrObject[1]/Iptc4xmpExt:AOCreatorId[2]","ArtworkOrObject[1]/Iptc4xmpExt:AOCreator[3]","ArtworkOrObject[1]/Iptc4xmpExt:AOCreatorId[3]","ArtworkOrObject[1]/Iptc4xmpExt:AODateCreated","ArtworkOrObject[1]/Iptc4xmpExt:AOCircaDateCreated","ArtworkOrObject[1]/Iptc4xmpExt:AOSource","ArtworkOrObject[1]/Iptc4xmpExt:AOSourceInvNo","ArtworkOrObject[1]/Iptc4xmpExt:AOSourceInvURL","ArtworkOrObject[1]/Iptc4xmpExt:AOCopyrightNotice","ArtworkOrObject[1]/Iptc4xmpExt:AOCurrentCopyrightOwnerName","ArtworkOrObject[1]/Iptc4xmpExt:AOCurrentCopyrightOwnerId","ArtworkOrObject[1]/Iptc4xmpExt:AOCurrentLicensorName","ArtworkOrObject[1]/Iptc4xmpExt:AOCurrentLicensorId","AuthorsPosition","DateCreated","Source","Credit","Headline","Instructions","LocationShown[1]/Iptc4xmpExt:Sublocation","LocationShown[1]/Iptc4xmpExt:City","LocationShown[1]/Iptc4xmpExt:ProvinceState","LocationShown[1]/Iptc4xmpExt:CountryName","LocationShown[1]/Iptc4xmpExt:CountryCode","LocationShown[1]/Iptc4xmpExt:WorldRegion","CopyrightOwner[1]/"+plusPrefix+"CopyrightOwnerName","CopyrightOwner[1]/"+plusPrefix+"CopyrightOwnerID","ImageSupplier[1]/"+plusPrefix+"ImageSupplierName","ImageSupplier[1]/"+plusPrefix+"ImageSupplierID","ImageSupplierImageID","PropertyReleaseID[1]","Licensor[1]/"+plusPrefix+"LicensorName","Licensor[1]/"+plusPrefix+"LicensorID","Licensor[1]/"+plusPrefix+"LicensorTelephone1","Licensor[1]/"+plusPrefix+"LicensorTelephone2","Licensor[1]/"+plusPrefix+"LicensorEmail","Licensor[1]/"+plusPrefix+"LicensorURL","RegistryId[1]/Iptc4xmpExt:RegOrgId","RegistryId[1]/Iptc4xmpExt:RegItemId","MaxAvailWidth","MaxAvailHeight"];

var flatTextInput = [wCreator1Name,wCreator1id,wCreator2Name,wCreator2id,wCreator3Name,wCreator3id,wDate,wDateCirca,wSourceName,wSourceInvNum,wSourceInvUrl,wCopyNotice,wCurrCROName,wCurrCRONameId,wCurrLicName,wCurrLicNameId,iCreatorJob,iDateCreated,iCreditLn,iCreditLn,iHeadlineEdit,iInstruct,iLocDisplaySubEdit,iLocDisplayCityEdit,iLocDisplayCityStProvEdit,iLocDisplayContryNmEdit,iLocDisplayContryCdEdit,iLocDisplayWorlRegEdit,iCopyrOwnerName,iCopyrOwnerId,iSupplierName,iSupplierID,iSupplierImageID,iPropRelID,iLicensorName,iLicensorID,iLicensorTel1,iLicensorTel2,iLicensorEmail,iLicensorWeb,iRegistryOrgId,iRegistryImageID,iMaxWidth,iMaxHeight];

// read/write array text fields
var arrayTextInputNS = [NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,NS_IPTC_EXT,XMPConst.NS_DC,XMPConst.NS_XMP_RIGHTS,XMPConst.NS_DC,XMPConst.NS_DC,XMPConst.NS_DC,XMPConst.NS_DC];
var arrayTextInputPath = ["ArtworkOrObject[1]/Iptc4xmpExt:AOTitle","ArtworkOrObject[1]/Iptc4xmpExt:AOStylePeriod","ArtworkOrObject[1]/Iptc4xmpExt:AOContributionDescription","ArtworkOrObject[1]/Iptc4xmpExt:AOPhysicalDescription","ArtworkOrObject[1]/Iptc4xmpExt:AOContentDescription","title","UsageTerms","rights","description","creator","subject"];
var arrayTextInput = [wTitle1,wStylePeriod,wContrib,wPyhsDesc,wContentDesc,iTitle,iRightsUsageT,iCRnotice,iDescEdit,iCreator1,iKeywEdit];
multiTestArr = [];
multiTestArr2 = [];
multiTestArr3 = [];

	{     
		for (var L1 = 0; L1 < thumb.length; L1++){
		// try to open file. if it fails, save file path in error log
		 try{
			if (thumb[L1].hasMetadata){      
                // save file names in an array in case they are needed for save alert function
                lastViewedThumb.push(thumb[L1].name);
				// Get the selected file
                var selectedFile = thumb[L1].spec;
                var imageFileName = thumb[L1].name.toString()  
                var splicePathIndex = imageFileName.lastIndexOf (".")
                var extensionOnly = imageFileName.slice(splicePathIndex+1)
                var isRawFile = false
                for (var L1b = 0; L1b < rawFileTypesArr.length; L1b++){
                    if(extensionOnly.toLowerCase() == rawFileTypesArr[L1b]){   
                        isRawFile = true
                        }
                    }  
                // if file is RAW - read the sidecar  directly to an XMPMeta Object
                        if(isRawFile == true){
					var xmpFile = File(selectedFile.fsName.split(extensionOnly).join("xmp")); 
if (xmpFile.exists == true){
	xmpFile.open('r')
	xmpFile.encoding = "UTF8";	
	var xmpData = new XMPMeta(xmpFile.read()); 									
	xmpFile.close() 
	}
else{
// todo: clear the form?
	 }                                    
                            }
                    else{
                        // if file is not an .xmp sidecar pull XMP from file
                        var xmpFile = new XMPFile(selectedFile.fsName, XMPConst.UNKNOWN, XMPConst.OPEN_FOR_READ);
						xmpFile.encoding = "UTF8 BOM";
                        // convert to xmp
                        var xmpData = xmpFile.getXMP();
                        }
// reset multi labels
iLocDisplayGroupLabel.text = "Location"
iCopyrOwnerGroupLabel.text = "Copyright Owner"
iSupplierGroupLabel.text = "Supplier"
iLicensorGroupLabel.text = "Licensor"

// Check for more too many values to show here!!        
if(footerButtonsMultiAoWinVal == true){
var countAO = xmpData.countArrayItems(NS_IPTC_EXT,"ArtworkOrObject")
var countLocCre = xmpData.countArrayItems(NS_IPTC_EXT,"LocationCreated")
var countLocSho = xmpData.countArrayItems(NS_IPTC_EXT,"LocationShown")
var countPlusCo = xmpData.countArrayItems(NS_PLUS,"CopyrightOwner")
var countPlusIs = xmpData.countArrayItems(NS_PLUS,"ImageSupplier")
var countPlusL = xmpData.countArrayItems(NS_PLUS,"Licensor")
if(countAO > 1 || countLocCre > 1 || countLocSho > 1 || countPlusCo > 1 || countPlusIs > 1 || countPlusL > 1){
multiAoWin = new Window("palette", "There's more metadata than you can edit here");
multiAoWin.preferredSize = [500,300]
multiAoWin.alignChildren = ['fill', 'fill'];
multiAoWin.spacing = 0
if(countAO > 1 ){
      aoPnl.text = "ARTWORK/OBJECT 1 of "+countAO
    multiAoWinText1val = "There are "+countAO+" Artwork/Objects described in the metadata.\nThis panel only allows you to edit the first one."
    multiAoWinText1 = multiAoWin.add( 'statictext', un, multiAoWinText1val,{multiline:true});
    var countAOCre = xmpData.countArrayItems(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOCreator")
if(countAOCre > 3){
      wCreator3label.text = "Creator 3+"
      multiAoWinText2val = "There are "+countAOCre+" Artwork/Object Creators in the metadata.\nThis panel only allows you to edit the first 3."
      multiAoWinText2 = multiAoWin.add( 'statictext', un, multiAoWinText2val,{multiline:true});
      } 
    } // END if(countAO > 1 )
  if(countLocCre > 0){
    iLocDisplayGroupLabel.text = "Location 1 of "+countLocCre
    multiLocCreText1 = multiAoWin.add( 'statictext', un, "There is a Location Created described in the metadata.\nThis panel does not allow you to view or edit it.",{multiline:true});
    }
  if(countLocSho > 1){
    iLocDisplayGroupLabel.text = "Location 1 of "+countLocSho
      multiLocShoText1 = multiAoWin.add( 'statictext', un, "There are "+countLocSho+" Location Shown described in the metadata.\nThis panel only allows you to edit the first one.",{multiline:true});
    }
  if(countPlusCo > 1){
    iCopyrOwnerGroupLabel.text = "Copyright Owner 1 of "+countPlusCo
    multiPlusCoText1 = multiAoWin.add( 'statictext', un, "There are "+countPlusCo+" Image Copyright owners described in the metadata.\nThis panel only allows you to edit the first one.",{multiline:true});
    }
  if(countPlusIs > 1){
    iSupplierGroupLabel.text = "Supplier 1 of "+countPlusIs
    multiPlusIsText1 = multiAoWin.add( 'statictext', un, "There are "+countPlusIs+" Image Supplier owners described in the metadata.\nThis panel only allows you to edit the first one.",{multiline:true});   
    }
  if(countPlusL > 1){
    iLicensorGroupLabel.text = "Licensor 1 of "+countPlusL
    multiPlusLText1 = multiAoWin.add( 'statictext', un, "There are "+countPlusL+" Image Licensors described in the metadata.\nThis panel only allows you to edit the first one.",{multiline:true});
    }
multiAoWinDont = multiAoWin.add('checkbox', un, "Don't show this warning again")
multiAoWinDont.onClick = function(){
    if(multiAoWinDont.value == true){
        footerButtonsMultiAoWin.value = false
        footerButtonsMultiAoWinVal = false
        }
    else{
        footerButtonsMultiAoWin.value = true
        footerButtonsMultiAoWinVal = true
        }
    }
multiAoWinSpcr1 = multiAoWin.add( 'statictext', un,"")
multiAoWinSpcr1.preferredSize = [0,20]
multiAoWinClose = multiAoWin.add('button', un, "Close")
multiAoWinClose.maximumSize = [100,22];
multiAoWinClose.onClick = function(){multiAoWin.hide(); multiAoWin.close();}
  multiAoWin.show()
  }
} //  END if(multiAoWinDontVal == false)                                  
		// display flat text input fields			
				for (var L2 = 0; L2 < flatTextInput.length; L2++){
					try{ 
						var prop = xmpData.getProperty(flatTextInputNS[L2], flatTextInputPath[L2]);
						}
					catch(e){};
					if (prop == un) var val = "";
					else var val = prop.toString();  
					if (L1 == 0){
						flatTextInput[L2].text = val;
						multiTestArr[L2] = val;
						}
					else if (val != multiTestArr[L2]){
  
						flatTextInput[L2].text = multi;
						}   
					} // end display flat text input fields	
			// display array fields			
				for (var L6 = 0; L6 < arrayTextInput.length; L6++){
					try{ 
						var count = xmpData.countArrayItems(arrayTextInputNS[L6],arrayTextInputPath[L6]);		
						var arString = "";
						for(var a = 1;a <= count;a++)
						try{
							arString += xmpData.getArrayItem(arrayTextInputNS[L6],arrayTextInputPath[L6], a);
							if(a < count) arString += "; ";
							}
						catch(x){
							var arString = "";
							}						
						arString.split("\n").join("; ").split("\r").join("; ").split("\t").join("; ")
						}
					catch(e){};
					if (count == 0) var val = "";
					else if(arString){
                        var val = arString;
                        }  
					if (L1 == 0){
						arrayTextInput[L6].text = val;
						multiTestArr2[L6] = val;
						}
					else if (val != multiTestArr2[L6]){
						arrayTextInput[L6].text = multi;
						}  
					} // end display array fields
               // read AO date and trim time
               wDate.text = wDate.text.substring(0,10);
				// read "plus:PropertyReleaseStatus"
				try{ 
					var prop = xmpData.getProperty(NS_PLUS,"PropertyReleaseStatus");
					}
				catch(e){};  
					if (prop == un) var val = "";
					else var val = prop.toString();  
					if (L1 == 0){
						multiTestArr3[L2] = val;
						if (prop == un) iPropRelStatus.selection = 0;
						if (prop == "http://ns.useplus.org/ldf/vocab/PR-NON") iPropRelStatus.selection = 1;
						if (prop == "http://ns.useplus.org/ldf/vocab/PR-NAP") iPropRelStatus.selection = 2;
						if (prop == "http://ns.useplus.org/ldf/vocab/PR-UPR") iPropRelStatus.selection = 3;
						if (prop == "http://ns.useplus.org/ldf/vocab/PR-LPR") iPropRelStatus.selection = 4;					
						}
					else if (val != multiTestArr3[L2]){
						iPropRelStatus.selection = 7;
						} 				
				// read "xmpRights:Marked"
				try{ 
					var prop = xmpData.getProperty(NS_IPTC_EXT,"DigitalSourceType");
					}
				catch(e){};
				if (prop == un) var val = "";
					else var val = prop.toString();  
					if (L1 == 0){
						multiTestArr[L2] = val;
				if (prop == un) iDigSrcType.selection = 0;
				if (prop == "http://cv.iptc.org/newscodes/digitalsourcetype/digitalCapture") iDigSrcType.selection = 1;
				if (prop == "http://cv.iptc.org/newscodes/digitalsourcetype/negativeFilm") iDigSrcType.selection = 2;
				if (prop == "http://cv.iptc.org/newscodes/digitalsourcetype/positiveFilm") iDigSrcType.selection = 3;
				if (prop == "http://cv.iptc.org/newscodes/digitalsourcetype/print") iDigSrcType.selection = 4;
				if (prop == "http://cv.iptc.org/newscodes/digitalsourcetype/softwareImage") iDigSrcType.selection = 5;	
					}
					else if (val != multiTestArr[L2]){
						iDigSrcType.selection = 8;
						} 
          // if there is no ext loc shown data but there is core loc data, display it in loc fields
          var locDispArr = [iLocDisplaySubEdit,iLocDisplayCityEdit,iLocDisplayCityStProvEdit,iLocDisplayContryNmEdit,iLocDisplayContryCdEdit,iLocDisplayWorlRegEdit]   
          var locsArr = [{ns:XMPConst.NS_IPTC_CORE, path:"Location", field:iLocDisplaySubEdit},{ns:XMPConst.NS_PHOTOSHOP, path:"City", field:iLocDisplayCityEdit},{ns:XMPConst.NS_PHOTOSHOP, path:"State", field:iLocDisplayCityStProvEdit},{ns:XMPConst.NS_PHOTOSHOP, path:"Country", field:iLocDisplayContryNmEdit},{ns:XMPConst.NS_IPTC_CORE, path:"CountryCode", field:iLocDisplayContryCdEdit}]
          var locHasData = false
          
        for (var locL1 = 0; locL1 < locDispArr.length; locL1++){
      if(locDispArr[locL1].text){
        locHasData = true
        }
      }
		if(locHasData == false){ // if no loc shown, try core loc
      for (var L2 = 0; L2 < locsArr.length; L2++){
        try{
        var prop = xmpData.getProperty(locsArr[L2].ns,locsArr[L2].path)
        }
    catch(e){};
        if (prop == un){ var val = "";}
        else{ var val = prop.toString();  
	locsArr[L2].field.text = val;}
        }
      } // END if(locHasData == false)
    // set loc code to 2 or 3 based on XMP value
      if(iLocDisplayContryCdEdit.text.length == 2){
        iLocCd2.value = true
        }
      else{
         iLocCd3.value = true
        }
			} // end if (thumb[L1].hasMetadata){
        } // end Try
catch(couldNotOpenError){}
		} // end for (var L6 = 0; L6 < arrayTextInput.length; L6++)
	}
} // end of function displayXMP()

//////////// BEGIN XMP WRITE FUNCTION
// when "Save" button is clicked, write data to XMP
// this works off the lastViewedThumb rather than the selectedThumbnails.  this allows the Save changes alert to save to the previously selected thumbnail if "Yes" is clicked
function writeXMP(){	
    save1.enabled = false;
   footerButtons.save.enabled = false;
   var wThumb = app.document.visibleThumbnails;
    app.synchronousMode = true; 
	// progress bar
   var progBar = new Window ("palette {text: '(Saving CSU Metadata)', bounds: [0,0,500,20], X: Progressbar {bounds: [0,0,500,20]}};");  
   var eachLastViewedThumb = "";
   propFailArr = [];
	for (var L1 = 0; L1 < wThumb.length; L1++){        
        for (var L1a = 0; L1a < lastViewedThumb.length; L1a++){		 
        if (wThumb[L1].name == lastViewedThumb[L1a]){
        if ( wThumb.length > 10){
             progBar.X.value = Math.round ((L1 / wThumb.length) * 100); 
              progBar.center();
              progBar.show();
            }			
          if (wThumb[L1].hasMetadata){
			var imageFile = wThumb[L1].spec;             
			var imageFileName = wThumb[L1].name.toString()     
			var nameOnly =  imageFileName.slice(0, imageFileName.indexOf("."));
			var splicePathIndex = imageFileName.lastIndexOf (".")
			var extensionOnly = imageFileName.slice(splicePathIndex+1)
			isRawFile = false
			for (var L1b = 0; L1b < rawFileTypesArr.length; L1b++){
				if(extensionOnly.toLowerCase() == rawFileTypesArr[L1b]){   
					isRawFile = true
					}
				}
    // if file is RAW - read the sidecar  directly to an XMPMeta Object
    if(isRawFile == true){
             var xmpFile = File(imageFile.fsName.split(extensionOnly).join("xmp"))        
			if (xmpFile.exists == true){  // if an XMP file already exists             
				xmpFile.open('r')
				xmpFile.encoding = "UTF8";	
				var xmpData = new XMPMeta(xmpFile.read()); 									
				xmpFile.close()           
				}
    else{     // if an XMP file does not already exist   
        // create new XMP file
        var thumb = new Thumbnail(wThumb[L1]);//make a new thumbnail for file  
        var xmpData = new XMPMeta(thumb.synchronousMetadata.serialize());// make an XMP object from thumb metadata  
        }
    }
    	
        if(isRawFile == false){		
            // if file is not an .xmp sidecar pull XMP from file
            var xmpFile = new XMPFile(imageFile.fsName, XMPConst.UNKNOWN, XMPConst.OPEN_FOR_READ);
            // convert to xmp
            var xmpData = xmpFile.getXMP();
            }
	// create arrays if they don't exist
		var countIptcAO = xmpData.countArrayItems(NS_IPTC_EXT,"ArtworkOrObject");	
			if(countIptcAO==0){				
				xmpData.appendArrayItem(NS_IPTC_EXT,"ArtworkOrObject", "", 0, XMPConst.ARRAY_IS_UNORDERED);
				xmpData.setProperty (NS_IPTC_EXT,"ArtworkOrObject[1]", "", XMPConst.PROP_IS_STRUCT);							
				}
		var countIptcAOCrea = xmpData.countArrayItems(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOCreator");	
			if(countIptcAOCrea==0){				
				xmpData.appendArrayItem(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOCreator", "", 0, XMPConst.ARRAY_IS_ORDERED);
				}
            var countIptcAOCrea = xmpData.countArrayItems(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOCreatorId");	
			if(countIptcAOCrea==0){				
				xmpData.appendArrayItem(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOCreatorId", "", 0, XMPConst.ARRAY_IS_ORDERED);
				}
		var countIptcLocCr = xmpData.countArrayItems(NS_IPTC_EXT,"LocationCreated");	
			if(countIptcLocCr==0){				
				xmpData.appendArrayItem(NS_IPTC_EXT,"LocationCreated", "", 0, XMPConst.ARRAY_IS_UNORDERED);
				xmpData.setProperty (NS_IPTC_EXT,"LocationCreated[1]", "", XMPConst.PROP_IS_STRUCT);							
				}
		var countIptcLocSh = xmpData.countArrayItems(NS_IPTC_EXT,"LocationShown");	
			if(countIptcLocSh==0){				
				xmpData.appendArrayItem(NS_IPTC_EXT,"LocationShown", "", 0, XMPConst.ARRAY_IS_UNORDERED);
				xmpData.setProperty (NS_IPTC_EXT,"LocationShown[1]", "", XMPConst.PROP_IS_STRUCT);							
				}				
			var countIptcReg = xmpData.countArrayItems(NS_IPTC_EXT,"RegistryId");	
			if(countIptcReg==0){				
				xmpData.appendArrayItem(NS_IPTC_EXT,"RegistryId", "", 0, XMPConst.ARRAY_IS_UNORDERED);
				xmpData.setProperty (NS_IPTC_EXT,"RegistryId[1]", "", XMPConst.PROP_IS_STRUCT);							
				}	
			var countPlusCO = xmpData.countArrayItems(NS_PLUS, "CopyrightOwner");	
			if(countPlusCO==0){
				xmpData.appendArrayItem(NS_PLUS, "CopyrightOwner", "", 0, XMPConst.ARRAY_IS_ORDERED);
				xmpData.setProperty (NS_PLUS, "CopyrightOwner[1]", "", XMPConst.PROP_IS_STRUCT);
				}			
			var countPlusIS = xmpData.countArrayItems(NS_PLUS, "ImageSupplier");	
			if(countPlusIS==0){
				xmpData.appendArrayItem(NS_PLUS, "ImageSupplier", "", 0, XMPConst.ARRAY_IS_ORDERED);
				xmpData.setProperty (NS_PLUS, "ImageSupplier[1]", "", XMPConst.PROP_IS_STRUCT);
				}
			var countPlusLic = xmpData.countArrayItems(NS_PLUS, "Licensor");	
			if(countPlusLic==0){
				xmpData.appendArrayItem(NS_PLUS, "Licensor", "", 0, XMPConst.ARRAY_IS_ORDERED);
				xmpData.setProperty (NS_PLUS, "Licensor[1]", "", XMPConst.PROP_IS_STRUCT);
				}
			var countPlusLic = xmpData.countArrayItems(NS_PLUS, "PropertyReleaseID");	
			if(countPlusLic==0){
				xmpData.appendArrayItem(NS_PLUS, "PropertyReleaseID", "", 0, XMPConst.ARRAY_IS_UNORDERED);
				xmpData.setProperty (NS_PLUS, "PropertyReleaseID[1]", "");
				}
							
			// write flat text input fields to the xmp file		 
			function writeText (namespace,path,field){
			try{				
				if (field.text.length > 0 && field.text != multi){
						xmpData.setProperty (namespace, path, field.text);	
						
						}
					if (field.text.length == 0){
						xmpData.deleteProperty (namespace, path);
						}
				}
				catch(v){
                    propFailArr.push (field.text)
                    }              
				}
                // run writeText
                writeText (XMPConst.NS_PHOTOSHOP, "AuthorsPosition",iCreatorJob)
                writeText (XMPConst.NS_PHOTOSHOP, "DateCreated",iDateCreated);
                writeText (XMPConst.NS_PHOTOSHOP, "Credit",iCreditLn);
                writeText (XMPConst.NS_PHOTOSHOP, "Headline",iHeadlineEdit)
                writeText (XMPConst.NS_PHOTOSHOP, "Instructions",iInstruct)

                writeText(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOCreator[1]",wCreator1Name)	
                writeText(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOCreatorId[1]",wCreator1id)
                writeText(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOCreator[2]",wCreator2Name)
                writeText(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOCreatorId[2]",wCreator2id)
                writeText(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOCreator[3]",wCreator3Name)
                writeText(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOCreatorId[3]",wCreator3id)

                writeText(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AODateCreated",wDate)
                writeText(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOCircaDateCreated",wDateCirca)
                writeText(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOSource",wSourceName)
                writeText(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOSourceInvNo",wSourceInvNum)
                writeText(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOSourceInvURL",wSourceInvUrl)				
                writeText(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOCopyrightNotice",wCopyNotice)
                writeText(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOCurrentCopyrightOwnerName",wCurrCROName)
                writeText(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOCurrentCopyrightOwnerId",wCurrCRONameId)
                writeText(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOCurrentLicensorName",wCurrLicName)
                writeText(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOCurrentLicensorId",wCurrLicNameId)

                writeText(XMPConst.NS_IPTC_CORE,"Location",iLocDisplaySubEdit)
                writeText(XMPConst.NS_PHOTOSHOP,"City",iLocDisplayCityEdit)
                writeText(XMPConst.NS_PHOTOSHOP,"State",iLocDisplayCityStProvEdit)
                writeText(XMPConst.NS_PHOTOSHOP,"Country",iLocDisplayContryNmEdit)
                writeText(XMPConst.NS_IPTC_CORE,"CountryCode",iLocDisplayContryCdEdit)

                writeText(NS_IPTC_EXT,"LocationShown[1]/Iptc4xmpExt:Sublocation",iLocDisplaySubEdit)
                writeText(NS_IPTC_EXT,"LocationShown[1]/Iptc4xmpExt:City",iLocDisplayCityEdit)
                writeText(NS_IPTC_EXT,"LocationShown[1]/Iptc4xmpExt:ProvinceState",iLocDisplayCityStProvEdit)
                writeText(NS_IPTC_EXT,"LocationShown[1]/Iptc4xmpExt:CountryName",iLocDisplayContryNmEdit)
                writeText(NS_IPTC_EXT,"LocationShown[1]/Iptc4xmpExt:CountryCode",iLocDisplayContryCdEdit)
                writeText(NS_IPTC_EXT,"LocationShown[1]/Iptc4xmpExt:WorldRegion",iLocDisplayWorlRegEdit)

                writeText(NS_IPTC_EXT,"RegistryId[1]/Iptc4xmpExt:RegOrgId",iRegistryOrgId)
                writeText(NS_IPTC_EXT,"RegistryId[1]/Iptc4xmpExt:RegItemId",iRegistryImageID)
                writeText(NS_IPTC_EXT,"MaxAvailWidth",iMaxWidth)
                writeText(NS_IPTC_EXT,"MaxAvailHeight",iMaxHeight)

                writeText(NS_PLUS, "CopyrightOwner[1]/"+plusPrefix+"CopyrightOwnerName",iCopyrOwnerName)
                writeText(NS_PLUS, "CopyrightOwner[1]/"+plusPrefix+"CopyrightOwnerID",iCopyrOwnerId)
                writeText(NS_PLUS, "ImageSupplier[1]/"+plusPrefix+"ImageSupplierName",iSupplierName)
                writeText(NS_PLUS, "ImageSupplier[1]/"+plusPrefix+"ImageSupplierID",iSupplierID)	
                writeText(NS_PLUS, "ImageSupplierImageID",iSupplierImageID)
                writeText(NS_PLUS, "Licensor[1]/"+plusPrefix+"LicensorName",iLicensorName)
                writeText(NS_PLUS, "Licensor[1]/"+plusPrefix+"LicensorID",iLicensorID)
                writeText(NS_PLUS, "Licensor[1]/"+plusPrefix+"LicensorTelephone1",iLicensorTel1)
                writeText(NS_PLUS, "Licensor[1]/"+plusPrefix+"LicensorTelephone2",iLicensorTel2)
                writeText(NS_PLUS, "Licensor[1]/"+plusPrefix+"LicensorEmail",iLicensorEmail)
                writeText(NS_PLUS, "Licensor[1]/"+plusPrefix+"LicensorURL",iLicensorWeb)
                writeText(NS_PLUS, "PropertyReleaseID[1]",iPropRelID) // writes to bag
			
			// write text LangAlt array
			function writeLangAlt (namespace,path,field){
			try{   
					// run if there is data in the field and it is not "(Multiple Values)"
					if (field.text.length > 0 && field.text != multi){ 
						// delete the existing XMP data
						xmpData.deleteProperty (namespace, path);
						// write the new data as a Lang Alt array
						xmpData.appendArrayItem(namespace, path, field.text, 0, XMPConst.ALIAS_TO_ALT_TEXT);
						// set the lang array item to "x-default"
						xmpData.setQualifier (namespace, path + "[1]", NS_W3, "lang", "x-default");
						}
					// if the field is empty, delete the XMP data
					if (field.text.length == 0){
						xmpData.deleteProperty (namespace, path);
						}
					}
			catch(v){propFail++}  
			}
            // run writeLangAlt
            writeLangAlt(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOTitle",wTitle1)
            writeLangAlt(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOContributionDescription",wContrib)
            writeLangAlt(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOPhysicalDescription",wPyhsDesc)
            writeLangAlt(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOContentDescription",wContentDesc)
            writeLangAlt(XMPConst.NS_DC, "title",iTitle)
            writeLangAlt(XMPConst.NS_XMP_RIGHTS, "UsageTerms",iRightsUsageT)
            writeLangAlt(XMPConst.NS_DC, "rights",iCRnotice)
            writeLangAlt(XMPConst.NS_DC, "description",iDescEdit)
					
			// write text bag array
			function writeBagArray (namespace,path,field){
			try{
				if (field.text.length > 0 && field.text != multi){ 
						// delete the existing XMP data
					xmpData.deleteProperty (namespace, path);
                        var separatedBagItems = field.text.split('; ').join(';').split (';');
						// write the new data as a Bag array
						xmpData.appendArrayItem(namespace, path, "", 0, XMPConst.ARRAY_IS_UNORDERED);
                            for (var L4a = 1; L4a < (separatedBagItems.length + 1); L4a++){
                                 xmpData.setProperty (namespace, path+"[" + L4a + "]", separatedBagItems[L4a - 1]);
                                 }
						}
					// if the field is empty, delete the XMP data
					if (field.text.length == 0){
						xmpData.deleteProperty (bagNs[L4], path);
						}
					}
			catch(v){propFail++}
			}
		// run writeBagArray 
                    writeBagArray(NS_IPTC_EXT,"ArtworkOrObject[1]/Iptc4xmpExt:AOStylePeriod",wStylePeriod)
			writeBagArray(XMPConst.NS_DC, "subject",iKeywEdit)
			
		// write text seq array
		function writeSeqArray (namespace,path,field){
			try{
				if (field.text.length > 0 && field.text != multi){ 
						// delete the existing XMP data
						xmpData.deleteProperty (namespace, path);
                        var separatedSeqItems = field.text.split('; ').join(';').split (';');
						// write the new data as a Seq array
						xmpData.appendArrayItem(namespace, path, "", 0, XMPConst.ARRAY_IS_ORDERED);
                        for (var L5a = 1; L5a < (separatedSeqItems.length + 1); L5a++){
                                 xmpData.setProperty (namespace, path+"[" + L5a + "]", separatedSeqItems[L5a - 1]);
                                 }
                              }					
					// if the field is empty, delete the XMP data
					if (field.text.length == 0){
						xmpData.deleteProperty (namespace, path);
						}
					}
			catch(v){propFail++}
			}
		// run writeSeqArray
		writeSeqArray(XMPConst.NS_DC, "creator",iCreator1)
		
		// PropertyReleaseStatus
        var namespace = NS_PLUS
        var path = "PropertyReleaseStatus"
        var field = iPropRelStatus
        try{
            if (field.selection > 0 && field.selection != 7){ 
                    // delete the existing XMP data
                    xmpData.deleteProperty (namespace, path);
                    // set property value based on dropdown selected index
                var prop = ""
                if (field.selection ==1) prop = "http://ns.useplus.org/ldf/vocab/PR-NON"
                if (field.selection ==2) prop = "http://ns.useplus.org/ldf/vocab/PR-NAP"
                if (field.selection ==3) prop = "http://ns.useplus.org/ldf/vocab/PR-UPR"
                if (field.selection ==4) prop = "http://ns.useplus.org/ldf/vocab/PR-LPR"
                xmpData.setProperty (namespace, path, prop);					
                          }						
                // if the field is empty, delete the XMP data
                if (field.selection == 0){
                    xmpData.deleteProperty (namespace, path);
                    }
                }
			catch(v){propFail++}
			
		// DigitalSourceType
        var namespace = NS_IPTC_EXT
        var path = "DigitalSourceType"
        var field = iDigSrcType
        try{
            if (field.selection > 0 && field.selection != 7){ 
                    // delete the existing XMP data
                    xmpData.deleteProperty (namespace, path);
                    // set property value based on dropdown selected index
                var prop = ""
                if (field.selection ==1) prop = "http://cv.iptc.org/newscodes/digitalsourcetype/digitalCapture"
                if (field.selection ==2) prop = "http://cv.iptc.org/newscodes/digitalsourcetype/negativeFilm"
                if (field.selection ==3) prop = "http://cv.iptc.org/newscodes/digitalsourcetype/positiveFilm"
                if (field.selection ==4) prop = "http://cv.iptc.org/newscodes/digitalsourcetype/print"
                if (field.selection ==5) prop = "http://cv.iptc.org/newscodes/digitalsourcetype/softwareImage"
                xmpData.setProperty (namespace, path, prop);					
                          }						
                // if the field is empty, delete the XMP data
                if (field.selection == 0){
                    xmpData.deleteProperty (namespace, path);
                    }
                }
			catch(v){propFail++}	  

           // if an XMP file does not already exist   
               if(isRawFile == true && xmpFile.exists == false){
                   // here!
                   xmpStr = xmpData.serialize(XMPConst.SERIALIZE_USE_COMPACT_FORMAT);
                    // Create and open the file so it can recieve data
                    var sidecar = new File (xmpFile)                
                    sidecar.encoding = "UTF8";
                    sidecar.open ("w", "TEXT", "ttxt");   
                    // write XMP RDF/XML to sidecar file
                    sidecar.write (xmpStr);
                    // Close the file
                    sidecar.close();
                   }
                else{

                    // Write the packet back to the selected file(s)
                    wThumb[L1].metadata = new Metadata (xmpData.serialize (XMPConst.SERIALIZE_OMIT_PACKET_WRAPPER | XMPConst.SERIALIZE_USE_COMPACT_FORMAT)); 					
                    }
                }
                if(propFailArr.length == 0){
                    progBar.hide()
                    progBar.close()
                    save1.text = check+" Changes Saved"
                    footerButtons.save.text = check+" Changes Saved"
                    }
                else{
                    alert("There was a problem saving:\n"+propFailArr[0]);
                    }
                } 		                       
            }		
       }
        //////////// end of save XMP function
        }
        ////////////////////////// END OF FUNCTIONS //////////////////////////////// 
        checkFileType(); 
        displayXMP();
    }
} // close if (BridgeTalk.appName == "bridge"){
